--[[
-- Orca, a free and open-source Roblox script hub.
-- This script was generated by ci/bundle.lua, and is not intended to be modified.
-- To view the source code, see the 'src' folder on GitHub!
--
-- Author: 0866
-- License: MIT
-- Version: "1.1.0"
-- GitHub: https://github.com/richie0866/orca
--]]

-- Runtime module

---@class Module
---@field fn function
---@field isLoaded boolean
---@field value any

---@type table<string, Instance>
local instanceFromId = {}

---@type table<Instance, string>
local idFromInstance = {}

---@type table<Instance, Module>
local modules = {}

---Stores currently loading modules.
---@type table<LocalScript | ModuleScript, ModuleScript>
local currentlyLoading = {}

-- Module resolution

---@param module LocalScript | ModuleScript
---@param caller? LocalScript | ModuleScript
---@return function | nil cleanup
local function validateRequire(module, caller)
	currentlyLoading[caller] = module

	local currentModule = module
	local depth = 0

	-- If the module is loaded, requiring it will not cause a circular dependency.
	if not modules[module] then
		while currentModule do
			depth = depth + 1
			currentModule = currentlyLoading[currentModule]

			if currentModule == module then
				local str = currentModule.Name -- Get the string traceback

				for _ = 1, depth do
					currentModule = currentlyLoading[currentModule]
					str = str .. "  ⇒ " .. currentModule.Name
				end

				error("Failed to load '" .. module.Name .. "'; Detected a circular dependency chain: " .. str, 2)
			end
		end
	end

	return function ()
		if currentlyLoading[caller] == module then -- Thread-safe cleanup!
			currentlyLoading[caller] = nil
		end
	end
end

---@param obj LocalScript | ModuleScript
---@param this? LocalScript | ModuleScript
---@return any
local function loadModule(obj, this)
	local cleanup = this and validateRequire(obj, this)
	local module = modules[obj]

	if module.isLoaded then
		if cleanup then
			cleanup()
		end
		return module.value
	else
		local data = module.fn()
		module.value = data
		module.isLoaded = true
		if cleanup then
			cleanup()
		end
		return data
	end
end

---@param target ModuleScript
---@param this? LocalScript | ModuleScript
---@return any
local function requireModuleInternal(target, this)
	if modules[target] and target:IsA("ModuleScript") then
		return loadModule(target, this)
	else
		return require(target)
	end
end

-- Instance creation

---@param id string
---@return table<string, any> environment
local function newEnv(id)
	return setmetatable({
		VERSION = "1.1.0",
		script = instanceFromId[id],
		require = function (module)
			return requireModuleInternal(module, instanceFromId[id])
		end,
	}, {
		__index = getfenv(0),
		__metatable = "This metatable is locked",
	})
end

---@param name string
---@param className string
---@param path string
---@param parent string | nil
---@param fn function
local function newModule(name, className, path, parent, fn)
	local instance = Instance.new(className)
	instance.Name = name
	instance.Parent = instanceFromId[parent]

	instanceFromId[path] = instance
	idFromInstance[instance] = path

	modules[instance] = {
		fn = fn,
		isLoaded = false,
		value = nil,
	}
end

---@param name string
---@param className string
---@param path string
---@param parent string | nil
local function newInstance(name, className, path, parent)
	local instance = Instance.new(className)
	instance.Name = name
	instance.Parent = instanceFromId[parent]

	instanceFromId[path] = instance
	idFromInstance[instance] = path
end

-- Runtime

local function init()
	if not game:IsLoaded() then
		game.Loaded:Wait()
	end
	for object in pairs(modules) do
		if object:IsA("LocalScript") and not object.Disabled then
			task.spawn(loadModule, object)
		end
	end
end


newInstance("Orca","Folder","Orca",nil)newModule("App","ModuleScript","Orca.App","Orca",function()return setfenv(function()local a=require(script.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local c=a.import(script,script.Parent,"views","Dashboard").default;local d=7;local function e()return b.createElement("ScreenGui",{IgnoreGuiInset=true,ResetOnSpawn=false,ZIndexBehavior="Sibling",DisplayOrder=d},{b.createElement(c)})end;local f=e;return{default=f}end,newEnv("Orca.App"))()end)newInstance("components","Folder","Orca.components","Orca")newModule("Acrylic","ModuleScript","Orca.components.Acrylic","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Acrylic").default;return g end,newEnv("Orca.components.Acrylic"))()end)newModule("Acrylic","ModuleScript","Orca.components.Acrylic.Acrylic","Orca.components.Acrylic",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local j=h.useCallback;local k=h.useEffect;local l=h.useMemo;local m=h.useMutable;local n=a.import(script,a.getModule(script,"@rbxts","services")).Workspace;local o=a.import(script,script.Parent,"acrylic-instance").acrylicInstance;local p=a.import(script,script.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local q=a.import(script,script.Parent.Parent.Parent,"utils","number-util").map;local r=a.import(script,script.Parent.Parent.Parent,"utils","udim2").scale;local s=CFrame.Angles(0,math.rad(90),0)local function t(u,v)local w=n.CurrentCamera:ScreenPointToRay(u.X,u.Y)local x=w.Origin;local y=w.Direction*v;return x+y end;local function z()return q(n.CurrentCamera.ViewportSize.Y,0,2560,8,56)end;local A;local function B(C)local D=C.radius;local v=C.distance;local E=p(function(F)return F.options.config.acrylicBlur end)return E and b.createElement(A,{radius=D,distance=v})or b.createElement("Frame",{BackgroundTransparency=1})end;local f=i(B)local function G(C)local D=C.radius;if D==nil then D=0 end;local v=C.distance;if v==nil then v=0.001 end;local H=m({topleft2d=Vector2.new(),topright2d=Vector2.new(),bottomright2d=Vector2.new(),topleftradius2d=Vector2.new()})local I=l(function()local J=o:Clone()J.Parent=n;return J end,{})k(function()return function()return I:Destroy()end end,{})local K=j(function(L,M)local y=L/2;local N=M-y;local O=H.current;O.topleft2d=Vector2.new(math.ceil(N.X),math.ceil(N.Y))local P=O.topleft2d;local Q=Vector2.new(L.X,0)O.topright2d=P+Q;O.bottomright2d=O.topleft2d+L;local R=O.topleft2d;local S=Vector2.new(D,0)O.topleftradius2d=R+S end,{v,D})local T=j(function()local U=H.current;local V=U.topleft2d;local W=U.topright2d;local X=U.bottomright2d;local Y=U.topleftradius2d;local Z=t(V,v)local _=t(W,v)local a0=t(X,v)local a1=t(Y,v)local a2=(a1-Z).Magnitude;local a3=(_-Z).Magnitude;local a4=(_-a0).Magnitude;local a5=CFrame.fromMatrix((Z+a0)/2,n.CurrentCamera.CFrame.XVector,n.CurrentCamera.CFrame.YVector,n.CurrentCamera.CFrame.ZVector)if D~=nil and D>0 then I.Horizontal.CFrame=a5;I.Horizontal.Mesh.Scale=Vector3.new(a3-a2*2,a4,0)I.Vertical.CFrame=a5;I.Vertical.Mesh.Scale=Vector3.new(a3,a4-a2*2,0)else I.Horizontal.CFrame=a5;I.Horizontal.Mesh.Scale=Vector3.new(a3,a4,0)end;if D~=nil and D>0 then local a6=CFrame.new(-a3/2+a2,a4/2-a2,0)I.TopLeft.CFrame=a5*a6*s;I.TopLeft.Mesh.Scale=Vector3.new(0,a2*2,a2*2)local a7=CFrame.new(a3/2-a2,a4/2-a2,0)I.TopRight.CFrame=a5*a7*s;I.TopRight.Mesh.Scale=Vector3.new(0,a2*2,a2*2)local a8=CFrame.new(-a3/2+a2,-a4/2+a2,0)I.BottomLeft.CFrame=a5*a8*s;I.BottomLeft.Mesh.Scale=Vector3.new(0,a2*2,a2*2)local a9=CFrame.new(a3/2-a2,-a4/2+a2,0)I.BottomRight.CFrame=a5*a9*s;I.BottomRight.Mesh.Scale=Vector3.new(0,a2*2,a2*2)end end,{D,v})k(function()T()local aa=n.CurrentCamera:GetPropertyChangedSignal("CFrame"):Connect(T)local ab=n.CurrentCamera:GetPropertyChangedSignal("FieldOfView"):Connect(T)local ac=n.CurrentCamera:GetPropertyChangedSignal("ViewportSize"):Connect(T)return function()aa:Disconnect()ab:Disconnect()ac:Disconnect()end end,{T})return b.createElement("Frame",{[b.Change.AbsoluteSize]=function(ad)local ae=z()local af=ad.AbsoluteSize;local Q=Vector2.new(ae,ae)local L=af-Q;local ag=ad.AbsolutePosition;local y=ad.AbsoluteSize/2;local M=ag+y;K(L,M)task.spawn(T)end,[b.Change.AbsolutePosition]=function(ad)local ae=z()local af=ad.AbsoluteSize;local Q=Vector2.new(ae,ae)local L=af-Q;local ag=ad.AbsolutePosition;local y=ad.AbsoluteSize/2;local M=ag+y;K(L,M)task.spawn(T)end,Size=r(1,1),BackgroundTransparency=1})end;A=i(G)return{default=f}end,newEnv("Orca.components.Acrylic.Acrylic"))()end)newModule("Acrylic.story","ModuleScript","Orca.components.Acrylic.Acrylic.story","Orca.components.Acrylic",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local ah=a.import(script,a.getModule(script,"@rbxts","roact-rodux-hooked").out).Provider;local B=a.import(script,script.Parent,"Acrylic").default;local ai=a.import(script,script.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local aj=a.import(script,script.Parent.Parent.Parent,"store","store").configureStore;local ak=a.import(script,script.Parent.Parent.Parent,"utils","color3").hex;local al=a.import(script,script.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;return function(an)local ao=b.mount(b.createElement(ah,{store=aj({dashboard={isOpen=true,page=ai.Apps,hint=nil,apps={}}})},{b.createElement("Frame",{AnchorPoint=Vector2.new(0.5,0.5),Position=r(0.3,0.7),Size=am(250,350),BackgroundColor3=ak("#000000"),BackgroundTransparency=0.5,BorderSizePixel=0},{b.createElement("UICorner",{CornerRadius=UDim.new(0,64)}),b.createElement(B,{radius=52})})}),an,"Acrylic")return function()return b.unmount(ao)end end end,newEnv("Orca.components.Acrylic.Acrylic.story"))()end)newModule("acrylic-instance","ModuleScript","Orca.components.Acrylic.acrylic-instance","Orca.components.Acrylic",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ap=a.import(script,a.getModule(script,"@rbxts","make"))local aq={Color=Color3.new(0,0,0),Material=Enum.Material.Glass,Size=Vector3.new(1,1,0),Anchored=true,CanCollide=false,Locked=true,CastShadow=false,Transparency=0.999}local ar={Color=Color3.new(0,0,0),Material=Enum.Material.Glass,Size=Vector3.new(0,1,1),Anchored=true,CanCollide=false,Locked=true,CastShadow=false,Transparency=0.999}local as={}local at="Children"local au={Name="Horizontal",Children={ap("SpecialMesh",{MeshType=Enum.MeshType.Brick,Offset=Vector3.new(0,0,-0.000001)})}}for av,aw in pairs(aq)do au[av]=aw end;local ax=ap("Part",au)local ay={Name="Vertical",Children={ap("SpecialMesh",{MeshType=Enum.MeshType.Brick,Offset=Vector3.new(0,0,0.000001)})}}for av,aw in pairs(aq)do ay[av]=aw end;local az=ap("Part",ay)local aA={Name="TopRight",Children={ap("SpecialMesh",{MeshType=Enum.MeshType.Cylinder})}}for av,aw in pairs(ar)do aA[av]=aw end;local aB=ap("Part",aA)local aC={Name="TopLeft",Children={ap("SpecialMesh",{MeshType=Enum.MeshType.Cylinder})}}for av,aw in pairs(ar)do aC[av]=aw end;local aD=ap("Part",aC)local aE={Name="BottomRight",Children={ap("SpecialMesh",{MeshType=Enum.MeshType.Cylinder})}}for av,aw in pairs(ar)do aE[av]=aw end;local aF=ap("Part",aE)local aG={Name="BottomLeft",Children={ap("SpecialMesh",{MeshType=Enum.MeshType.Cylinder})}}for av,aw in pairs(ar)do aG[av]=aw end;as[at]={ax,az,aB,aD,aF,ap("Part",aG)}local o=ap("Model",as)return{acrylicInstance=o}end,newEnv("Orca.components.Acrylic.acrylic-instance"))()end)newModule("ActionButton","ModuleScript","Orca.components.ActionButton","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local aH=h.useState;local aI=a.import(script,script.Parent,"BrightButton").default;local aJ=a.import(script,script.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local aL=a.import(script,script.Parent.Parent,"hooks","common","use-spring").useSpring;local aM=a.import(script,script.Parent.Parent,"store","actions","dashboard.action")local aN=aM.clearHint;local aO=aM.setHint;local aP=a.import(script,script.Parent.Parent,"store","actions","jobs.action").setJobActive;local am=a.import(script,script.Parent.Parent,"utils","udim2").px;local function aQ(C)local aR=C.action;local aS=C.hint;local aT=C.theme;local aU=C.image;local M=C.position;local aV=C.canDeactivate;local aW=aK()local aX=p(function(F)return F.jobs[aR].active end)local U=aH(false)local aY=U[1]local aZ=U[2]local a_=aT.highlight[aR]~=nil and aT.highlight[aR]or aT.background;if not(aT.highlight[aR]~=nil)then warn("ActionButton: "..aR.." is not in theme.highlight")end;local b0;if aX then b0=a_ else local b1;if aY then local b2=aT.button.backgroundHovered;if b2==nil then b2=aT.button.background:Lerp(a_,0.1)end;b1=b2 else b1=aT.button.background end;b0=b1 end;local b3=aL(b0,{})local b4=aL(aX and aT.button.foregroundAccent and aT.button.foregroundAccent or aT.button.foreground,{})return b.createElement(aI,{onActivate=function()if aX and aV then aW(aP(aR,false))elseif not aX then aW(aP(aR,true))end end,onHover=function(aY)if aY then aZ(true)aW(aO(aS))else aZ(false)aW(aN())end end,size=am(61,49),position=M,radius=8,color=b3,borderEnabled=aT.button.outlined,borderColor=b4,transparency=aT.button.backgroundTransparency},{b.createElement("ImageLabel",{Image=aU,ImageColor3=b4,ImageTransparency=aL(aX and 0 or(aY and aT.button.foregroundTransparency-0.25 or aT.button.foregroundTransparency),{}),Size=am(36,36),Position=am(12,6),BackgroundTransparency=1})})end;local f=i(aQ)return{default=f}end,newEnv("Orca.components.ActionButton"))()end)newModule("Border","ModuleScript","Orca.components.Border","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local b5=a.import(script,script.Parent.Parent,"utils","binding-util")local b6=b5.asBinding;local b7=b5.mapBinding;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local am=a.import(script,script.Parent.Parent,"utils","udim2").px;local function b8(C)local L=C.size;if L==nil then L=1 end;local D=C.radius;if D==nil then D=0 end;local b9=C.color;if b9==nil then b9=ak("#ffffff")end;local ba=C.transparency;if ba==nil then ba=0 end;local bb=C[b.Children]local bc={Size=b7(L,function(bd)return UDim2.new(1,-bd*2,1,-bd*2)end),Position=b7(L,function(bd)return am(bd,bd)end),BackgroundTransparency=1}local be={}local bf=#be;local bg={Thickness=L,Color=b9,Transparency=ba}local bh={}local bi=#bh;if bb then for av,aw in pairs(bb)do if type(av)=="number"then bh[bi+av]=aw else bh[av]=aw end end end;be[bf+1]=b.createElement("UIStroke",bg,bh)be[bf+2]=b.createElement("UICorner",{CornerRadius=b.joinBindings({radius=b6(D),size=b6(L)}):map(function(bj)local D=bj.radius;local L=bj.size;return D=="circular"and UDim.new(1,0)or UDim.new(0,D-L*2)end)})return b.createElement("Frame",bc,be)end;local f=i(b8)return{default=f}end,newEnv("Orca.components.Border"))()end)newModule("BrightButton","ModuleScript","Orca.components.BrightButton","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local b8=a.import(script,script.Parent,"Border").default;local bk=a.import(script,script.Parent,"Canvas").default;local bl=a.import(script,script.Parent,"Fill").default;local bm=a.import(script,script.Parent,"Glow")local bn=bm.default;local bo=bm.GlowRadius;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local al=a.import(script,script.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local function aI(C)local L=C.size;if L==nil then L=am(100,100)end;local M=C.position;if M==nil then M=am(0,0)end;local D=C.radius;if D==nil then D=8 end;local b9=C.color;if b9==nil then b9=ak("#FFFFFF")end;local bp=C.borderEnabled;local bq=C.borderColor;if bq==nil then bq=ak("#FFFFFF")end;local ba=C.transparency;if ba==nil then ba=0 end;local br=C.onActivate;local bs=C.onPress;local bt=C.onRelease;local bu=C.onHover;local bb=C[b.Children]local bc={size=L,position=M}local be={b.createElement(bn,{radius=bo.Size70,color=b9,size=UDim2.new(1,36,1,36),position=am(-18,5-18),transparency=ba}),b.createElement(bl,{color=b9,radius=D,transparency=ba})}local bf=#be;local bv=bp and b.createElement(b8,{color=bq,radius=D,transparency=0.8})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("TextButton",{Text="",AutoButtonColor=false,Size=r(1,1),BackgroundTransparency=1,[b.Event.Activated]=function()local b0=br;if b0~=nil then b0=b0()end;return b0 end,[b.Event.MouseButton1Down]=function()local b0=bs;if b0~=nil then b0=b0()end;return b0 end,[b.Event.MouseButton1Up]=function()local b0=bt;if b0~=nil then b0=b0()end;return b0 end,[b.Event.MouseEnter]=function()local b0=bu;if b0~=nil then b0=b0(true)end;return b0 end,[b.Event.MouseLeave]=function()local b0=bu;if b0~=nil then b0=b0(false)end;return b0 end})if bb then for av,aw in pairs(bb)do if type(av)=="number"then be[bf+1+av]=aw else be[av]=aw end end end;return b.createElement(bk,bc,be)end;local f=i(aI)return{default=f}end,newEnv("Orca.components.BrightButton"))()end)newModule("BrightSlider","ModuleScript","Orca.components.BrightSlider","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local bw=a.import(script,a.getModule(script,"@rbxts","flipper").src).Spring;local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local j=h.useCallback;local k=h.useEffect;local aH=h.useState;local bx=a.import(script,a.getModule(script,"@rbxts","services")).UserInputService;local by=a.import(script,script.Parent.Parent,"hooks","common","flipper-hooks")local bz=by.getBinding;local bA=by.useMotor;local al=a.import(script,script.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local b8=a.import(script,script.Parent,"Border").default;local bk=a.import(script,script.Parent,"Canvas").default;local bl=a.import(script,script.Parent,"Fill").default;local bm=a.import(script,script.Parent,"Glow")local bn=bm.default;local bo=bm.GlowRadius;local bB={frequency=8}local bC;local function bD(C)local bE=C.min;local bF=C.max;local bG=C.initialValue;local L=C.size;local M=C.position;local D=C.radius;local b9=C.color;local bH=C.accentColor;local bp=C.borderEnabled;local bq=C.borderColor;local ba=C.transparency;local bI=C.indicatorTransparency;local bJ=C.onValueChanged;local bt=C.onRelease;local bb=C[b.Children]local bK=bA(bG)local bL=bz(bK)k(function()local b0=bJ;if b0~=nil then b0(bG)end end,{})k(function()return function()return bK:destroy()end end,{})local bc={size=L,position=M}local be={b.createElement(bn,{radius=bo.Size70,color=bH,size=bL:map(function(bM)return UDim2.new((bM-bE)/(bF-bE),36,1,36)end),position=am(-18,5-18),transparency=0,maintainCornerRadius=true}),b.createElement(bl,{color=b9,radius=D,transparency=ba}),b.createElement(bk,{size=bL:map(function(bM)return r((bM-bE)/(bF-bE),1)end),clipsDescendants=true},{b.createElement("Frame",{Size=L,BackgroundColor3=bH,BackgroundTransparency=bI},{b.createElement("UICorner",{CornerRadius=UDim.new(0,D)})})})}local bf=#be;local bv=bp and b.createElement(b8,{color=bq,radius=D,transparency=0.8})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement(bC,{onChange=function(bN)bK:setGoal(bw.new(bN*(bF-bE)+bE,bB))local b0=bJ;if b0~=nil then b0(bN*(bF-bE)+bE)end end,onRelease=function(bN)local b0=bt;if b0~=nil then b0=b0(bN*(bF-bE)+bE)end;return b0 end})if bb then for av,aw in pairs(bb)do if type(av)=="number"then be[bf+1+av]=aw else be[av]=aw end end end;return b.createElement(bk,bc,be)end;local f=i(bD)local function bO(C)local bP=C.onChange;local bt=C.onRelease;local U=aH()local bQ=U[1]local bR=U[2]local bS=j(function(bN)bN=math.clamp(bN,0,1)bP(bN)end,{})local bT=j(function(bU,ad)return(bU-ad.AbsolutePosition.X)/ad.AbsoluteSize.X end,{})k(function()return function()local b0=bQ;if b0~=nil then b0:Disconnect()end end end,{})return b.createElement("Frame",{Active=true,Size=r(1,1),BackgroundTransparency=1,[b.Event.InputBegan]=function(ad,bV)if bV.UserInputType==Enum.UserInputType.MouseButton1 then local b0=bQ;if b0~=nil then b0:Disconnect()end;local ao=bx.InputChanged:Connect(function(bV)if bV.UserInputType==Enum.UserInputType.MouseMovement then bS(bT(bV.Position.X,ad))end end)bR(ao)bS(bT(bV.Position.X,ad))end end,[b.Event.InputEnded]=function(ad,bV)if bV.UserInputType==Enum.UserInputType.MouseButton1 then local b0=bQ;if b0~=nil then b0:Disconnect()end;bR(nil)bt(bT(bV.Position.X,ad))end end})end;bC=i(bO)return{default=f}end,newEnv("Orca.components.BrightSlider"))()end)newModule("Canvas","ModuleScript","Orca.components.Canvas","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local b7=a.import(script,script.Parent.Parent,"utils","binding-util").mapBinding;local r=a.import(script,script.Parent.Parent,"utils","udim2").scale;local function bk(C)local L=C.size;if L==nil then L=r(1,1)end;local M=C.position;if M==nil then M=r(0,0)end;local bW=C.anchor;local bX=C.padding;local bY=C.clipsDescendants;local bZ=C.zIndex;local bP=C.onChange;if bP==nil then bP={}end;local bb=C[b.Children]local bc={Size=L,Position=M,AnchorPoint=bW,ClipsDescendants=bY,BackgroundTransparency=1,ZIndex=bZ}for av,aw in pairs(bP)do bc[b.Change[av]]=aw end;local be={}local bf=#be;local bv=bX~=nil and b.createElement("UIPadding",{PaddingTop=b7(bX.top,function(am)return UDim.new(0,am)end),PaddingRight=b7(bX.right,function(am)return UDim.new(0,am)end),PaddingBottom=b7(bX.bottom,function(am)return UDim.new(0,am)end),PaddingLeft=b7(bX.left,function(am)return UDim.new(0,am)end)})or nil;if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;if bb then for av,aw in pairs(bb)do if type(av)=="number"then be[bf+av]=aw else be[av]=aw end end end;return b.createElement("Frame",bc,be)end;local f=i(bk)return{default=f}end,newEnv("Orca.components.Canvas"))()end)newModule("Card","ModuleScript","Orca.components.Card","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local B=a.import(script,script.Parent,"Acrylic").default;local b8=a.import(script,script.Parent,"Border").default;local bk=a.import(script,script.Parent,"Canvas").default;local bl=a.import(script,script.Parent,"Fill").default;local bm=a.import(script,script.Parent,"Glow")local bn=bm.default;local bo=bm.GlowRadius;local b_=a.import(script,script.Parent.Parent,"hooks","common","use-delayed-update").useDelayedUpdate;local aL=a.import(script,script.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local am=a.import(script,script.Parent.Parent,"utils","udim2").px;local function c1(C)local c2=C.index;local c3=C.page;local aT=C.theme;local L=C.size;local M=C.position;local bb=C[b.Children]local c4=c0(c3)local c5=b_(c4,c2*40)local c6=UDim2.new(UDim.new(),M.Y)local y=am((L.X.Offset+48)*2-M.X.Offset,0)local c7=am(L.X.Offset+48*2,0)local c8=c6-y-c7;local bc={anchor=Vector2.new(0,1),size=L,position=aL(c5 and M or c8,{frequency=2,dampingRatio=0.8})}local be={b.createElement(bn,{radius=bo.Size198,size=UDim2.new(1,100,1,96),position=am(-50,-28),color=aT.dropshadow,gradient=aT.dropshadowGradient,transparency=aT.dropshadowTransparency}),b.createElement(bl,{color=aT.background,gradient=aT.backgroundGradient,transparency=aT.transparency,radius=16})}local bf=#be;if bb then for av,aw in pairs(bb)do if type(av)=="number"then be[bf+av]=aw else be[av]=aw end end end;bf=#be;local bv=aT.acrylic and b.createFragment({acrylic=b.createElement(B)})or nil;if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;local c9=aT.outlined and b.createElement(b8,{color=aT.foreground,radius=16,transparency=0.8})if c9 then if c9.elements~=nil or c9.props~=nil and c9.component~=nil then be[bf+1]=c9 else for av,aw in ipairs(c9)do be[bf+av]=aw end end end;return b.createElement(bk,bc,be)end;local f=i(c1)return{default=f}end,newEnv("Orca.components.Card"))()end)newModule("Fill","ModuleScript","Orca.components.Fill","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local b7=a.import(script,script.Parent.Parent,"utils","binding-util").mapBinding;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local r=a.import(script,script.Parent.Parent,"utils","udim2").scale;local function bl(C)local b9=C.color;if b9==nil then b9=ak("#ffffff")end;local ca=C.gradient;local ba=C.transparency;if ba==nil then ba=0 end;local D=C.radius;if D==nil then D=0 end;local bb=C[b.Children]local bc={Size=r(1,1),BackgroundColor3=b9,BackgroundTransparency=ba}local be={}local bf=#be;local bv=ca and b.createFragment({gradient=b.createElement("UIGradient",{Color=ca.color,Transparency=ca.transparency,Rotation=ca.rotation})})or nil;if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;local c9=D~=nil and b.createFragment({corner=b.createElement("UICorner",{CornerRadius=b7(D,function(cb)return cb=="circular"and UDim.new(1,0)or UDim.new(0,cb)end)})})or nil;if c9 then if c9.elements~=nil or c9.props~=nil and c9.component~=nil then be[bf+1]=c9 else for av,aw in ipairs(c9)do be[bf+av]=aw end end end;bf=#be;if bb then for av,aw in pairs(bb)do if type(av)=="number"then be[bf+av]=aw else be[av]=aw end end end;return b.createElement("Frame",bc,be)end;local f=i(bl)return{default=f}end,newEnv("Orca.components.Fill"))()end)newModule("Glow","ModuleScript","Orca.components.Glow","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local cc=h.useBinding;local cd=a.import(script,script.Parent.Parent,"hooks","use-scale").useScale;local b6=a.import(script,script.Parent.Parent,"utils","binding-util").asBinding;local q=a.import(script,script.Parent.Parent,"utils","number-util").map;local al=a.import(script,script.Parent.Parent,"utils","udim2")local ce=al.applyUDim2;local am=al.px;local bk=a.import(script,script.Parent,"Canvas").default;local bo;do local cf={}bo=setmetatable({},{__index=cf})bo.Size70="rbxassetid://8992230903"cf["rbxassetid://8992230903"]="Size70"bo.Size146="rbxassetid://8992584561"cf["rbxassetid://8992584561"]="Size146"bo.Size198="rbxassetid://8992230677"cf["rbxassetid://8992230677"]="Size198"end;local cg={[bo.Size70]=70/2,[bo.Size146]=146/2,[bo.Size198]=198/2}local function bn(C)local D=C.radius;local L=C.size;local M=C.position;local b9=C.color;local ca=C.gradient;local ba=C.transparency;if ba==nil then ba=0 end;local ch=C.maintainCornerRadius;local bb=C[b.Children]local U=cc(Vector2.new())local ci=U[1]local cj=U[2]local ck=cd()local cl=cg[D]local cm=ch and b.joinBindings({absoluteSize=ci,scaleFactor=ck,size=b6(L)}):map(function(bj)local ci=bj.absoluteSize;local L=bj.size;local ck=bj.scaleFactor;local cn=ce(ci,L,ck)return am(math.max(cn.X,cl*2),math.max(cn.Y,cl*2))end)or L;local co=ch and b.joinBindings({absoluteSize=ci,scaleFactor=ck,size=b6(L),transparency=b6(ba)}):map(function(bj)local ci=bj.absoluteSize;local L=bj.size;local ba=bj.transparency;local ck=bj.scaleFactor;local cp=cl*2;local cn=ce(ci,UDim2.fromScale(L.X.Scale,L.Y.Scale),ck).X;if cn<cp then return 1-(1-ba)*q(cn,0,cp,0,1)else return ba end end)or ba;local bc={onChange={AbsoluteSize=ch and function(ad)return cj(ad.AbsoluteSize)end or nil}}local be={}local bf=#be;local bg={Image=D,ImageColor3=b9,ImageTransparency=co,ScaleType="Slice",SliceCenter=Rect.new(Vector2.new(cl,cl),Vector2.new(cl,cl)),SliceScale=ck:map(function(cq)return cq*0.1+0.9 end),Size=cm,Position=M,BackgroundTransparency=1}local bh={}local bi=#bh;local bv=ca and b.createElement("UIGradient",{Color=ca.color,Transparency=ca.transparency,Rotation=ca.rotation})or nil;if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then bh[bi+1]=bv else for av,aw in ipairs(bv)do bh[bi+av]=aw end end end;bi=#bh;if bb then for av,aw in pairs(bb)do if type(av)=="number"then bh[bi+av]=aw else bh[av]=aw end end end;be[bf+1]=b.createElement("ImageLabel",bg,bh)return b.createElement(bk,bc,be)end;local f=i(bn)return{GlowRadius=bo,RADIUS_TO_CENTER_OFFSET=cg,default=f}end,newEnv("Orca.components.Glow"))()end)newModule("ParallaxImage","ModuleScript","Orca.components.ParallaxImage","Orca.components",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local b7=a.import(script,script.Parent.Parent,"utils","binding-util").mapBinding;local r=a.import(script,script.Parent.Parent,"utils","udim2").scale;local function cr(C)local aU=C.image;local cs=C.imageSize;local ct=C.offset;local bX=C.padding;local bb=C[b.Children]local bc={Image=aU}local y=bX*2;bc.ImageRectSize=cs-y;bc.ImageRectOffset=b7(ct,function(cu)local c7=cu*bX;return bX+c7 end)bc.ScaleType="Crop"bc.Size=r(1,1)bc.BackgroundTransparency=1;local be={}local bf=#be;if bb then for av,aw in pairs(bb)do if type(av)=="number"then be[bf+av]=aw else be[av]=aw end end end;return b.createElement("ImageLabel",bc,be)end;local f=cr;return{default=f}end,newEnv("Orca.components.ParallaxImage"))()end)newModule("constants","ModuleScript","Orca.constants","Orca",function()return setfenv(function()local cv=getgenv==nil;local b2=VERSION;if b2==nil then b2="studio"end;local cw=b2;return{IS_DEV=cv,VERSION_TAG=cw}end,newEnv("Orca.constants"))()end)newInstance("context","Folder","Orca.context","Orca")newModule("scale-context","ModuleScript","Orca.context.scale-context","Orca.context",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local cx=b.createContext(b.createBinding(1))return{ScaleContext=cx}end,newEnv("Orca.context.scale-context"))()end)newInstance("hooks","Folder","Orca.hooks","Orca")newInstance("common","Folder","Orca.hooks.common","Orca.hooks")newModule("flipper-hooks","ModuleScript","Orca.hooks.common.flipper-hooks","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local g={}g.getBinding=a.import(script,script,"get-binding").getBinding;g.useGoal=a.import(script,script,"use-goal").useGoal;g.useInstant=a.import(script,script,"use-instant").useInstant;g.useLinear=a.import(script,script,"use-linear").useLinear;g.useMotor=a.import(script,script,"use-motor").useMotor;g.useSpring=a.import(script,script,"use-spring").useSpring;return g end,newEnv("Orca.hooks.common.flipper-hooks"))()end)newModule("get-binding","ModuleScript","Orca.hooks.common.flipper-hooks.get-binding","Orca.hooks.common.flipper-hooks",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local cy=a.import(script,a.getModule(script,"@rbxts","flipper").src).isMotor;local cz=a.import(script,a.getModule(script,"@rbxts","roact").src).createBinding;local cA=setmetatable({},{__tostring=function()return"AssignedBinding"end})local function bz(cB)assert(cB,"Missing argument #1: motor")local y=cy(cB)assert(y,"Provided value is not a motor")if cB[cA]~=nil then return cB[cA]end;local cC,cD=cz(cB:getValue())cB:onStep(cD)cB[cA]=cC;return cC end;return{getBinding=bz}end,newEnv("Orca.hooks.common.flipper-hooks.get-binding"))()end)newModule("use-goal","ModuleScript","Orca.hooks.common.flipper-hooks.use-goal","Orca.hooks.common.flipper-hooks",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local bz=a.import(script,script.Parent,"get-binding").getBinding;local bA=a.import(script,script.Parent,"use-motor").useMotor;local function cE(cF)local cB=bA(cF._targetValue)cB:setGoal(cF)return bz(cB)end;return{useGoal=cE}end,newEnv("Orca.hooks.common.flipper-hooks.use-goal"))()end)newModule("use-instant","ModuleScript","Orca.hooks.common.flipper-hooks.use-instant","Orca.hooks.common.flipper-hooks",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local cG=a.import(script,a.getModule(script,"@rbxts","flipper").src).Instant;local cE=a.import(script,script.Parent,"use-goal").useGoal;local function cH(cI)return cE(cG.new(cI))end;return{useInstant=cH}end,newEnv("Orca.hooks.common.flipper-hooks.use-instant"))()end)newModule("use-linear","ModuleScript","Orca.hooks.common.flipper-hooks.use-linear","Orca.hooks.common.flipper-hooks",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local cJ=a.import(script,a.getModule(script,"@rbxts","flipper").src).Linear;local cE=a.import(script,script.Parent,"use-goal").useGoal;local function cK(cI,cL)return cE(cJ.new(cI,cL))end;return{useLinear=cK}end,newEnv("Orca.hooks.common.flipper-hooks.use-linear"))()end)newModule("use-motor","ModuleScript","Orca.hooks.common.flipper-hooks.use-motor","Orca.hooks.common.flipper-hooks",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local cM=a.import(script,a.getModule(script,"@rbxts","flipper").src)local cN=cM.GroupMotor;local cO=cM.SingleMotor;local m=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out.hooks).useMutable;local function cP(bG)if type(bG)=="number"then return cO.new(bG)elseif type(bG)=="table"then return cN.new(bG)else error("Invalid type for initialValue. Expected 'number' or 'table', got '"..tostring(bG).."'")end end;local function bA(bG)return m(cP(bG)).current end;return{useMotor=bA}end,newEnv("Orca.hooks.common.flipper-hooks.use-motor"))()end)newModule("use-spring","ModuleScript","Orca.hooks.common.flipper-hooks.use-spring","Orca.hooks.common.flipper-hooks",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local bw=a.import(script,a.getModule(script,"@rbxts","flipper").src).Spring;local cE=a.import(script,script.Parent,"use-goal").useGoal;local function aL(cI,cL)return cE(bw.new(cI,cL))end;return{useSpring=aL}end,newEnv("Orca.hooks.common.flipper-hooks.use-spring"))()end)newModule("rodux-hooks","ModuleScript","Orca.hooks.common.rodux-hooks","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local cQ=a.import(script,a.getModule(script,"@rbxts","roact-rodux-hooked").out)local cR=cQ.useDispatch;local cS=cQ.useSelector;local cT=cQ.useStore;local p=cS;local aK=function()return cR()end;local cU=function()return cT()end;return{useAppSelector=p,useAppDispatch=aK,useAppStore=cU}end,newEnv("Orca.hooks.common.rodux-hooks"))()end)newModule("use-delayed-update","ModuleScript","Orca.hooks.common.use-delayed-update","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local k=h.useEffect;local m=h.useMutable;local aH=h.useState;local cV=a.import(script,script.Parent.Parent.Parent,"utils","timeout")local cW=cV.clearTimeout;local cX=cV.setTimeout;local cY=0;local function cZ(c_,d0)for d1,d2 in pairs(c_)do if d0==nil or d2.resolveTime>=d0 then c_[d1]=nil;cW(d2.timeout)end end end;local function b_(d3,d4,d5)local U=aH(d3)local d6=U[1]local d7=U[2]local c_=m({})k(function()local b0=d5;if b0~=nil then b0=b0(d3)end;if b0 then cZ(c_.current)d7(d3)return nil end;local d8=cY;cY=cY+1;local d1=d8;local d2={timeout=cX(function()d7(d3)c_.current[d1]=nil end,d4),resolveTime=os.clock()+d4}cZ(c_.current,d2.resolveTime)c_.current[d1]=d2 end,{d3})k(function()return function()return cZ(c_.current)end end,{})return d6 end;return{useDelayedUpdate=b_}end,newEnv("Orca.hooks.common.use-delayed-update"))()end)newModule("use-did-mount","ModuleScript","Orca.hooks.common.use-did-mount","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local k=h.useEffect;local m=h.useMutable;local function d9(da)local db=m(da)k(function()if db.current then db.current()end end,{})return db end;local function dc()local db=m(true)k(function()db.current=false end,{})return db.current end;return{useDidMount=d9,useIsMount=dc}end,newEnv("Orca.hooks.common.use-did-mount"))()end)newModule("use-forced-update","ModuleScript","Orca.hooks.common.use-forced-update","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local j=h.useCallback;local aH=h.useState;local function dd()local U=aH(0)local de=U[2]return j(function()return de(function(F)return F+1 end)end,{})end;return{useForcedUpdate=dd}end,newEnv("Orca.hooks.common.use-forced-update"))()end)newModule("use-interval","ModuleScript","Orca.hooks.common.use-interval","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local k=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).useEffect;local cV=a.import(script,script.Parent.Parent.Parent,"utils","timeout")local df=cV.clearInterval;local dg=cV.setInterval;local function dh(da,d4,di)if di==nil then di={}end;local ax=function()if d4~=nil then local dj=dg(da,d4)return function()return df(dj)end end end;local dk={da,d4}local bf=#dk;table.move(di,1,#di,bf+1,dk)k(ax,dk)return dg end;return{useInterval=dh}end,newEnv("Orca.hooks.common.use-interval"))()end)newModule("use-mouse-location","ModuleScript","Orca.hooks.common.use-mouse-location","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local cc=h.useBinding;local k=h.useEffect;local bx=a.import(script,a.getModule(script,"@rbxts","services")).UserInputService;local function dl(bP)local U=cc(bx:GetMouseLocation())local u=U[1]local dm=U[2]k(function()local ao=bx.InputChanged:Connect(function(bV)if bV.UserInputType==Enum.UserInputType.MouseMovement then dm(Vector2.new(bV.Position.X,bV.Position.Y))local b0=bP;if b0~=nil then b0(Vector2.new(bV.Position.X,bV.Position.Y))end end end)return function()ao:Disconnect()end end,{})return u end;return{useMouseLocation=dl}end,newEnv("Orca.hooks.common.use-mouse-location"))()end)newModule("use-promise","ModuleScript","Orca.hooks.common.use-promise","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local k=h.useEffect;local dn=h.useReducer;local function dp(dq)if type(dq)=="function"then return dq()end;return dq end;local dr={pending="pending",rejected="rejected",resolved="resolved"}local ds={err=nil,result=nil,state=dr.pending}local function dt(F,aR)local ax=aR.type;repeat if ax==dr.pending then return ds end;if ax==dr.resolved then return{err=nil,result=aR.payload,state=dr.resolved}end;if ax==dr.rejected then return{err=aR.payload,result=nil,state=dr.rejected}end;return F until true end;local function du(dq,di)if di==nil then di={}end;local U=dn(dt,ds)local dv=U[1]local dw=dv.err;local dx=dv.result;local F=dv.state;local aW=U[2]k(function()dq=dp(dq)if not dq then return nil end;local dy=false;aW({type=dr.pending})local y=function(dx)return not dy and aW({payload=dx,type=dr.resolved})end;local dz=function(dw)return not dy and aW({payload=dw,type=dr.rejected})end;dq:andThen(y,dz)return function()dy=true end end,di)return{dx,dw,F}end;return{usePromise=du}end,newEnv("Orca.hooks.common.use-promise"))()end)newModule("use-set-state","ModuleScript","Orca.hooks.common.use-set-state","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local aH=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).useState;local function dA(dB)local U=aH(dB)local F=U[1]local de=U[2]local dC=function(aR)return de(function(bd)local as={}if type(bd)=="table"then for av,aw in pairs(bd)do as[av]=aw end end;local b0;if type(aR)=="function"then b0=aR(bd)else b0=aR end;if type(b0)=="table"then for av,aw in pairs(b0)do as[av]=aw end end;return as end)end;return{F,dC}end;return{default=dA}end,newEnv("Orca.hooks.common.use-set-state"))()end)newModule("use-spring","ModuleScript","Orca.hooks.common.use-spring","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local bw=a.import(script,a.getModule(script,"@rbxts","flipper").src).Spring;local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local by=a.import(script,script.Parent,"flipper-hooks")local bz=by.getBinding;local bA=by.useMotor;local dD=by.useSpring;local dE={number=dD,Color3=function(b9,cL)local cB=bA({b9.R,b9.G,b9.B})cB:setGoal({bw.new(b9.R,cL),bw.new(b9.G,cL),bw.new(b9.B,cL)})return bz(cB):map(function(C)local cb=C[1]local dF=C[2]local dG=C[3]return Color3.new(cb,dF,dG)end)end,UDim=function(dH,cL)local cB=bA({dH.Scale,dH.Offset})cB:setGoal({bw.new(dH.Scale,cL),bw.new(dH.Offset,cL)})return bz(cB):map(function(C)local bd=C[1]local cu=C[2]return UDim.new(bd,cu)end)end,UDim2=function(dI,cL)local cB=bA({dI.X.Scale,dI.X.Offset,dI.Y.Scale,dI.Y.Offset})cB:setGoal({bw.new(dI.X.Scale,cL),bw.new(dI.X.Offset,cL),bw.new(dI.Y.Scale,cL),bw.new(dI.Y.Offset,cL)})return bz(cB):map(function(C)local dJ=C[1]local dK=C[2]local dL=C[3]local dM=C[4]return UDim2.new(dJ,math.round(dK),dL,math.round(dM))end)end,Vector2=function(dN,cL)local cB=bA({dN.X,dN.Y})cB:setGoal({bw.new(dN.X,cL),bw.new(dN.Y,cL)})return bz(cB):map(function(C)local dO=C[1]local dP=C[2]return Vector2.new(dO,dP)end)end}local function aL(d3,cL)if not cL then return b.createBinding(d3)end;local aL=dE[typeof(d3)]local dz="useAnySpring: "..typeof(d3).." is not supported"assert(aL,dz)return aL(d3,cL)end;return{useSpring=aL}end,newEnv("Orca.hooks.common.use-spring"))()end)newModule("use-viewport-size","ModuleScript","Orca.hooks.common.use-viewport-size","Orca.hooks.common",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local cc=h.useBinding;local k=h.useEffect;local aH=h.useState;local n=a.import(script,a.getModule(script,"@rbxts","services")).Workspace;local function dQ(bP)local U=aH(n.CurrentCamera)local dR=U[1]local dS=U[2]local dv=cc(dR.ViewportSize)local L=dv[1]local dT=dv[2]k(function()local ao=n:GetPropertyChangedSignal("CurrentCamera"):Connect(function()if n.CurrentCamera then dS(n.CurrentCamera)dT(n.CurrentCamera.ViewportSize)local b0=bP;if b0~=nil then b0(n.CurrentCamera.ViewportSize)end end end)return function()ao:Disconnect()end end,{})k(function()local ao=dR:GetPropertyChangedSignal("ViewportSize"):Connect(function()dT(dR.ViewportSize)local b0=bP;if b0~=nil then b0(dR.ViewportSize)end end)return function()ao:Disconnect()end end,{dR})return L end;return{useViewportSize=dQ}end,newEnv("Orca.hooks.common.use-viewport-size"))()end)newModule("use-current-page","ModuleScript","Orca.hooks.use-current-page","Orca.hooks",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local p=a.import(script,script.Parent,"common","rodux-hooks").useAppSelector;local function dU()return p(function(F)return F.dashboard.page end)end;local function c0(c3)return p(function(F)return F.dashboard.isOpen and F.dashboard.page==c3 end)end;return{useCurrentPage=dU,useIsPageOpen=c0}end,newEnv("Orca.hooks.use-current-page"))()end)newModule("use-friends","ModuleScript","Orca.hooks.use-friends","Orca.hooks",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local l=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).useMemo;local dV=a.import(script,a.getModule(script,"@rbxts","services")).Players;local du=a.import(script,script.Parent,"common","use-promise").usePromise;local function dW(di)return du(a.async(function()return dV.LocalPlayer:GetFriendsOnline()end),di)end;local function dX(di)local U=dW(di)local dY=U[1]local dw=U[2]local dZ=U[3]local d_=dY;if d_~=nil then local y=function(e0)return e0.PlaceId~=nil and e0.GameId~=nil end;local e1={}local bf=0;for av,aw in ipairs(d_)do if y(aw,av-1,d_)==true then bf=bf+1;e1[bf]=aw end end;d_=e1 end;local e2=d_;return{e2,dw,dZ}end;local function e3(di)local U=dX(di)local dY=U[1]local dw=U[2]local dZ=U[3]local e4=l(function()return{}end,di)if not dY or#e4>0 then return{e4,dw,dZ}end;local y=function(e0)local c7=function(dF)return dF.placeId==e0.PlaceId end;local b0=nil;for e5,aw in ipairs(e4)do if c7(aw,e5-1,e4)==true then b0=aw;break end end;local e6=b0;if not e6 then e6={friends={e0},placeId=e0.PlaceId,thumbnail="https://www.roblox.com/asset-thumbnail/image?assetId="..tostring(e0.PlaceId).."&width=768&height=432&format=png"}local e7=e6;e4[#e4+1]=e7 else local e8=e6.friends;e8[#e8+1]=e0 end end;for av,aw in ipairs(dY)do y(aw,av-1,dY)end;return{e4,dw,dZ}end;return{useFriends=dW,useFriendsPlaying=dX,useFriendActivity=e3}end,newEnv("Orca.hooks.use-friends"))()end)newModule("use-parallax-offset","ModuleScript","Orca.hooks.use-parallax-offset","Orca.hooks",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local bw=a.import(script,a.getModule(script,"@rbxts","flipper").src).Spring;local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local by=a.import(script,script.Parent,"common","flipper-hooks")local bz=by.getBinding;local bA=by.useMotor;local dl=a.import(script,script.Parent,"common","use-mouse-location").useMouseLocation;local dQ=a.import(script,script.Parent,"common","use-viewport-size").useViewportSize;local function e9()local ea=bA({0,0})local eb=bz(ea)local ec=dQ()local ct=b.joinBindings({viewportSize=ec,mouseLocation=eb}):map(function(C)local ec=C.viewportSize;local U=C.mouseLocation;local bU=U[1]local ed=U[2]return Vector2.new((bU-ec.X/2)/ec.X,(ed-ec.Y/2)/ec.Y)end)dl(function(u)ea:setGoal({bw.new(u.X,{dampingRatio=5}),bw.new(u.Y,{dampingRatio=5})})end)return ct end;return{useParallaxOffset=e9}end,newEnv("Orca.hooks.use-parallax-offset"))()end)newModule("use-scale","ModuleScript","Orca.hooks.use-scale","Orca.hooks",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local ee=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).useContext;local cx=a.import(script,script.Parent.Parent,"context","scale-context").ScaleContext;local ef=b.createBinding(1)local function cd()local b2=ee(cx)if b2==nil then b2=ef end;return b2 end;return{useScale=cd}end,newEnv("Orca.hooks.use-scale"))()end)newModule("use-theme","ModuleScript","Orca.hooks.use-theme","Orca.hooks",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local p=a.import(script,script.Parent,"common","rodux-hooks").useAppSelector;local eg=a.import(script,script.Parent.Parent,"themes").getThemes;local eh=a.import(script,script.Parent.Parent,"themes","dark-theme").darkTheme;local function ei(ej)return p(function(F)local ax=eg()local y=function(ek)return ek.name==F.options.currentTheme end;local b0=nil;for e5,aw in ipairs(ax)do if y(aw,e5-1,ax)==true then b0=aw;break end end;local aT=b0;return aT and aT[ej]or eh[ej]end)end;return{useTheme=ei}end,newEnv("Orca.hooks.use-theme"))()end)newModule("jobs","ModuleScript","Orca.jobs","Orca",function()return setfenv(function()local a=require(script.Parent.include.RuntimeLib)local g={}g.setStore=a.import(script,script,"helpers","job-store").setStore;return g end,newEnv("Orca.jobs"))()end)newModule("acrylic","LocalScript","Orca.jobs.acrylic","Orca.jobs",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ap=a.import(script,a.getModule(script,"@rbxts","make"))local el=a.import(script,a.getModule(script,"@rbxts","services")).Lighting;local em=a.import(script,script.Parent,"helpers","job-store").getStore;local cX=a.import(script,script.Parent.Parent,"utils","timeout").setTimeout;local en=ap("DepthOfFieldEffect",{FarIntensity=0,InFocusRadius=0.1,NearIntensity=1})local eo={}local function ep()for eq in pairs(eo)do eq.Enabled=false end;en.Parent=el end;local function er()for eq,es in pairs(eo)do eq.Enabled=es.enabled end;en.Parent=nil end;local et=a.async(function()local eu=a.await(em())for ev,eq in ipairs(el:GetChildren())do if eq:IsA("DepthOfFieldEffect")then local dz={enabled=eq.Enabled}eo[eq]=dz end end;local ew;eu.changed:connect(function(ex)local b0=ew;if b0~=nil then b0:clear()end;ew=nil;if not ex.dashboard.isOpen then ew=cX(er,500)return nil end;if ex.options.config.acrylicBlur then ep()else er()end end)end)et():catch(function(dw)warn("[acrylic-worker] "..tostring(dw))end)end,newEnv("Orca.jobs.acrylic"))()end)newInstance("character","Folder","Orca.jobs.character","Orca.jobs")newModule("flight","LocalScript","Orca.jobs.character.flight","Orca.jobs.character",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local cM=a.import(script,a.getModule(script,"@rbxts","flipper").src)local cN=cM.GroupMotor;local bw=cM.Spring;local ey=a.import(script,a.getModule(script,"@rbxts","services"))local dV=ey.Players;local ez=ey.RunService;local bx=ey.UserInputService;local n=ey.Workspace;local eA=a.import(script,script.Parent.Parent,"helpers","job-store").onJobChange;local eB=dV.LocalPlayer;local eC={forward=Vector3.new(),backward=Vector3.new(),left=Vector3.new(),right=Vector3.new(),up=Vector3.new(),down=Vector3.new()}local eD=false;local eE=16;local eF;local eG;local eH=cN.new({0,0,0},false)local eI,eJ,eK,eL;local et=a.async(function()a.await(eA("flight",function(eM)eD=eM.active;eE=eM.value;if eD then eI()eJ()end end))bx.InputBegan:Connect(function(bV,eN)if eN then return nil end;eK(bV.KeyCode,true)end)bx.InputEnded:Connect(function(bV)eK(bV.KeyCode,false)end)ez.Heartbeat:Connect(function(eO)if eD and(eF and eG)then eL(eO)eH:setGoal({bw.new(eG.X),bw.new(eG.Y),bw.new(eG.Z)})eH:step(eO)local U=eH:getValue()local bU=U[1]local ed=U[2]local eP=U[3]eF.AssemblyLinearVelocity=Vector3.new()local eQ=n.CurrentCamera.CFrame.Rotation;local eR=Vector3.new(bU,ed,eP)eF.CFrame=eQ+eR end end)ez.RenderStepped:Connect(function()if eD and(eF and eG)then local eQ=n.CurrentCamera.CFrame.Rotation;local eS=eF.CFrame.Position;eF.CFrame=eQ+eS end end)eB.CharacterAdded:Connect(function(eT)local eU=eT:WaitForChild("HumanoidRootPart",5)if eU and eU:IsA("BasePart")then eF=eU end;eI()eJ()end)local eV=eB.Character;if eV~=nil then eV=eV:FindFirstChild("HumanoidRootPart")end;local eW=eV;if eW and eW:IsA("BasePart")then eF=eW;eI()end end)local function eX()local eY=Vector3.new()for ev,eZ in pairs(eC)do eY=eY+eZ end;return eY.Magnitude>0 and eY.Unit or eY end;function eI()if not eF then return nil end;local U=n.CurrentCamera.CFrame;local e_=U.XVector;local f0=U.YVector;local f1=U.ZVector;eG=CFrame.fromMatrix(eF.Position,e_,f0,f1)end;function eJ()if not eG then return nil end;eH=cN.new({eG.X,eG.Y,eG.Z},false)end;function eL(eO)if not eG then return nil end;local U=n.CurrentCamera.CFrame;local e_=U.XVector;local f0=U.YVector;local f1=U.ZVector;local f2=eX()if f2.Magnitude>0 then local y=eE*eO;local dv=f2*y;local dO=dv.X;local dP=dv.Y;local f3=dv.Z;local ax=CFrame.fromMatrix(eG.Position,e_,f0,f1)local a6=CFrame.new(dO,dP,f3)eG=ax*a6 else eG=CFrame.fromMatrix(eG.Position,e_,f0,f1)end end;function eK(f4,f5)repeat if f4==Enum.KeyCode.W then eC.forward=f5 and Vector3.new(0,0,-1)or Vector3.new()break end;if f4==Enum.KeyCode.S then eC.backward=f5 and Vector3.new(0,0,1)or Vector3.new()break end;if f4==Enum.KeyCode.A then eC.left=f5 and Vector3.new(-1,0,0)or Vector3.new()break end;if f4==Enum.KeyCode.D then eC.right=f5 and Vector3.new(1,0,0)or Vector3.new()break end;if f4==Enum.KeyCode.Q then eC.up=f5 and Vector3.new(0,-1,0)or Vector3.new()break end;if f4==Enum.KeyCode.E then eC.down=f5 and Vector3.new(0,1,0)or Vector3.new()break end until true end;et():catch(function(dw)warn("[flight-worker] "..tostring(dw))end)end,newEnv("Orca.jobs.character.flight"))()end)newModule("ghost","LocalScript","Orca.jobs.character.ghost","Orca.jobs.character",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ey=a.import(script,a.getModule(script,"@rbxts","services"))local dV=ey.Players;local n=ey.Workspace;local f6=a.import(script,script.Parent.Parent,"helpers","job-store")local em=f6.getStore;local eA=f6.onJobChange;local eB=dV.LocalPlayer;local f7;local f8;local f9;local fa,fb,fc,fd;local et=a.async(function()a.await(eA("ghost",function(eM,F)if F.jobs.refresh.active and eM.active then fa()elseif eM.active then fb():andThen(fc):catch(function(dw)warn("[ghost-worker-active] "..tostring(dw))fa()end)elseif not F.jobs.refresh.active then fd():catch(function(dw)warn("[ghost-worker-inactive] "..tostring(dw))end)end end))end)fa=a.async(function()local eu=a.await(em())eu:dispatch({type="jobs/setJobActive",jobName="ghost",active=false})end)fc=a.async(function()a.await(a.Promise.fromEvent(eB.CharacterAdded,function(eT)return eT~=f7 and eT~=f8 end))a.await(fa())end)fb=a.async(function()local eT=eB.Character;local fe=eT;if fe~=nil then fe=fe:FindFirstChildWhichIsA("Humanoid")end;local ff=fe;if not eT or not ff then error("Character or Humanoid is null")end;eT.Archivable=true;f8=eT:Clone()eT.Archivable=false;local fg=eT:FindFirstChild("HumanoidRootPart")local b0=fg;if b0~=nil then b0=b0:IsA("BasePart")end;f9=b0 and fg.CFrame or nil;f7=eT;local fh=f8:FindFirstChildWhichIsA("Humanoid")for ev,fi in ipairs(f8:GetDescendants())do if fi:IsA("BasePart")then fi.Transparency=1-(1-fi.Transparency)*0.5 end end;if fh then fh.DisplayName=utf8.char(128123)end;local b1=f8:FindFirstChild("Animate")if b1~=nil then b1:Destroy()end;local fj=f7:FindFirstChild("Animate")if fj then fj.Disabled=true;fj.Parent=f8 end;f8.Parent=eT.Parent;eB.Character=f8;n.CurrentCamera.CameraSubject=fh;if fj then fj.Disabled=false end;local ao;ao=ff.Died:Connect(function()ao:Disconnect()fa()end)end)fd=a.async(function()if not f7 or not f8 then return nil end;local fg=f7:FindFirstChild("HumanoidRootPart")local fk=f8:FindFirstChild("HumanoidRootPart")local b0=fk;if b0~=nil then b0=b0:IsA("BasePart")end;local fl=b0 and fk.CFrame or nil;local fj=f8:FindFirstChild("Animate")if fj then fj.Disabled=true;fj.Parent=nil end;f8:Destroy()local ff=f7:FindFirstChildWhichIsA("Humanoid")local b1=ff;if b1~=nil then local ax=b1:GetPlayingAnimationTracks()local y=function(fm)return fm:Stop()end;for av,aw in ipairs(ax)do y(aw,av-1,ax)end end;local M=fl or f9;local fn=fg;if fn~=nil then fn=fn:IsA("BasePart")end;local b2=fn;if b2 then b2=M end;if b2 then fg.CFrame=M end;eB.Character=f7;n.CurrentCamera.CameraSubject=ff;if fj then fj.Parent=f7;fj.Disabled=false end;f7=nil;f8=nil;f9=nil end)et():catch(function(dw)warn("[ghost-worker] "..tostring(dw))end)end,newEnv("Orca.jobs.character.ghost"))()end)newModule("godmode","LocalScript","Orca.jobs.character.godmode","Orca.jobs.character",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ey=a.import(script,a.getModule(script,"@rbxts","services"))local dV=ey.Players;local n=ey.Workspace;local f6=a.import(script,script.Parent.Parent,"helpers","job-store")local em=f6.getStore;local eA=f6.onJobChange;local eB=dV.LocalPlayer;local fo;local fa,fp,fc;local et=a.async(function()local function fq(dw)warn("[godmode-worker] "..tostring(dw))fa()end;a.await(eA("godmode",function(eM,F)if F.jobs.ghost.active and eM.active then fa()elseif eM.active then fp():andThen(fc):catch(fq)end end))end)fa=a.async(function()local eu=a.await(em())eu:dispatch({type="jobs/setJobActive",jobName="godmode",active=false})end)fc=a.async(function()local eu=a.await(em())a.await(a.Promise.fromEvent(eB.CharacterAdded,function(eT)local fr=eu:getState().jobs;return not fr.ghost.active and eT~=fo end))a.await(fa())end)fp=a.async(function()local fs=n.CurrentCamera.CFrame;local eT=eB.Character;if not eT then error("Character is null")end;local ff=eT:FindFirstChildWhichIsA("Humanoid")if not ff then error("No humanoid found")end;local ft=ff:Clone()ft.Parent=eT;fo=eT;eB.Character=nil;ft:SetStateEnabled(Enum.HumanoidStateType.Dead,false)ft:SetStateEnabled(Enum.HumanoidStateType.Ragdoll,false)ft:SetStateEnabled(Enum.HumanoidStateType.FallingDown,false)ft.BreakJointsOnDeath=true;ft.DisplayDistanceType=Enum.HumanoidDisplayDistanceType.None;ff:Destroy()eB.Character=eT;n.CurrentCamera.CameraSubject=ft;task.defer(function()n.CurrentCamera.CFrame=fs end)local fj=eT:FindFirstChild("Animate")if fj then fj.Disabled=true;fj.Disabled=false end;ft.MaxHealth=math.huge;ft.Health=ft.MaxHealth end)et():catch(function(dw)warn("[godmode-worker] "..tostring(dw))end)end,newEnv("Orca.jobs.character.godmode"))()end)newModule("humanoid","LocalScript","Orca.jobs.character.humanoid","Orca.jobs.character",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local dV=a.import(script,a.getModule(script,"@rbxts","services")).Players;local f6=a.import(script,script.Parent.Parent,"helpers","job-store")local em=f6.getStore;local eA=f6.onJobChange;local fu=349.24;local eB=dV.LocalPlayer;local es={walkSpeed=16,jumpHeight=7.2}local fv,fw,fx,fy;local et=a.async(function()local eu=a.await(em())local fe=eB.Character;if fe~=nil then fe=fe:FindFirstChildWhichIsA("Humanoid")end;local ff=fe;local F=eu:getState()local fz=F.jobs.walkSpeed;local fA=F.jobs.jumpHeight;a.await(eA("walkSpeed",function(eM)if eM.active and not fz.active then fv(ff)end;fz=eM;fw(ff,fz)end))a.await(eA("jumpHeight",function(eM)if eM.active and not fA.active then fx(ff)end;fA=eM;fy(ff,fA)end))eB.CharacterAdded:Connect(function(eT)local fB=eT:WaitForChild("Humanoid",5)if fB and fB:IsA("Humanoid")then ff=fB;fv(fB)fw(fB,fz)fx(fB)fy(fB,fA)end end)fv(ff)fx(ff)end)function fv(ff)if ff then es.walkSpeed=ff.WalkSpeed end end;function fx(ff)if ff then es.jumpHeight=ff.JumpHeight end end;function fw(ff,fz)if not ff then return nil end;if fz.active then ff.WalkSpeed=fz.value else ff.WalkSpeed=es.walkSpeed end end;function fy(ff,fA)if not ff then return nil end;if fA.active then ff.JumpHeight=fA.value;if ff.UseJumpPower then ff.JumpPower=math.sqrt(fu*fA.value)end else ff.JumpHeight=es.jumpHeight;if ff.UseJumpPower then ff.JumpPower=math.sqrt(fu*es.jumpHeight)end end end;et():catch(function(dw)warn("[humanoid-worker] "..tostring(dw))end)end,newEnv("Orca.jobs.character.humanoid"))()end)newModule("refresh","LocalScript","Orca.jobs.character.refresh","Orca.jobs.character",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ey=a.import(script,a.getModule(script,"@rbxts","services"))local dV=ey.Players;local n=ey.Workspace;local f6=a.import(script,script.Parent.Parent,"helpers","job-store")local em=f6.getStore;local eA=f6.onJobChange;local fC=10;local eB=dV.LocalPlayer;local fD;local et=a.async(function()local eu=a.await(em())local function fa()eu:dispatch({type="jobs/setJobActive",jobName="refresh",active=false})end;a.await(eA("refresh",function(eM,F)if F.jobs.ghost.active and eM.active then fa()elseif eM.active then fD():catch(function(dw)return warn("[refresh-worker-respawn] "..tostring(dw))end):finally(function()return fa()end)end end))end)fD=a.async(function()local eT=eB.Character;if not eT then error("Character is null")end;local fE=eT:FindFirstChild("HumanoidRootPart")if fE~=nil then fE=fE.CFrame end;local fF=fE;local ff=eT:FindFirstAncestorWhichIsA("Humanoid")local b0=ff;if b0~=nil then b0:ChangeState(Enum.HumanoidStateType.Dead)end;eT:ClearAllChildren()local fG=Instance.new("Model",n)eB.Character=fG;eB.Character=eT;fG:Destroy()if not fF then return nil end;local fH=a.await(a.Promise.fromEvent(eB.CharacterAdded):timeout(fC,"CharacterAdded event timed out"))local eF=fH:WaitForChild("HumanoidRootPart",5)if eF and(eF:IsA("BasePart")and fF)then task.delay(0.1,function()eF.CFrame=fF end)end end)et():catch(function(dw)warn("[refresh-worker] "..tostring(dw))end)end,newEnv("Orca.jobs.character.refresh"))()end)newModule("freecam","LocalScript","Orca.jobs.freecam","Orca.jobs",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local fI=a.import(script,script.Parent,"helpers","freecam")local fJ=fI.DisableFreecam;local fK=fI.EnableFreecam;local eA=a.import(script,script.Parent,"helpers","job-store").onJobChange;local et=a.async(function()a.await(eA("freecam",function(eM)if eM.active then fK()else fJ()end end))end)et():catch(function(dw)warn("[freecam-worker] "..tostring(dw))end)end,newEnv("Orca.jobs.freecam"))()end)newInstance("helpers","Folder","Orca.jobs.helpers","Orca.jobs")newModule("freecam","ModuleScript","Orca.jobs.helpers.freecam","Orca.jobs.helpers",function()return setfenv(function()local fL=math.pi;local fM=math.abs;local fN=math.clamp;local fO=math.exp;local fP=math.rad;local fQ=math.sign;local fR=math.sqrt;local fS=math.tan;local fT=game:GetService("ContextActionService")local dV=game:GetService("Players")local ez=game:GetService("RunService")local fU=game:GetService("StarterGui")local bx=game:GetService("UserInputService")local n=game:GetService("Workspace")local fV=dV.LocalPlayer;if not fV then dV:GetPropertyChangedSignal("LocalPlayer"):Wait()fV=dV.LocalPlayer end;local fW=n.CurrentCamera;n:GetPropertyChangedSignal("CurrentCamera"):Connect(function()local fX=n.CurrentCamera;if fX then fW=fX end end)local fY=Enum.ContextActionPriority.Low.Value;local fZ=Enum.ContextActionPriority.High.Value;local f_={Enum.KeyCode.LeftShift,Enum.KeyCode.P}local g0=game:GetService("HttpService"):GenerateGUID(false)local g1=Vector3.new(1,1,1)*64;local g2=Vector2.new(0.75,1)*8;local g3=300;local g4=fP(90)local g5=2.0;local g6=3.0;local g7=4.0;local bw={}do bw.__index=bw;function bw.new(g8,g9)local self=setmetatable({},bw)self.f=g8;self.p=g9;self.v=g9*0;return self end;function bw:Update(ga,cF)local gb=self.f*2*fL;local gc=self.p;local gd=self.v;local ct=cF-gc;local ge=fO(-gb*ga)local gf=cF+(gd*ga-ct*(gb*ga+1))*ge;local gg=(gb*ga*(ct*gb-gd)+gd)*ge;self.p=gf;self.v=gg;return gf end;function bw:Reset(g9)self.p=g9;self.v=g9*0 end end;local gh=Vector3.new()local gi=Vector2.new()local gj=0;local gk=bw.new(g5,Vector3.new())local gl=bw.new(g6,Vector2.new())local gm=bw.new(g7,0)local gn={}do local go;do local gp=2.0;local gq=0.15;local function gr(bU)return(fO(gp*bU)-1)/(fO(gp)-1)end;local function gs(bU)return gr((bU-gq)/(1-gq))end;function go(bU)return fQ(bU)*fN(gs(fM(bU)),0,1)end end;local gt={ButtonX=0,ButtonY=0,DPadDown=0,DPadUp=0,ButtonL2=0,ButtonR2=0,Thumbstick1=Vector2.new(),Thumbstick2=Vector2.new()}local gu={W=0,A=0,S=0,D=0,E=0,Q=0,U=0,H=0,J=0,K=0,I=0,Y=0,Up=0,Down=0,LeftShift=0,RightShift=0}local gv={Delta=Vector2.new(),MouseWheel=0}local gw=Vector3.new(1,1,1)local gx=Vector3.new(1,1,1)local gy=Vector2.new(1,1)*fL/64;local gz=Vector2.new(1,1)*fL/8;local gA=1.0;local gB=0.25;local gC=0.75;local gD=0.25;local gE=1;function gn.Vel(ga)gE=fN(gE+ga*(gu.Up-gu.Down)*gC,0.01,4)local gF=Vector3.new(go(gt.Thumbstick1.X),go(gt.ButtonR2)-go(gt.ButtonL2),go(-gt.Thumbstick1.Y))*gw;local gG=Vector3.new(gu.D-gu.A+gu.K-gu.H,gu.E-gu.Q+gu.I-gu.Y,gu.S-gu.W+gu.J-gu.U)*gx;local gH=bx:IsKeyDown(Enum.KeyCode.LeftShift)or bx:IsKeyDown(Enum.KeyCode.RightShift)return(gF+gG)*gE*(gH and gD or 1)end;function gn.Pan(ga)local gF=Vector2.new(go(gt.Thumbstick2.Y),go(-gt.Thumbstick2.X))*gz;local gI=gv.Delta*gy/(ga*60)gv.Delta=Vector2.new()return gF+gI end;function gn.Fov(ga)local gF=(gt.ButtonX-gt.ButtonY)*gB;local gI=gv.MouseWheel*gA;gv.MouseWheel=0;return gF+gI end;do local function gJ(aR,F,bV)gu[bV.KeyCode.Name]=F==Enum.UserInputState.Begin and 1 or 0;return Enum.ContextActionResult.Sink end;local function gK(aR,F,bV)gt[bV.KeyCode.Name]=F==Enum.UserInputState.Begin and 1 or 0;return Enum.ContextActionResult.Sink end;local function gL(aR,F,bV)local gM=bV.Delta;gv.Delta=Vector2.new(-gM.y,-gM.x)return Enum.ContextActionResult.Sink end;local function gN(aR,F,bV)gt[bV.KeyCode.Name]=bV.Position;return Enum.ContextActionResult.Sink end;local function gO(aR,F,bV)gt[bV.KeyCode.Name]=bV.Position.z;return Enum.ContextActionResult.Sink end;local function gP(aR,F,bV)gv[bV.UserInputType.Name]=-bV.Position.z;return Enum.ContextActionResult.Sink end;local function gQ(ek)for gR,bM in pairs(ek)do ek[gR]=bM*0 end end;function gn.StartCapture()fT:BindActionAtPriority(g0 .."FreecamKeyboard",gJ,false,fZ,Enum.KeyCode.W,Enum.KeyCode.A,Enum.KeyCode.S,Enum.KeyCode.D,Enum.KeyCode.E,Enum.KeyCode.Q,Enum.KeyCode.Up,Enum.KeyCode.Down)fT:BindActionAtPriority(g0 .."FreecamMousePan",gL,false,fZ,Enum.UserInputType.MouseMovement)fT:BindActionAtPriority(g0 .."FreecamMouseWheel",gP,false,fZ,Enum.UserInputType.MouseWheel)fT:BindActionAtPriority(g0 .."FreecamGamepadButton",gK,false,fZ,Enum.KeyCode.ButtonX,Enum.KeyCode.ButtonY)fT:BindActionAtPriority(g0 .."FreecamGamepadTrigger",gO,false,fZ,Enum.KeyCode.ButtonR2,Enum.KeyCode.ButtonL2)fT:BindActionAtPriority(g0 .."FreecamGamepadThumbstick",gN,false,fZ,Enum.KeyCode.Thumbstick1,Enum.KeyCode.Thumbstick2)end;function gn.StopCapture()gE=1;gQ(gt)gQ(gu)gQ(gv)fT:UnbindAction(g0 .."FreecamKeyboard")fT:UnbindAction(g0 .."FreecamMousePan")fT:UnbindAction(g0 .."FreecamMouseWheel")fT:UnbindAction(g0 .."FreecamGamepadButton")fT:UnbindAction(g0 .."FreecamGamepadTrigger")fT:UnbindAction(g0 .."FreecamGamepadThumbstick")end end end;local function gS(gT)local gU=0.1;local gV=fW.ViewportSize;local gW=2*fS(gj/2)local gX=gV.x/gV.y*gW;local gY=gT.rightVector;local gZ=gT.upVector;local g_=gT.lookVector;local h0=Vector3.new()local h1=512;for bU=0,1,0.5 do for ed=0,1,0.5 do local h2=(bU-0.5)*gX;local h3=(ed-0.5)*gW;local ct=gY*h2-gZ*h3+g_;local h4=gT.p+ct*gU;local ev,h5=n:FindPartOnRay(Ray.new(h4,ct.unit*h1))local h6=(h5-h4).magnitude;if h1>h6 then h1=h6;h0=ct.unit end end end;return g_:Dot(h0)*h1 end;local function h7(ga)local h8=gk:Update(ga,gn.Vel(ga))local h9=gl:Update(ga,gn.Pan(ga))local ha=gm:Update(ga,gn.Fov(ga))local hb=fR(fS(fP(70/2))/fS(fP(gj/2)))gj=fN(gj+ha*g3*ga/hb,1,120)gi=gi+h9*g2*ga/hb;gi=Vector2.new(fN(gi.x,-g4,g4),gi.y%(2*fL))local fs=CFrame.new(gh)*CFrame.fromOrientation(gi.x,gi.y,0)*CFrame.new(h8*g1*ga)gh=fs.p;fW.CFrame=fs;fW.Focus=fs*CFrame.new(0,0,-gS(fs))fW.FieldOfView=gj end;local hc={}do local hd;local he;local hf;local hg;local fs;local hh;local hi={}local hj={Backpack=true,Chat=true,Health=true,PlayerList=true}local hk={BadgesNotificationsActive=true,PointsNotificationsActive=true}function hc.Push()hh=fW.FieldOfView;fW.FieldOfView=70;fs=fW.CFrame;hg=fW.Focus;hd=bx.MouseBehavior;bx.MouseBehavior=Enum.MouseBehavior.Default end;function hc.Pop()fW.FieldOfView=hh;hh=nil;fW.CFrame=fs;fs=nil;fW.Focus=hg;hg=nil;bx.MouseBehavior=hd;hd=nil end end;local function hl()local fs=fW.CFrame;gi=Vector2.new(fs:toEulerAnglesYXZ())gh=fs.p;gj=fW.FieldOfView;gk:Reset(Vector3.new())gl:Reset(Vector2.new())gm:Reset(0)hc.Push()ez:BindToRenderStep(g0,Enum.RenderPriority.Camera.Value+1,h7)gn.StartCapture()end;local function hm()gn.StopCapture()ez:UnbindFromRenderStep(g0)hc.Pop()end;local eD=false;local function fK()if not eD then hl()eD=true end end;local function fJ()if eD then hm()eD=false end end;return{EnableFreecam=fK,DisableFreecam=fJ}end,newEnv("Orca.jobs.helpers.freecam"))()end)newModule("get-selected-player","ModuleScript","Orca.jobs.helpers.get-selected-player","Orca.jobs.helpers",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local dV=a.import(script,a.getModule(script,"@rbxts","services")).Players;local em=a.import(script,script.Parent,"job-store").getStore;local hn=a.async(function(bP)local eu=a.await(em())local ho={current=nil}eu.changed:connect(function(ex)local hp=ex.dashboard.apps.playerSelected;local b0=ho.current;if b0~=nil then b0=b0.Name end;if b0~=hp then ho.current=hp~=nil and dV:FindFirstChild(hp)or nil;if bP then task.defer(bP,ho.current)end end end)return ho end)return{getSelectedPlayer=hn}end,newEnv("Orca.jobs.helpers.get-selected-player"))()end)newModule("job-store","ModuleScript","Orca.jobs.helpers.job-store","Orca.jobs.helpers",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local dg=a.import(script,script.Parent.Parent.Parent,"utils","timeout").setInterval;local eu={}local function hq(hr)if eu.current then error("Store has already been set")end;eu.current=hr end;local em=a.async(function()if eu.current then return eu.current end;return a.Promise.new(function(hs,ev,ht)local dj;dj=dg(function()if eu.current then hs(eu.current)dj:clear()end end,100)ht(function()dj:clear()end)end)end)local hu;local eA=a.async(function(hv,da)local eu=a.await(em())local hw=eu:getState().jobs[hv]return eu.changed:connect(function(ex)local eM=ex.jobs[hv]if not hu(eM,hw)then hw=eM;task.defer(da,eM,ex)end end)end)function hu(hx,dG)for ej in pairs(hx)do if hx[ej]~=dG[ej]then return false end end;return true end;return{setStore=hq,getStore=em,onJobChange=eA}end,newEnv("Orca.jobs.helpers.job-store"))()end)newInstance("players","Folder","Orca.jobs.players","Orca.jobs")newModule("hide","LocalScript","Orca.jobs.players.hide","Orca.jobs.players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local dV=a.import(script,a.getModule(script,"@rbxts","services")).Players;local hn=a.import(script,script.Parent.Parent,"helpers","get-selected-player").getSelectedPlayer;local f6=a.import(script,script.Parent.Parent,"helpers","job-store")local em=f6.getStore;local eA=f6.onJobChange;local aP=a.import(script,script.Parent.Parent.Parent,"store","actions","jobs.action").setJobActive;local hy={}local function hz(eB)if hy[eB]~=nil then return nil end;local eT=eB.Character;local hA;hA={character=eT,parent=eT.Parent,handle=eB.CharacterAdded:Connect(function(fH)fH.Parent=nil;hA.character=eT end)}hy[eB]=hA;eT.Parent=nil end;local function hB(eB,hC)if not(hy[eB]~=nil)then return nil end;local hA=hy[eB]if hC then hA.character.Parent=hA.parent end;hA.handle:Disconnect()hy[eB]=nil end;local et=a.async(function()local eu=a.await(em())local ho=a.await(hn(function(eB)local hD=eu;local b0;if eB then b0=hy[eB]~=nil else b0=false end;hD:dispatch(aP("hide",b0))end))dV.PlayerRemoving:Connect(function(eB)if eB==ho.current then eu:dispatch(aP("hide",false))else hB(eB,false)end end)a.await(eA("hide",function(eM)local eB=ho.current;if not eB then eu:dispatch(aP("hide",false))return nil end;if eM.active and eB.Character then hz(eB)elseif not eM.active then hB(eB,true)end end))end)et():catch(function(dw)warn("[hide-worker] "..tostring(dw))end)end,newEnv("Orca.jobs.players.hide"))()end)newModule("kill","LocalScript","Orca.jobs.players.kill","Orca.jobs.players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local ey=a.import(script,a.getModule(script,"@rbxts","services"))local dV=ey.Players;local n=ey.Workspace;local hn=a.import(script,script.Parent.Parent,"helpers","get-selected-player").getSelectedPlayer;local f6=a.import(script,script.Parent.Parent,"helpers","job-store")local em=f6.getStore;local eA=f6.onJobChange;local aP=a.import(script,script.Parent.Parent.Parent,"store","actions","jobs.action").setJobActive;local eB=dV.LocalPlayer;local hE=a.async(function(hF)local hG=eB:FindFirstChildWhichIsA("Backpack")if not hG then error("No inventory found")end;local hH=eB.Character;local hI=hF.Character;if not hH or not hI then error("Victim or local player has no character")end;local hJ=hH:FindFirstChildWhichIsA("Humanoid")local hK=hH:FindFirstChild("HumanoidRootPart")local hL=hI:FindFirstChild("HumanoidRootPart")if not hJ or(not hK or not hL)then error("Victim or local player has no Humanoid or root part")end;local dk={}local bf=#dk;local hM=hH:GetChildren()local hN=#hM;table.move(hM,1,hN,bf+1,dk)bf=bf+hN;local hO=hG:GetChildren()table.move(hO,1,#hO,bf+1,dk)local y=function(hP)return hP:IsA("Tool")and hP:FindFirstChild("Handle")~=nil end;local b0=nil;for e5,aw in ipairs(dk)do if y(aw,e5-1,dk)==true then b0=aw;break end end;local hQ=b0;if not hQ then error("A tool with a handle is required to kill this victim")end;hJ.Name=""local ft=hJ:Clone()ft.DisplayName=utf8.char(128298)ft.Parent=hH;ft.Name="Humanoid"task.wait()hJ:Destroy()n.CurrentCamera.CameraSubject=ft;hQ.Parent=hH;do local hR=0;local hS=false;while true do if hS then hR=hR+1 else hS=true end;if not(hR<250)then break end;if hL.Parent~=hI or hK.Parent~=hH then error("Victim or local player has no root part; did a player respawn?")end;if hQ.Parent~=hH then return hK end;hK.CFrame=hL.CFrame;task.wait(0.1)end end;error("Failed to attach to victim")end)local hT=a.async(function(hF)local eu=a.await(em())local hU=eB.Character;if hU~=nil then hU=hU:FindFirstChild("HumanoidRootPart")end;local hV=hU;local b0=hV;if b0~=nil then b0=b0:IsA("BasePart")end;local u=b0 and hV.CFrame or nil;eu:dispatch(aP("refresh",true))a.await(a.Promise.fromEvent(eB.CharacterAdded,function(eT)return eT:WaitForChild("HumanoidRootPart",5)~=nil end))task.wait(0.3)local fg=a.await(hE(hF))local U={hF.Character,eB.Character}local hI=U[1]local hH=U[2]repeat do task.wait(0.1)fg.CFrame=CFrame.new(1000000,n.FallenPartsDestroyHeight+5,1000000)end;local b1=hI;if b1~=nil then b1=b1:FindFirstChild("HumanoidRootPart")end;local b2=b1~=nil;if b2 then local fn=hH;if fn~=nil then fn=fn:FindFirstChild("HumanoidRootPart")end;b2=fn~=nil end until not b2;local fH=a.await(a.Promise.fromEvent(eB.CharacterAdded,function(eT)return eT:WaitForChild("HumanoidRootPart",5)~=nil end))if u then fH.HumanoidRootPart.CFrame=u end end)local et=a.async(function()local eu=a.await(em())local ho=a.await(hn())a.await(eA("kill",function(eM)if eM.active then if not ho.current then eu:dispatch(aP("kill",false))return nil end;hT(ho.current):catch(function(dw)return warn("[kill-worker] "..tostring(dw))end):finally(function()return eu:dispatch(aP("kill",false))end)end end))end)et():catch(function(dw)warn("[kill-worker] "..tostring(dw))end)end,newEnv("Orca.jobs.players.kill"))()end)newModule("spectate","LocalScript","Orca.jobs.players.spectate","Orca.jobs.players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local n=a.import(script,a.getModule(script,"@rbxts","services")).Workspace;local hn=a.import(script,script.Parent.Parent,"helpers","get-selected-player").getSelectedPlayer;local f6=a.import(script,script.Parent.Parent,"helpers","job-store")local em=f6.getStore;local eA=f6.onJobChange;local aP=a.import(script,script.Parent.Parent.Parent,"store","actions","jobs.action").setJobActive;local et=a.async(function()local eu=a.await(em())local ho=a.await(hn(function()eu:dispatch(aP("spectate",false))end))local hW=false;local hX;local hY;local function hZ(dR)dR:GetPropertyChangedSignal("CameraSubject"):Connect(function()if hX~=dR.CameraSubject and eu:getState().jobs.spectate.active then hW=false;eu:dispatch(aP("spectate",false))end end)end;n:GetPropertyChangedSignal("CurrentCamera"):Connect(function()hZ(n.CurrentCamera)end)hZ(n.CurrentCamera)a.await(eA("spectate",function(eM)local dR=n.CurrentCamera;if eM.active then local h_=ho.current;if h_~=nil then h_=h_.Character;if h_~=nil then h_=h_:FindFirstChildWhichIsA("Humanoid")end end;local i0=h_;if not i0 then eu:dispatch(aP("spectate",false))else hW=true;hY=dR.CameraSubject;hX=i0;dR.CameraSubject=i0 end elseif hW then hW=false;dR.CameraSubject=hY;hY=nil;hX=nil end end))end)et():catch(function(dw)warn("[spectate-worker] "..tostring(dw))end)end,newEnv("Orca.jobs.players.spectate"))()end)newModule("teleport","LocalScript","Orca.jobs.players.teleport","Orca.jobs.players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local dV=a.import(script,a.getModule(script,"@rbxts","services")).Players;local hn=a.import(script,script.Parent.Parent,"helpers","get-selected-player").getSelectedPlayer;local f6=a.import(script,script.Parent.Parent,"helpers","job-store")local em=f6.getStore;local eA=f6.onJobChange;local aP=a.import(script,script.Parent.Parent.Parent,"store","actions","jobs.action").setJobActive;local cX=a.import(script,script.Parent.Parent.Parent,"utils","timeout").setTimeout;local et=a.async(function()local eu=a.await(em())local ho=a.await(hn(function()eu:dispatch(aP("teleport",false))end))local ew;a.await(eA("teleport",function(eM)local b0=ew;if b0~=nil then b0:clear()end;ew=nil;if eM.active then local i1=dV.LocalPlayer.Character;if i1~=nil then i1=i1:FindFirstChild("HumanoidRootPart")end;local fg=i1;local i2=ho.current;if i2~=nil then i2=i2.Character;if i2~=nil then i2=i2:FindFirstChild("HumanoidRootPart")end end;local i3=i2;if not i3 or(not fg or(not fg:IsA("BasePart")or not i3:IsA("BasePart")))then eu:dispatch(aP("teleport",false))warn("[teleport-worker] Failed to find root parts ("..tostring(fg).." -> "..tostring(i3)..")")return nil end;ew=cX(function()eu:dispatch(aP("teleport",false))local a6=i3.CFrame;local a7=CFrame.new(0,0,1)fg.CFrame=a6*a7 end,1000)end end))end)et():catch(function(dw)warn("[teleport-worker] "..tostring(dw))end)end,newEnv("Orca.jobs.players.teleport"))()end)newModule("server","LocalScript","Orca.jobs.server","Orca.jobs",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ey=a.import(script,a.getModule(script,"@rbxts","services"))local i4=ey.HttpService;local dV=ey.Players;local i5=ey.TeleportService;local f6=a.import(script,script.Parent,"helpers","job-store")local em=f6.getStore;local eA=f6.onJobChange;local aP=a.import(script,script.Parent.Parent,"store","actions","jobs.action").setJobActive;local i6=a.import(script,script.Parent.Parent,"utils","http")local cX=a.import(script,script.Parent.Parent,"utils","timeout").setTimeout;local i7;local i8=a.async(function()i7()local i9=i4:JSONDecode(a.await(i6.get("https://games.roblox.com/v1/games/"..tostring(game.PlaceId).."/servers/Public?sortOrder=Asc&limit=100")))local ia=i9.data;local y=function(ib)return ib.playing<ib.maxPlayers and ib.id~=game.JobId end;local e1={}local bf=0;for av,aw in ipairs(ia)do if y(aw,av-1,ia)==true then bf=bf+1;e1[bf]=aw end end;local ic=e1;if#ic==0 then error("[server-worker-switch] No servers available.")else local ib=ic[math.random(#ic-1)+1]i5:TeleportToPlaceInstance(game.PlaceId,ib.id)end end)local id=a.async(function()i7()if#dV:GetPlayers()==1 then i5:Teleport(game.PlaceId,dV.LocalPlayer)else i5:TeleportToPlaceInstance(game.PlaceId,game.JobId)end end)function i7()local ie={string.match(VERSION,"^.+%..+%..+$")}~=nil;local f4=ie and'loadstring(game:HttpGetAsync("https://raw.githubusercontent.com/richie0866/orca/master/public/latest.lua"))()'or'loadstring(game:HttpGetAsync("https://raw.githubusercontent.com/richie0866/orca/master/public/snapshot.lua"))()'local b0=syn;if b0~=nil then b0=b0.queue_on_teleport end;local b2=b0;if b2==nil then b2=queue_on_teleport end;local b1=b2;if b1~=nil then b1(f4)end end;local et=a.async(function()local eu=a.await(em())local ew;local function cW()local b0=ew;if b0~=nil then b0:clear()end;ew=nil end;a.await(eA("rejoinServer",function(eM,F)cW()if F.jobs.switchServer.active then aP("switchServer",false)end;if eM.active then ew=cX(function()id():catch(function(dw)warn("[server-worker-rejoin] "..tostring(dw))eu:dispatch(aP("rejoinServer",false))end)end,1000)end end))a.await(eA("switchServer",function(eM,F)cW()if F.jobs.rejoinServer.active then aP("rejoinServer",false)end;if eM.active then ew=cX(function()i8():catch(function(dw)warn("[server-worker-switch] "..tostring(dw))eu:dispatch(aP("switchServer",false))end)end,1000)end end))end)et():catch(function(dw)warn("[server-worker] "..tostring(dw))end)end,newEnv("Orca.jobs.server"))()end)newModule("main","LocalScript","Orca.main","Orca",function()return setfenv(function()local a=require(script.Parent.include.RuntimeLib)local ap=a.import(script,a.getModule(script,"@rbxts","make"))local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local ah=a.import(script,a.getModule(script,"@rbxts","roact-rodux-hooked").out).Provider;local dV=a.import(script,a.getModule(script,"@rbxts","services")).Players;local cv=a.import(script,script.Parent,"constants").IS_DEV;local hq=a.import(script,script.Parent,"jobs").setStore;local ig=a.import(script,script.Parent,"store","actions","dashboard.action").toggleDashboard;local aj=a.import(script,script.Parent,"store","store").configureStore;local e=a.import(script,script.Parent,"App").default;local eu=aj()hq(eu)local ih=a.async(function()local ii=ap("Folder",{})b.mount(b.createElement(ah,{store=eu},{b.createElement(e)}),ii)return ii:WaitForChild(1)end)local function ij(ik)local il=syn and syn.protect_gui or protect_gui;if il then il(ik)end;if cv then ik.Parent=dV.LocalPlayer:WaitForChild("PlayerGui")elseif gethui then ik.Parent=gethui()else ik.Parent=game:GetService("CoreGui")end end;local et=a.async(function()if getgenv and getgenv()._ORCA_IS_LOADED~=nil then error("Orca is already loaded!")end;local ik=a.await(ih())ij(ik)if time()>3 then task.defer(function()return eu:dispatch(ig())end)end;if getgenv then getgenv()._ORCA_IS_LOADED=true end end)et():catch(function(dw)warn("Orca failed to load: "..tostring(dw))end)end,newEnv("Orca.main"))()end)newInstance("store","Folder","Orca.store","Orca")newInstance("actions","Folder","Orca.store.actions","Orca.store")newModule("dashboard.action","ModuleScript","Orca.store.actions.dashboard.action","Orca.store.actions",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local im=a.import(script,a.getModule(script,"@rbxts","rodux").src)local io=im.makeActionCreator("dashboard/setDashboardPage",function(c3)return{page=c3}end)local ig=im.makeActionCreator("dashboard/toggleDashboard",function()return{}end)local aO=im.makeActionCreator("dashboard/setHint",function(aS)return{hint=aS}end)local aN=im.makeActionCreator("dashboard/clearHint",function()return{}end)local ho=im.makeActionCreator("dashboard/playerSelected",function(eB)return{name=eB.Name}end)local ip=im.makeActionCreator("dashboard/playerDeselected",function()return{}end)return{setDashboardPage=io,toggleDashboard=ig,setHint=aO,clearHint=aN,playerSelected=ho,playerDeselected=ip}end,newEnv("Orca.store.actions.dashboard.action"))()end)newModule("jobs.action","ModuleScript","Orca.store.actions.jobs.action","Orca.store.actions",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local im=a.import(script,a.getModule(script,"@rbxts","rodux").src)local aP=im.makeActionCreator("jobs/setJobActive",function(hv,aX)return{jobName=hv,active=aX}end)local iq=im.makeActionCreator("jobs/setJobValue",function(hv,d3)return{jobName=hv,value=d3}end)return{setJobActive=aP,setJobValue=iq}end,newEnv("Orca.store.actions.jobs.action"))()end)newModule("options.action","ModuleScript","Orca.store.actions.options.action","Orca.store.actions",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local im=a.import(script,a.getModule(script,"@rbxts","rodux").src)local ir=im.makeActionCreator("options/setConfig",function(hp,aX)return{name=hp,active=aX}end)local is=im.makeActionCreator("options/setShortcut",function(it,iu)return{shortcut=it,keycode=iu}end)local iv=im.makeActionCreator("options/removeShortcut",function(it)return{shortcut=it}end)local iw=im.makeActionCreator("options/setTheme",function(aT)return{theme=aT}end)return{setConfig=ir,setShortcut=is,removeShortcut=iv,setTheme=iw}end,newEnv("Orca.store.actions.options.action"))()end)newInstance("models","Folder","Orca.store.models","Orca.store")newModule("dashboard.model","ModuleScript","Orca.store.models.dashboard.model","Orca.store.models",function()return setfenv(function()local ai;do local cf={}ai=setmetatable({},{__index=cf})ai.Home="home"cf.home="Home"ai.Apps="apps"cf.apps="Apps"ai.Scripts="scripts"cf.scripts="Scripts"ai.Options="options"cf.options="Options"end;local ix={[ai.Home]=0,[ai.Apps]=1,[ai.Scripts]=2,[ai.Options]=3}local iy={[ai.Home]="rbxassetid://8992031167",[ai.Apps]="rbxassetid://8992031246",[ai.Scripts]="rbxassetid://8992030918",[ai.Options]="rbxassetid://8992031056"}return{DashboardPage=ai,PAGE_TO_INDEX=ix,PAGE_TO_ICON=iy}end,newEnv("Orca.store.models.dashboard.model"))()end)newModule("jobs.model","ModuleScript","Orca.store.models.jobs.model","Orca.store.models",function()return setfenv(function()end,newEnv("Orca.store.models.jobs.model"))()end)newModule("options.model","ModuleScript","Orca.store.models.options.model","Orca.store.models",function()return setfenv(function()end,newEnv("Orca.store.models.options.model"))()end)newModule("persistent-state","ModuleScript","Orca.store.persistent-state","Orca.store",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ey=a.import(script,a.getModule(script,"@rbxts","services"))local i4=ey.HttpService;local dV=ey.Players;local em=a.import(script,script.Parent.Parent,"jobs","helpers","job-store").getStore;local dg=a.import(script,script.Parent.Parent,"utils","timeout").setInterval;if makefolder and not isfolder("_orca")then makefolder("_orca")end;local function iz(iA)if readfile then return isfile(iA)and readfile(iA)or nil else print("READ   "..iA)return nil end end;local function iB(iA,iC)if writefile then return writefile(iA,iC)else print("WRITE  "..iA.." => \n"..iC)return nil end end;local iD;local function iE(hp,iF,iG)local iH,iI=a.try(function()local iJ=iz("_orca/"..hp..".json")if iJ==nil then iB("_orca/"..hp..".json",i4:JSONEncode(iG))return a.TRY_RETURN,{iG}end;local d3=i4:JSONDecode(iJ)iD(hp,iF):catch(function()warn("Autosave failed")end)return a.TRY_RETURN,{d3}end,function(dw)warn("Failed to load "..hp..".json: "..tostring(dw))return a.TRY_RETURN,{iG}end)if iH then return unpack(iI)end end;iD=a.async(function(hp,iF)local eu=a.await(em())local function iK()local F=iF(eu:getState())iB("_orca/"..hp..".json",i4:JSONEncode(F))end;dg(function()return iK end,60000)dV.PlayerRemoving:Connect(function(eB)if eB==dV.LocalPlayer then iK()end end)end)return{persistentState=iE}end,newEnv("Orca.store.persistent-state"))()end)newInstance("reducers","Folder","Orca.store.reducers","Orca.store")newModule("dashboard.reducer","ModuleScript","Orca.store.reducers.dashboard.reducer","Orca.store.reducers",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local im=a.import(script,a.getModule(script,"@rbxts","rodux").src)local ai=a.import(script,script.Parent.Parent,"models","dashboard.model").DashboardPage;local dB={page=ai.Home,isOpen=false,hint=nil,apps={playerSelected=nil}}local iL=im.createReducer(dB,{["dashboard/setDashboardPage"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;as.page=aR.page;return as end,["dashboard/toggleDashboard"]=function(F)local as={}for av,aw in pairs(F)do as[av]=aw end;as.isOpen=not F.isOpen;return as end,["dashboard/setHint"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;as.hint=aR.hint;return as end,["dashboard/clearHint"]=function(F)local as={}for av,aw in pairs(F)do as[av]=aw end;as.hint=nil;return as end,["dashboard/playerSelected"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;local at="apps"local au={}for av,aw in pairs(F.apps)do au[av]=aw end;au.playerSelected=aR.name;as[at]=au;return as end,["dashboard/playerDeselected"]=function(F)local as={}for av,aw in pairs(F)do as[av]=aw end;local at="apps"local au={}for av,aw in pairs(F.apps)do au[av]=aw end;au.playerSelected=nil;as[at]=au;return as end})return{dashboardReducer=iL}end,newEnv("Orca.store.reducers.dashboard.reducer"))()end)newModule("jobs.reducer","ModuleScript","Orca.store.reducers.jobs.reducer","Orca.store.reducers",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local im=a.import(script,a.getModule(script,"@rbxts","rodux").src)local dB={flight={value=60,active=false},walkSpeed={value=80,active=false},jumpHeight={value=200,active=false},refresh={active=false},ghost={active=false},godmode={active=false},freecam={active=false},teleport={active=false},hide={active=false},kill={active=false},spectate={active=false},rejoinServer={active=false},switchServer={active=false}}local iM=im.createReducer(dB,{["jobs/setJobActive"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;local at=aR.jobName;local au={}for av,aw in pairs(F[aR.jobName])do au[av]=aw end;au.active=aR.active;as[at]=au;return as end,["jobs/setJobValue"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;local at=aR.jobName;local au={}for av,aw in pairs(F[aR.jobName])do au[av]=aw end;au.value=aR.value;as[at]=au;return as end})return{jobsReducer=iM}end,newEnv("Orca.store.reducers.jobs.reducer"))()end)newModule("options.reducer","ModuleScript","Orca.store.reducers.options.reducer","Orca.store.reducers",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local im=a.import(script,a.getModule(script,"@rbxts","rodux").src)local iE=a.import(script,script.Parent.Parent,"persistent-state").persistentState;local dB=iE("options",function(F)return F.options end,{currentTheme="Sorbet",config={acrylicBlur=true},shortcuts={toggleDashboard=Enum.KeyCode.K.Value}})local iN=im.createReducer(dB,{["options/setConfig"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;local at="config"local au={}for av,aw in pairs(F.config)do au[av]=aw end;au[aR.name]=aR.active;as[at]=au;return as end,["options/setTheme"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;as.currentTheme=aR.theme;return as end,["options/setShortcut"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;local at="shortcuts"local au={}for av,aw in pairs(F.shortcuts)do au[av]=aw end;au[aR.shortcut]=aR.keycode;as[at]=au;return as end,["options/removeShortcut"]=function(F,aR)local as={}for av,aw in pairs(F)do as[av]=aw end;local at="shortcuts"local au={}for av,aw in pairs(F.shortcuts)do au[av]=aw end;au[aR.shortcut]=nil;as[at]=au;return as end})return{optionsReducer=iN}end,newEnv("Orca.store.reducers.options.reducer"))()end)newModule("store","ModuleScript","Orca.store.store","Orca.store",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local im=a.import(script,a.getModule(script,"@rbxts","rodux").src)local iL=a.import(script,script.Parent,"reducers","dashboard.reducer").dashboardReducer;local iM=a.import(script,script.Parent,"reducers","jobs.reducer").jobsReducer;local iN=a.import(script,script.Parent,"reducers","options.reducer").optionsReducer;local iO=im.combineReducers({dashboard=iL,jobs=iM,options=iN})local function aj(dB)return im.Store.new(iO,dB)end;return{configureStore=aj}end,newEnv("Orca.store.store"))()end)newModule("themes","ModuleScript","Orca.themes","Orca",function()return setfenv(function()local a=require(script.Parent.include.RuntimeLib)local eh=a.import(script,script,"dark-theme").darkTheme;local iP=a.import(script,script,"frosted-glass").frostedGlass;local iQ=a.import(script,script,"high-contrast").highContrast;local iR=a.import(script,script,"light-theme").lightTheme;local iS=a.import(script,script,"obsidian").obsidian;local iT=a.import(script,script,"sorbet").sorbet;local iU={iT,eh,iR,iP,iS,iQ}local function eg()return iU end;return{getThemes=eg}end,newEnv("Orca.themes"))()end)newModule("dark-theme","ModuleScript","Orca.themes.dark-theme","Orca.themes",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local eh={name="Dark theme",preview={foreground={color=ColorSequence.new(ak("#ffffff"))},background={color=ColorSequence.new(ak("#232428"))},accent={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))}),rotation=25}},navbar={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,accentGradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#f629c6")),ColorSequenceKeypoint.new(0.25,ak("#F64229")),ColorSequenceKeypoint.new(0.5,ak("#ffd42a")),ColorSequenceKeypoint.new(0.75,ak("#37CC95")),ColorSequenceKeypoint.new(1,ak("#3789cc"))})},dropshadow=ak("#232428"),dropshadowTransparency=0.3,glowTransparency=0},clock={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,dropshadow=ak("#232428"),dropshadowTransparency=0.3},home={title={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#ffffff"),backgroundGradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))}),rotation=25},transparency=0,dropshadow=ak("#ffffff"),dropshadowGradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))}),rotation=25},dropshadowTransparency=0.3},profile={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,dropshadow=ak("#232428"),dropshadowTransparency=0.3,avatar={background=ak("#1B1C20"),gradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))}),rotation=25},transparency=0},button={outlined=true,foreground=ak("#ffffff"),foregroundTransparency=0.5,background=ak("#1B1C20"),backgroundTransparency=0},slider={outlined=true,foreground=ak("#ffffff"),foregroundTransparency=0,background=ak("#1B1C20"),backgroundTransparency=0},highlight={flight=ak("#a22df0"),walkSpeed=ak("#EC423D"),jumpHeight=ak("#37CC95"),refresh=ak("#a22df0"),ghost=ak("#FF4040"),godmode=ak("#f09c2d"),freecam=ak("#37CC95")}},server={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#37CC95"),transparency=0,dropshadow=ak("#37CC95"),dropshadowTransparency=0.3,rejoinButton={outlined=true,foreground=ak("#ffffff"),background=ak("#37CC95"),accent=ak("#232428"),foregroundTransparency=0,backgroundTransparency=0},switchButton={outlined=true,foreground=ak("#ffffff"),background=ak("#37CC95"),accent=ak("#232428"),foregroundTransparency=0,backgroundTransparency=0}},friendActivity={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,dropshadow=ak("#232428"),dropshadowTransparency=0.3,friendButton={outlined=true,accent=ak("#37CC95"),foreground=ak("#ffffff"),foregroundTransparency=0,background=ak("#1B1C20"),backgroundTransparency=0,dropshadow=ak("#000000"),dropshadowTransparency=0.4,glowTransparency=0.6}}},apps={players={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,dropshadow=ak("#232428"),dropshadowTransparency=0.3,avatar={background=ak("#1B1C20"),gradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#37CC95")),ColorSequenceKeypoint.new(1,ak("#37CC95"))}),rotation=25},transparency=0},button={outlined=true,foreground=ak("#ffffff"),foregroundTransparency=0.5,background=ak("#1B1C20"),backgroundTransparency=0},highlight={teleport=ak("#37CC95"),hide=ak("#f09c2d"),kill=ak("#EC423D"),spectate=ak("#a22df0")},playerButton={outlined=true,accent=ak("#37CC95"),foreground=ak("#ffffff"),foregroundTransparency=0.5,background=ak("#1B1C20"),backgroundTransparency=0,dropshadow=ak("#000000"),dropshadowTransparency=0.5,glowTransparency=0.2}}},options={themes={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,dropshadow=ak("#232428"),dropshadowTransparency=0.3,themeButton={outlined=true,accent=ak("#37a4cc"),foreground=ak("#ffffff"),foregroundTransparency=0.5,background=ak("#1B1C20"),backgroundTransparency=0,dropshadow=ak("#000000"),dropshadowTransparency=0.5,glowTransparency=0.2}},shortcuts={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,dropshadow=ak("#232428"),dropshadowTransparency=0.3,shortcutButton={outlined=true,accent=ak("#37CC95"),foreground=ak("#ffffff"),foregroundTransparency=0.5,background=ak("#1B1C20"),backgroundTransparency=0,dropshadow=ak("#000000"),dropshadowTransparency=0.5,glowTransparency=0.2}},config={outlined=true,acrylic=false,foreground=ak("#ffffff"),background=ak("#232428"),transparency=0,dropshadow=ak("#232428"),dropshadowTransparency=0.3,configButton={outlined=true,accent=ak("#37CC95"),foreground=ak("#ffffff"),foregroundTransparency=0.5,background=ak("#1B1C20"),backgroundTransparency=0,dropshadow=ak("#000000"),dropshadowTransparency=0.5,glowTransparency=0.2}}}}return{darkTheme=eh}end,newEnv("Orca.themes.dark-theme"))()end)newModule("frosted-glass","ModuleScript","Orca.themes.frosted-glass","Orca.themes",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local eh=a.import(script,script.Parent,"dark-theme").darkTheme;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local a_=ak("#000000")local iV=ColorSequence.new(ak("#000000"))local iW={acrylic=true,outlined=true,foreground=ak("#ffffff"),background=ak("#ffffff"),backgroundGradient=nil,transparency=0.9,dropshadow=ak("#ffffff"),dropshadowTransparency=0,dropshadowGradient={color=ColorSequence.new(ak("#000000")),transparency=NumberSequence.new(1,0.8),rotation=90}}local as={}for av,aw in pairs(eh)do as[av]=aw end;as.name="Frosted glass"as.preview={foreground={color=ColorSequence.new(ak("#ffffff"))},background={color=ColorSequence.new(ak("#ffffff"))},accent={color=iV}}local at="navbar"local au={}for av,aw in pairs(eh.navbar)do au[av]=aw end;au.outlined=true;au.acrylic=true;au.foreground=ak("#ffffff")au.background=ak("#ffffff")au.backgroundGradient=nil;au.transparency=0.9;au.dropshadow=ak("#000000")au.dropshadowTransparency=0.2;au.accentGradient={color=ColorSequence.new(ak("#ffffff")),transparency=NumberSequence.new(0.8),rotation=90}au.glowTransparency=0.5;as[at]=au;as.clock={outlined=true,acrylic=true,foreground=ak("#ffffff"),background=ak("#ffffff"),backgroundGradient=nil,transparency=0.9,dropshadow=ak("#000000"),dropshadowTransparency=0.2}local iX="home"local ay={}local iY="title"local aA={}for av,aw in pairs(iW)do aA[av]=aw end;ay[iY]=aA;local iZ="profile"local aC={}for av,aw in pairs(iW)do aC[av]=aw end;local i_="avatar"local aE={}for av,aw in pairs(eh.home.profile.avatar)do aE[av]=aw end;aE.background=ak("#ffffff")aE.transparency=0.7;aE.gradient={color=ColorSequence.new(ak("#ffffff"),ak("#ffffff")),transparency=NumberSequence.new(0.5,1),rotation=45}aC[i_]=aE;aC.highlight={flight=a_,walkSpeed=a_,jumpHeight=a_,refresh=a_,ghost=a_,godmode=a_,freecam=a_}local j0="slider"local aG={}for av,aw in pairs(eh.home.profile.slider)do aG[av]=aw end;aG.outlined=false;aG.foreground=ak("#ffffff")aG.background=ak("#ffffff")aG.backgroundTransparency=0.8;aG.indicatorTransparency=0.3;aC[j0]=aG;local j1="button"local j2={}for av,aw in pairs(eh.home.profile.button)do j2[av]=aw end;j2.outlined=false;j2.foreground=ak("#ffffff")j2.background=ak("#ffffff")j2.backgroundTransparency=0.8;aC[j1]=j2;ay[iZ]=aC;local j3="server"local j4={}for av,aw in pairs(iW)do j4[av]=aw end;local j5="rejoinButton"local j6={}for av,aw in pairs(eh.home.server.rejoinButton)do j6[av]=aw end;j6.outlined=false;j6.foreground=ak("#ffffff")j6.background=ak("#ffffff")j6.foregroundTransparency=0.5;j6.backgroundTransparency=0.8;j6.accent=a_;j4[j5]=j6;local j7="switchButton"local j8={}for av,aw in pairs(eh.home.server.switchButton)do j8[av]=aw end;j8.outlined=false;j8.foreground=ak("#ffffff")j8.background=ak("#ffffff")j8.foregroundTransparency=0.5;j8.backgroundTransparency=0.8;j8.accent=a_;j4[j7]=j8;ay[j3]=j4;local j9="friendActivity"local ja={}for av,aw in pairs(iW)do ja[av]=aw end;local jb="friendButton"local jc={}for av,aw in pairs(eh.home.friendActivity.friendButton)do jc[av]=aw end;jc.outlined=false;jc.foreground=ak("#ffffff")jc.background=ak("#ffffff")jc.dropshadow=ak("#ffffff")jc.backgroundTransparency=0.7;ja[jb]=jc;ay[j9]=ja;as[iX]=ay;local jd="apps"local je={}local jf="players"local jg={}for av,aw in pairs(iW)do jg[av]=aw end;jg.highlight={teleport=a_,hide=a_,kill=a_,spectate=a_}local jh="avatar"local ji={}for av,aw in pairs(eh.apps.players.avatar)do ji[av]=aw end;ji.background=ak("#ffffff")ji.transparency=0.7;ji.gradient={color=ColorSequence.new(ak("#ffffff"),ak("#ffffff")),transparency=NumberSequence.new(0.5,1),rotation=45}jg[jh]=ji;local jj="button"local jk={}for av,aw in pairs(eh.apps.players.button)do jk[av]=aw end;jk.outlined=false;jk.foreground=ak("#ffffff")jk.background=ak("#ffffff")jk.backgroundTransparency=0.8;jg[jj]=jk;local jl="playerButton"local jm={}for av,aw in pairs(eh.apps.players.playerButton)do jm[av]=aw end;jm.outlined=false;jm.foreground=ak("#ffffff")jm.background=ak("#ffffff")jm.dropshadow=ak("#ffffff")jm.accent=a_;jm.backgroundTransparency=0.8;jm.dropshadowTransparency=0.7;jg[jl]=jm;je[jf]=jg;as[jd]=je;local jn="options"local jo={}local jp="config"local jq={}for av,aw in pairs(iW)do jq[av]=aw end;local jr="configButton"local js={}for av,aw in pairs(eh.options.config.configButton)do js[av]=aw end;js.outlined=false;js.foreground=ak("#ffffff")js.background=ak("#ffffff")js.dropshadow=ak("#ffffff")js.accent=a_;js.backgroundTransparency=0.8;js.dropshadowTransparency=0.7;jq[jr]=js;jo[jp]=jq;local jt="shortcuts"local ju={}for av,aw in pairs(iW)do ju[av]=aw end;local jv="shortcutButton"local jw={}for av,aw in pairs(eh.options.shortcuts.shortcutButton)do jw[av]=aw end;jw.outlined=false;jw.foreground=ak("#ffffff")jw.background=ak("#ffffff")jw.dropshadow=ak("#ffffff")jw.accent=a_;jw.backgroundTransparency=0.8;jw.dropshadowTransparency=0.7;ju[jv]=jw;jo[jt]=ju;local jx="themes"local jy={}for av,aw in pairs(iW)do jy[av]=aw end;local jz="themeButton"local jA={}for av,aw in pairs(eh.options.themes.themeButton)do jA[av]=aw end;jA.outlined=false;jA.foreground=ak("#ffffff")jA.background=ak("#ffffff")jA.dropshadow=ak("#ffffff")jA.accent=a_;jA.backgroundTransparency=0.8;jA.dropshadowTransparency=0.7;jy[jz]=jA;jo[jx]=jy;as[jn]=jo;local iP=as;return{frostedGlass=iP}end,newEnv("Orca.themes.frosted-glass"))()end)newModule("high-contrast","ModuleScript","Orca.themes.high-contrast","Orca.themes",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local eh=a.import(script,script.Parent,"dark-theme").darkTheme;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local as={}for av,aw in pairs(eh)do as[av]=aw end;as.name="High contrast"as.preview={foreground={color=ColorSequence.new(ak("#ffffff"))},background={color=ColorSequence.new(ak("#000000"))},accent={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))}),rotation=25}}local at="navbar"local au={}for av,aw in pairs(eh.navbar)do au[av]=aw end;au.foreground=ak("#ffffff")au.background=ak("#000000")au.dropshadow=ak("#000000")as[at]=au;local iX="clock"local ay={}for av,aw in pairs(eh.clock)do ay[av]=aw end;ay.foreground=ak("#ffffff")ay.background=ak("#000000")ay.dropshadow=ak("#000000")as[iX]=ay;local iY="home"local aA={}local iZ="title"local aC={}for av,aw in pairs(eh.home.title)do aC[av]=aw end;aC.foreground=ak("#ffffff")aC.background=ak("#000000")aC.dropshadow=ak("#000000")aA[iZ]=aC;local i_="profile"local aE={}for av,aw in pairs(eh.home.profile)do aE[av]=aw end;aE.foreground=ak("#ffffff")aE.background=ak("#000000")aE.dropshadow=ak("#000000")local j0="avatar"local aG={}for av,aw in pairs(eh.home.profile.avatar)do aG[av]=aw end;aG.background=ak("#ffffff")aG.transparency=0.9;aG.gradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))})}aE[j0]=aG;local j1="slider"local j2={}for av,aw in pairs(eh.home.profile.slider)do j2[av]=aw end;j2.foreground=ak("#ffffff")j2.background=ak("#000000")aE[j1]=j2;local j3="button"local j4={}for av,aw in pairs(eh.home.profile.button)do j4[av]=aw end;j4.foreground=ak("#ffffff")j4.background=ak("#000000")aE[j3]=j4;aA[i_]=aE;local j5="server"local j6={}for av,aw in pairs(eh.home.server)do j6[av]=aw end;j6.foreground=ak("#ffffff")j6.background=ak("#000000")j6.dropshadow=ak("#000000")local j7="rejoinButton"local j8={}for av,aw in pairs(eh.home.server.rejoinButton)do j8[av]=aw end;j8.foreground=ak("#ffffff")j8.background=ak("#000000")j8.foregroundTransparency=0.5;j8.accent=ak("#ff3f6c")j6[j7]=j8;local j9="switchButton"local ja={}for av,aw in pairs(eh.home.server.switchButton)do ja[av]=aw end;ja.foreground=ak("#ffffff")ja.background=ak("#000000")ja.foregroundTransparency=0.5;ja.accent=ak("#ff3f6c")j6[j9]=ja;aA[j5]=j6;local jb="friendActivity"local jc={}for av,aw in pairs(eh.home.friendActivity)do jc[av]=aw end;jc.foreground=ak("#ffffff")jc.background=ak("#000000")jc.dropshadow=ak("#000000")local jd="friendButton"local je={}for av,aw in pairs(eh.home.friendActivity.friendButton)do je[av]=aw end;je.foreground=ak("#ffffff")je.background=ak("#000000")jc[jd]=je;aA[jb]=jc;as[iY]=aA;local jf="apps"local jg={}local jh="players"local ji={}for av,aw in pairs(eh.apps.players)do ji[av]=aw end;ji.foreground=ak("#ffffff")ji.background=ak("#000000")ji.dropshadow=ak("#000000")local jj="avatar"local jk={}for av,aw in pairs(eh.apps.players.avatar)do jk[av]=aw end;jk.background=ak("#ffffff")jk.transparency=0.9;jk.gradient={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))})}ji[jj]=jk;local jl="button"local jm={}for av,aw in pairs(eh.apps.players.button)do jm[av]=aw end;jm.foreground=ak("#ffffff")jm.background=ak("#000000")ji[jl]=jm;local jn="playerButton"local jo={}for av,aw in pairs(eh.apps.players.playerButton)do jo[av]=aw end;jo.foreground=ak("#ffffff")jo.background=ak("#000000")jo.accent=ak("#ff3f6c")jo.dropshadowTransparency=0.7;ji[jn]=jo;jg[jh]=ji;as[jf]=jg;local jp="options"local jq={}local jr="config"local js={}for av,aw in pairs(eh.options.config)do js[av]=aw end;js.foreground=ak("#ffffff")js.background=ak("#000000")js.dropshadow=ak("#000000")local jt="configButton"local ju={}for av,aw in pairs(eh.options.config.configButton)do ju[av]=aw end;ju.foreground=ak("#ffffff")ju.background=ak("#000000")ju.accent=ak("#ff3f6c")ju.dropshadowTransparency=0.7;js[jt]=ju;jq[jr]=js;local jv="shortcuts"local jw={}for av,aw in pairs(eh.options.shortcuts)do jw[av]=aw end;jw.foreground=ak("#ffffff")jw.background=ak("#000000")jw.dropshadow=ak("#000000")local jx="shortcutButton"local jy={}for av,aw in pairs(eh.options.shortcuts.shortcutButton)do jy[av]=aw end;jy.foreground=ak("#ffffff")jy.background=ak("#000000")jy.accent=ak("#ff3f6c")jy.dropshadowTransparency=0.7;jw[jx]=jy;jq[jv]=jw;local jz="themes"local jA={}for av,aw in pairs(eh.options.themes)do jA[av]=aw end;jA.foreground=ak("#ffffff")jA.background=ak("#000000")jA.dropshadow=ak("#000000")local jB="themeButton"local jC={}for av,aw in pairs(eh.options.themes.themeButton)do jC[av]=aw end;jC.foreground=ak("#ffffff")jC.background=ak("#000000")jC.accent=ak("#ff3f6c")jC.dropshadowTransparency=0.7;jA[jB]=jC;jq[jz]=jA;as[jp]=jq;local iQ=as;return{highContrast=iQ}end,newEnv("Orca.themes.high-contrast"))()end)newModule("light-theme","ModuleScript","Orca.themes.light-theme","Orca.themes",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local eh=a.import(script,script.Parent,"dark-theme").darkTheme;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local as={}for av,aw in pairs(eh)do as[av]=aw end;as.name="Light theme"as.preview={foreground={color=ColorSequence.new(ak("#000000"))},background={color=ColorSequence.new(ak("#ffffff"))},accent={color=ColorSequence.new({ColorSequenceKeypoint.new(0,ak("#F6BD29")),ColorSequenceKeypoint.new(0.5,ak("#F64229")),ColorSequenceKeypoint.new(1,ak("#9029F6"))}),rotation=25}}local at="navbar"local au={}for av,aw in pairs(eh.navbar)do au[av]=aw end;au.foreground=ak("#000000")au.background=ak("#ffffff")as[at]=au;local iX="clock"local ay={}for av,aw in pairs(eh.clock)do ay[av]=aw end;ay.foreground=ak("#000000")ay.background=ak("#ffffff")as[iX]=ay;local iY="home"local aA={}local iZ="title"local aC={}for av,aw in pairs(eh.home.title)do aC[av]=aw end;aC.foreground=ak("#000000")aC.background=ak("#ffffff")aA[iZ]=aC;local i_="profile"local aE={}for av,aw in pairs(eh.home.profile)do aE[av]=aw end;aE.foreground=ak("#000000")aE.background=ak("#ffffff")local j0="avatar"local aG={}for av,aw in pairs(eh.home.profile.avatar)do aG[av]=aw end;aG.background=ak("#000000")aG.transparency=0.9;aG.gradient={color=ColorSequence.new(ak("#3ce09b"))}aE[j0]=aG;local j1="slider"local j2={}for av,aw in pairs(eh.home.profile.slider)do j2[av]=aw end;j2.foreground=ak("#000000")j2.background=ak("#ffffff")aE[j1]=j2;local j3="button"local j4={}for av,aw in pairs(eh.home.profile.button)do j4[av]=aw end;j4.foreground=ak("#000000")j4.background=ak("#ffffff")aE[j3]=j4;aA[i_]=aE;local j5="server"local j6={}for av,aw in pairs(eh.home.server)do j6[av]=aw end;j6.foreground=ak("#000000")j6.background=ak("#ff3f6c")j6.dropshadow=ak("#ff3f6c")local j7="rejoinButton"local j8={}for av,aw in pairs(eh.home.server.rejoinButton)do j8[av]=aw end;j8.foreground=ak("#000000")j8.background=ak("#ff3f6c")j8.accent=ak("#ffffff")j6[j7]=j8;local j9="switchButton"local ja={}for av,aw in pairs(eh.home.server.switchButton)do ja[av]=aw end;ja.foreground=ak("#000000")ja.background=ak("#ff3f6c")ja.accent=ak("#ffffff")j6[j9]=ja;aA[j5]=j6;local jb="friendActivity"local jc={}for av,aw in pairs(eh.home.friendActivity)do jc[av]=aw end;jc.foreground=ak("#000000")jc.background=ak("#ffffff")local jd="friendButton"local je={}for av,aw in pairs(eh.home.friendActivity.friendButton)do je[av]=aw end;je.foreground=ak("#ffffff")je.background=ak("#ffffff")jc[jd]=je;aA[jb]=jc;as[iY]=aA;local jf="apps"local jg={}local jh="players"local ji={}for av,aw in pairs(eh.apps.players)do ji[av]=aw end;ji.foreground=ak("#000000")ji.background=ak("#ffffff")local jj="avatar"local jk={}for av,aw in pairs(eh.apps.players.avatar)do jk[av]=aw end;jk.background=ak("#000000")jk.transparency=0.9;jk.gradient={color=ColorSequence.new(ak("#3ce09b"))}ji[jj]=jk;local jl="button"local jm={}for av,aw in pairs(eh.apps.players.button)do jm[av]=aw end;jm.foreground=ak("#000000")jm.background=ak("#ffffff")ji[jl]=jm;local jn="playerButton"local jo={}for av,aw in pairs(eh.apps.players.playerButton)do jo[av]=aw end;jo.foreground=ak("#000000")jo.background=ak("#ffffff")jo.backgroundHovered=ak("#eeeeee")jo.accent=ak("#3ce09b")jo.dropshadowTransparency=0.7;ji[jn]=jo;jg[jh]=ji;as[jf]=jg;local jp="options"local jq={}local jr="config"local js={}for av,aw in pairs(eh.options.config)do js[av]=aw end;js.foreground=ak("#000000")js.background=ak("#ffffff")local jt="configButton"local ju={}for av,aw in pairs(eh.options.config.configButton)do ju[av]=aw end;ju.foreground=ak("#000000")ju.background=ak("#ffffff")ju.backgroundHovered=ak("#eeeeee")ju.accent=ak("#3ce09b")ju.dropshadowTransparency=0.7;js[jt]=ju;jq[jr]=js;local jv="shortcuts"local jw={}for av,aw in pairs(eh.options.shortcuts)do jw[av]=aw end;jw.foreground=ak("#000000")jw.background=ak("#ffffff")local jx="shortcutButton"local jy={}for av,aw in pairs(eh.options.shortcuts.shortcutButton)do jy[av]=aw end;jy.foreground=ak("#000000")jy.background=ak("#ffffff")jy.backgroundHovered=ak("#eeeeee")jy.accent=ak("#3ce09b")jy.dropshadowTransparency=0.7;jw[jx]=jy;jq[jv]=jw;local jz="themes"local jA={}for av,aw in pairs(eh.options.themes)do jA[av]=aw end;jA.foreground=ak("#000000")jA.background=ak("#ffffff")local jB="themeButton"local jC={}for av,aw in pairs(eh.options.themes.themeButton)do jC[av]=aw end;jC.foreground=ak("#000000")jC.background=ak("#ffffff")jC.backgroundHovered=ak("#eeeeee")jC.accent=ak("#3ce09b")jC.dropshadowTransparency=0.7;jA[jB]=jC;jq[jz]=jA;as[jp]=jq;local iR=as;return{lightTheme=iR}end,newEnv("Orca.themes.light-theme"))()end)newModule("obsidian","ModuleScript","Orca.themes.obsidian","Orca.themes",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local eh=a.import(script,script.Parent,"dark-theme").darkTheme;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local a_=ak("#9029F6")local iV=ColorSequence.new(ak("#9029F6"))local as={}for av,aw in pairs(eh)do as[av]=aw end;as.name="Obsidian"as.preview={foreground={color=ColorSequence.new(ak("#ffffff"))},background={color=ColorSequence.new(ak("#000000"))},accent={color=iV}}local at="navbar"local au={}for av,aw in pairs(eh.navbar)do au[av]=aw end;au.acrylic=true;au.outlined=false;au.foreground=ak("#ffffff")au.background=ak("#000000")au.dropshadow=ak("#000000")au.transparency=0.7;au.accentGradient={color=iV,transparency=NumberSequence.new(0.5)}as[at]=au;local iX="clock"local ay={}for av,aw in pairs(eh.clock)do ay[av]=aw end;ay.acrylic=true;ay.outlined=false;ay.foreground=ak("#ffffff")ay.background=ak("#000000")ay.dropshadow=ak("#000000")ay.transparency=0.7;as[iX]=ay;local iY="home"local aA={}local iZ="title"local aC={}for av,aw in pairs(eh.home.title)do aC[av]=aw end;aC.acrylic=true;aC.outlined=false;aC.foreground=ak("#ffffff")aC.background=ak("#000000")aC.dropshadow=ak("#000000")aC.transparency=0.7;aC.dropshadowTransparency=0.65;aA[iZ]=aC;local i_="profile"local aE={}for av,aw in pairs(eh.home.profile)do aE[av]=aw end;aE.acrylic=true;aE.outlined=false;aE.foreground=ak("#ffffff")aE.background=ak("#000000")aE.dropshadow=ak("#000000")aE.transparency=0.7;aE.dropshadowTransparency=0.65;local j0="avatar"local aG={}for av,aw in pairs(eh.home.profile.avatar)do aG[av]=aw end;aG.background=ak("#000000")aG.transparency=0.7;aG.gradient={color=iV}aE[j0]=aG;aE.highlight={flight=a_,walkSpeed=a_,jumpHeight=a_,refresh=a_,ghost=a_,godmode=a_,freecam=a_}local j1="slider"local j2={}for av,aw in pairs(eh.home.profile.slider)do j2[av]=aw end;j2.outlined=false;j2.foreground=ak("#ffffff")j2.background=ak("#000000")j2.backgroundTransparency=0.5;j2.indicatorTransparency=0.5;aE[j1]=j2;local j3="button"local j4={}for av,aw in pairs(eh.home.profile.button)do j4[av]=aw end;j4.outlined=false;j4.foreground=ak("#ffffff")j4.background=ak("#000000")j4.backgroundTransparency=0.5;aE[j3]=j4;aA[i_]=aE;local j5="server"local j6={}for av,aw in pairs(eh.home.server)do j6[av]=aw end;j6.acrylic=true;j6.outlined=false;j6.foreground=ak("#ffffff")j6.background=ak("#000000")j6.dropshadow=ak("#000000")j6.transparency=0.7;j6.dropshadowTransparency=0.65;local j7="rejoinButton"local j8={}for av,aw in pairs(eh.home.server.rejoinButton)do j8[av]=aw end;j8.outlined=false;j8.foreground=ak("#ffffff")j8.background=ak("#000000")j8.backgroundTransparency=0.5;j8.foregroundTransparency=0.5;j8.accent=a_;j6[j7]=j8;local j9="switchButton"local ja={}for av,aw in pairs(eh.home.server.switchButton)do ja[av]=aw end;ja.outlined=false;ja.foreground=ak("#ffffff")ja.background=ak("#000000")ja.backgroundTransparency=0.5;ja.foregroundTransparency=0.5;ja.accent=a_;j6[j9]=ja;aA[j5]=j6;local jb="friendActivity"local jc={}for av,aw in pairs(eh.home.friendActivity)do jc[av]=aw end;jc.acrylic=true;jc.outlined=false;jc.foreground=ak("#ffffff")jc.background=ak("#000000")jc.dropshadow=ak("#000000")jc.transparency=0.7;jc.dropshadowTransparency=0.65;local jd="friendButton"local je={}for av,aw in pairs(eh.home.friendActivity.friendButton)do je[av]=aw end;je.outlined=false;je.foreground=ak("#ffffff")je.background=ak("#000000")je.dropshadow=ak("#000000")je.backgroundTransparency=0.7;jc[jd]=je;aA[jb]=jc;as[iY]=aA;local jf="apps"local jg={}local jh="players"local ji={}for av,aw in pairs(eh.apps.players)do ji[av]=aw end;ji.acrylic=true;ji.outlined=false;ji.foreground=ak("#ffffff")ji.background=ak("#000000")ji.dropshadow=ak("#000000")ji.transparency=0.7;ji.dropshadowTransparency=0.65;ji.highlight={teleport=a_,hide=a_,kill=a_,spectate=a_}local jj="avatar"local jk={}for av,aw in pairs(eh.apps.players.avatar)do jk[av]=aw end;jk.background=ak("#000000")jk.transparency=0.7;jk.gradient={color=iV}ji[jj]=jk;local jl="button"local jm={}for av,aw in pairs(eh.apps.players.button)do jm[av]=aw end;jm.outlined=false;jm.foreground=ak("#ffffff")jm.background=ak("#000000")jm.backgroundTransparency=0.5;ji[jl]=jm;local jn="playerButton"local jo={}for av,aw in pairs(eh.apps.players.playerButton)do jo[av]=aw end;jo.outlined=false;jo.foreground=ak("#ffffff")jo.background=ak("#000000")jo.accent=a_;jo.backgroundTransparency=0.5;jo.dropshadowTransparency=0.7;ji[jn]=jo;jg[jh]=ji;as[jf]=jg;local jp="options"local jq={}local jr="config"local js={}for av,aw in pairs(eh.options.config)do js[av]=aw end;js.acrylic=true;js.outlined=false;js.foreground=ak("#ffffff")js.background=ak("#000000")js.dropshadow=ak("#000000")js.transparency=0.7;js.dropshadowTransparency=0.65;local jt="configButton"local ju={}for av,aw in pairs(eh.options.config.configButton)do ju[av]=aw end;ju.outlined=false;ju.foreground=ak("#ffffff")ju.background=ak("#000000")ju.accent=a_;ju.backgroundTransparency=0.5;ju.dropshadowTransparency=0.7;js[jt]=ju;jq[jr]=js;local jv="shortcuts"local jw={}for av,aw in pairs(eh.options.shortcuts)do jw[av]=aw end;jw.acrylic=true;jw.outlined=false;jw.foreground=ak("#ffffff")jw.background=ak("#000000")jw.dropshadow=ak("#000000")jw.transparency=0.7;jw.dropshadowTransparency=0.65;local jx="shortcutButton"local jy={}for av,aw in pairs(eh.options.shortcuts.shortcutButton)do jy[av]=aw end;jy.outlined=false;jy.foreground=ak("#ffffff")jy.background=ak("#000000")jy.accent=a_;jy.backgroundTransparency=0.5;jy.dropshadowTransparency=0.7;jw[jx]=jy;jq[jv]=jw;local jz="themes"local jA={}for av,aw in pairs(eh.options.themes)do jA[av]=aw end;jA.acrylic=true;jA.outlined=false;jA.foreground=ak("#ffffff")jA.background=ak("#000000")jA.dropshadow=ak("#000000")jA.transparency=0.7;jA.dropshadowTransparency=0.65;local jB="themeButton"local jC={}for av,aw in pairs(eh.options.themes.themeButton)do jC[av]=aw end;jC.outlined=false;jC.foreground=ak("#ffffff")jC.background=ak("#000000")jC.accent=a_;jC.backgroundTransparency=0.5;jC.dropshadowTransparency=0.7;jA[jB]=jC;jq[jz]=jA;as[jp]=jq;local iS=as;return{obsidian=iS}end,newEnv("Orca.themes.obsidian"))()end)newModule("sorbet","ModuleScript","Orca.themes.sorbet","Orca.themes",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local eh=a.import(script,script.Parent,"dark-theme").darkTheme;local ak=a.import(script,script.Parent.Parent,"utils","color3").hex;local jD=ak("#C6428E")local jE=ak("#484fd7")local jF=ak("#9a3fe5")local iV=ColorSequence.new({ColorSequenceKeypoint.new(0,jD),ColorSequenceKeypoint.new(0.5,jF),ColorSequenceKeypoint.new(1,jE)})local b3=ak("#181818")local jG=ak("#242424")local iW={acrylic=false,outlined=false,foreground=ak("#ffffff"),background=b3,backgroundGradient=nil,transparency=0,dropshadow=b3,dropshadowTransparency=0.3}local as={}for av,aw in pairs(eh)do as[av]=aw end;as.name="Sorbet"as.preview={foreground={color=ColorSequence.new(ak("#ffffff"))},background={color=ColorSequence.new(b3)},accent={color=iV}}local at="navbar"local au={}for av,aw in pairs(eh.navbar)do au[av]=aw end;au.outlined=false;au.background=b3;au.dropshadow=b3;au.accentGradient={color=iV}as[at]=au;local iX="clock"local ay={}for av,aw in pairs(eh.clock)do ay[av]=aw end;ay.outlined=false;ay.background=b3;ay.dropshadow=b3;as[iX]=ay;local iY="home"local aA={}local iZ="title"local aC={}for av,aw in pairs(iW)do aC[av]=aw end;aC.background=ak("#ffffff")aC.backgroundGradient={color=iV,rotation=30}aC.dropshadow=ak("#ffffff")aC.dropshadowGradient={color=iV,rotation=30}aA[iZ]=aC;local i_="profile"local aE={}for av,aw in pairs(iW)do aE[av]=aw end;local j0="avatar"local aG={}for av,aw in pairs(eh.home.profile.avatar)do aG[av]=aw end;aG.background=jG;aG.transparency=0;aG.gradient={color=iV,rotation=45}aE[j0]=aG;aE.highlight={flight=jD,walkSpeed=jF,jumpHeight=jE,refresh=jD,ghost=jE,godmode=jD,freecam=jE}local j1="slider"local j2={}for av,aw in pairs(eh.home.profile.slider)do j2[av]=aw end;j2.outlined=false;j2.foreground=ak("#ffffff")j2.background=jG;aE[j1]=j2;local j3="button"local j4={}for av,aw in pairs(eh.home.profile.button)do j4[av]=aw end;j4.outlined=false;j4.foreground=ak("#ffffff")j4.background=jG;aE[j3]=j4;aA[i_]=aE;local j5="server"local j6={}for av,aw in pairs(iW)do j6[av]=aw end;local j7="rejoinButton"local j8={}for av,aw in pairs(eh.home.server.rejoinButton)do j8[av]=aw end;j8.outlined=false;j8.foreground=ak("#ffffff")j8.background=jG;j8.foregroundTransparency=0.5;j8.accent=jD;j6[j7]=j8;local j9="switchButton"local ja={}for av,aw in pairs(eh.home.server.switchButton)do ja[av]=aw end;ja.outlined=false;ja.foreground=ak("#ffffff")ja.background=jG;ja.foregroundTransparency=0.5;ja.accent=jE;j6[j9]=ja;aA[j5]=j6;local jb="friendActivity"local jc={}for av,aw in pairs(iW)do jc[av]=aw end;local jd="friendButton"local je={}for av,aw in pairs(eh.home.friendActivity.friendButton)do je[av]=aw end;je.outlined=false;je.foreground=ak("#ffffff")je.background=jG;jc[jd]=je;aA[jb]=jc;as[iY]=aA;local jf="apps"local jg={}local jh="players"local ji={}for av,aw in pairs(iW)do ji[av]=aw end;ji.highlight={teleport=jD,hide=jE,kill=jD,spectate=jE}local jj="avatar"local jk={}for av,aw in pairs(eh.apps.players.avatar)do jk[av]=aw end;jk.background=jG;jk.transparency=0;jk.gradient={color=iV,rotation=45}ji[jj]=jk;local jl="button"local jm={}for av,aw in pairs(eh.apps.players.button)do jm[av]=aw end;jm.outlined=false;jm.foreground=ak("#ffffff")jm.background=jG;ji[jl]=jm;local jn="playerButton"local jo={}for av,aw in pairs(eh.apps.players.playerButton)do jo[av]=aw end;jo.outlined=false;jo.foreground=ak("#ffffff")jo.background=jG;jo.dropshadow=jG;jo.accent=jE;ji[jn]=jo;jg[jh]=ji;as[jf]=jg;local jp="options"local jq={}local jr="config"local js={}for av,aw in pairs(iW)do js[av]=aw end;local jt="configButton"local ju={}for av,aw in pairs(eh.options.config.configButton)do ju[av]=aw end;ju.outlined=false;ju.foreground=ak("#ffffff")ju.background=jG;ju.dropshadow=jG;ju.accent=jD;js[jt]=ju;jq[jr]=js;local jv="shortcuts"local jw={}for av,aw in pairs(iW)do jw[av]=aw end;local jx="shortcutButton"local jy={}for av,aw in pairs(eh.options.shortcuts.shortcutButton)do jy[av]=aw end;jy.outlined=false;jy.foreground=ak("#ffffff")jy.background=jG;jy.dropshadow=jG;jy.accent=jF;jw[jx]=jy;jq[jv]=jw;local jz="themes"local jA={}for av,aw in pairs(iW)do jA[av]=aw end;local jB="themeButton"local jC={}for av,aw in pairs(eh.options.themes.themeButton)do jC[av]=aw end;jC.outlined=false;jC.foreground=ak("#ffffff")jC.background=jG;jC.dropshadow=jG;jC.accent=jE;jA[jB]=jC;jq[jz]=jA;as[jp]=jq;local iT=as;return{sorbet=iT}end,newEnv("Orca.themes.sorbet"))()end)newModule("theme.interface","ModuleScript","Orca.themes.theme.interface","Orca.themes",function()return setfenv(function()end,newEnv("Orca.themes.theme.interface"))()end)newInstance("utils","Folder","Orca.utils","Orca")newModule("array-util","ModuleScript","Orca.utils.array-util","Orca.utils",function()return setfenv(function()local function jH(jI,jJ)local e1=table.create(#jI)for av,aw in ipairs(jI)do e1[av]=jJ(aw,av-1,jI)end;local jK={}for ev,aw in ipairs(e1)do jK[aw[1]]=aw[2]end;return jK end;return{arrayToMap=jH}end,newEnv("Orca.utils.array-util"))()end)newModule("binding-util","ModuleScript","Orca.utils.binding-util","Orca.utils",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local function jL(cC)return type(cC)=="table"and cC.getValue~=nil end;local function b7(d3,jM)return jL(d3)and d3:map(jM)or b.createBinding(jM(d3))end;local function b6(d3)return jL(d3)and d3 or b.createBinding(d3)end;return{isBinding=jL,mapBinding=b7,asBinding=b6}end,newEnv("Orca.utils.binding-util"))()end)newModule("color3","ModuleScript","Orca.utils.color3","Orca.utils",function()return setfenv(function()local function jN(b9)if typeof(b9)=="ColorSequence"then b9=b9.Keypoints[1].Value end;return b9.R*0.2126+b9.G*0.7152+b9.B*0.0722 end;local function jO(jP,bN)local c2=math.floor(bN*(#jP.Keypoints-1))local jQ=math.min(c2+1,#jP.Keypoints-1)local b2=jP.Keypoints[c2+1]if b2==nil then b2=jP.Keypoints[1]end;local jR=b2;local jS=jP.Keypoints[jQ+1]if jS==nil then jS=jR end;local jT=jS;return jR.Value:Lerp(jT.Value,bN*(#jP.Keypoints-1)-c2)end;local jU=function(ak)local jV=string.gsub(ak,"#","0x",1)local b2=tonumber(jV)if b2==nil then b2=0 end;return b2 end;local jW=function(jX)return Color3.fromRGB(math.floor(jX/65536)%256,math.floor(jX/256)%256,jX%256)end;local ak=function(ak)return jW(jU(ak))end;local jY=function(cb,dF,dG)return Color3.fromRGB(cb,dF,dG)end;local jZ=function(j_,bd,bM)return Color3.fromHSV(j_/360,bd/100,bM/100)end;local k0=function(j_,bd,k1)local k2=bd*(k1<50 and k1 or 100-k1)/100;local k3=k2==0 and 0 or 2*k2/(k1+k2)*100;local k4=k1+k2;return Color3.fromHSV(j_/255,k3/100,k4/100)end;return{getLuminance=jN,getColorInSequence=jO,hex=ak,rgb=jY,hsv=jZ,hsl=k0}end,newEnv("Orca.utils.color3"))()end)newModule("debug","ModuleScript","Orca.utils.debug","Orca.utils",function()return setfenv(function()local k5=os.clock()local k6="clock"local k7={}local function k8(hp)local b2=k7[hp]if b2==nil then b2=0 end;k7[hp]=b2+1;k6=hp;k5=os.clock()end;local function k9()local ka=os.clock()-k5;local b2=k7[k6]if b2==nil then b2=0 end;local hR=b2;print("\n["..k6 .." "..tostring(hR).."]\n"..tostring(ka*1000).." ms\n\n")end;return{startTimer=k8,endTimer=k9}end,newEnv("Orca.utils.debug"))()end)newModule("http","ModuleScript","Orca.utils.http","Orca.utils",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local i4=a.import(script,a.getModule(script,"@rbxts","services")).HttpService;local cv=a.import(script,script.Parent.Parent,"constants").IS_DEV;local kb;kb=a.async(function(kc)if cv then return i4:RequestAsync(kc)else local kd=syn and syn.request or kb;if not kd then error("request/syn.request is not available")end;return kd(kc)end end)local ke=a.async(function(kf,kg)return game:HttpGetAsync(kf,kg)end)local kh=a.async(function(kf,hA,ki,kg)return game:HttpPostAsync(kf,hA,ki,kg)end)return{request=kb,get=ke,post=kh}end,newEnv("Orca.utils.http"))()end)newModule("number-util","ModuleScript","Orca.utils.number-util","Orca.utils",function()return setfenv(function()local function q(kj,kk,kl,km,kn)return km+(kj-kk)*(kn-km)/(kl-kk)end;local function ko(hx,dG,ek)return hx+(dG-hx)*ek end;return{map=q,lerp=ko}end,newEnv("Orca.utils.number-util"))()end)newModule("timeout","ModuleScript","Orca.utils.timeout","Orca.utils",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local ez=a.import(script,a.getModule(script,"@rbxts","services")).RunService;local kp;do kp=setmetatable({},{__tostring=function()return"Timeout"end})kp.__index=kp;function kp.new(...)local self=setmetatable({},kp)return self:constructor(...)or self end;function kp:constructor(da,kq,...)local kr={...}self.running=true;task.delay(kq/1000,function()if self.running then da(unpack(kr))end end)end;function kp:clear()self.running=false end end;local function cX(da,kq,...)local kr={...}return kp.new(da,kq,unpack(kr))end;local function cW(ew)ew:clear()end;local ks;do ks=setmetatable({},{__tostring=function()return"Interval"end})ks.__index=ks;function ks.new(...)local self=setmetatable({},ks)return self:constructor(...)or self end;function ks:constructor(da,kq,...)local kr={...}self.running=true;task.defer(function()local k5=0;local kt;kt=ez.Heartbeat:Connect(function(ku)k5=k5+ku;if not self.running then kt:Disconnect()elseif k5>=kq/1000 then k5=k5-kq/1000;da(unpack(kr))end end)end)end;function ks:clear()self.running=false end end;local function dg(da,kq,...)local kr={...}return ks.new(da,kq,unpack(kr))end;local function df(dj)dj:clear()end;return{setTimeout=cX,clearTimeout=cW,setInterval=dg,clearInterval=df,Timeout=kp,Interval=ks}end,newEnv("Orca.utils.timeout"))()end)newModule("udim2","ModuleScript","Orca.utils.udim2","Orca.utils",function()return setfenv(function()local function am(bU,ed)return UDim2.new(0,bU,0,ed)end;local function r(bU,ed)return UDim2.new(bU,0,ed,0)end;local function ce(L,dI,ck)if ck==nil then ck=1 end;return Vector2.new(dI.X.Offset+dI.X.Scale/ck*L.X,dI.Y.Offset+dI.Y.Scale/ck*L.Y)end;return{px=am,scale=r,applyUDim2=ce}end,newEnv("Orca.utils.udim2"))()end)newInstance("views","Folder","Orca.views","Orca")newModule("Clock","ModuleScript","Orca.views.Clock","Orca.views",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Clock").default;return g end,newEnv("Orca.views.Clock"))()end)newModule("Clock","ModuleScript","Orca.views.Clock.Clock","Orca.views.Clock",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local k=h.useEffect;local l=h.useMemo;local aH=h.useState;local kv=a.import(script,a.getModule(script,"@rbxts","services")).TextService;local B=a.import(script,script.Parent.Parent.Parent,"components","Acrylic").default;local b8=a.import(script,script.Parent.Parent.Parent,"components","Border").default;local bl=a.import(script,script.Parent.Parent.Parent,"components","Fill").default;local bm=a.import(script,script.Parent.Parent.Parent,"components","Glow")local bn=bm.default;local bo=bm.GlowRadius;local p=a.import(script,script.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local ei=a.import(script,script.Parent.Parent.Parent,"hooks","use-theme").useTheme;local dg=a.import(script,script.Parent.Parent.Parent,"utils","timeout").setInterval;local am=a.import(script,script.Parent.Parent.Parent,"utils","udim2").px;local kw=am(56,56)local kx=14;local function ky()return string.gsub(os.date("%I:%M %p"),"^0([0-9])","%1")end;local function kz()local c4=p(function(F)return F.dashboard.isOpen end)local aT=ei("clock")local U=aH(ky())local kA=U[1]local kB=U[2]local kC=l(function()return kv:GetTextSize(kA,20,"GothamBold",Vector2.new(200,56))end,{kA})k(function()local dj=dg(function()return kB(ky())end,1000)return function()return dj:clear()end end,{})local bc={}local y=am(kC.X+kx,0)bc.Size=kw+y;bc.Position=aL(c4 and UDim2.new(0,0,1,0)or UDim2.new(0,0,1,48+56+20),{})bc.AnchorPoint=Vector2.new(0,1)bc.BackgroundTransparency=1;local be={b.createElement(bn,{radius=bo.Size146,size=UDim2.new(1,80,0,146),position=am(-40,-20),color=aT.dropshadow,gradient=aT.dropshadowGradient,transparency=aT.transparency}),b.createElement(bl,{color=aT.background,gradient=aT.backgroundGradient,transparency=aT.transparency,radius=8})}local bf=#be;local bv=aT.outlined and b.createFragment({border=b.createElement(b8,{color=aT.foreground,radius=8,transparency=0.8})})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("ImageLabel",{Image="rbxassetid://8992234911",ImageColor3=aT.foreground,Size=am(36,36),Position=am(10,10),BackgroundTransparency=1})be[bf+2]=b.createElement("TextLabel",{Text=kA,Font="GothamBold",TextColor3=aT.foreground,TextSize=20,TextXAlignment="Left",TextYAlignment="Center",Size=am(0,0),Position=am(51,27),BackgroundTransparency=1})local c9=aT.acrylic and b.createElement(B)or nil;if c9 then if c9.elements~=nil or c9.props~=nil and c9.component~=nil then be[bf+3]=c9 else for av,aw in ipairs(c9)do be[bf+2+av]=aw end end end;return b.createElement("Frame",bc,be)end;local f=i(kz)return{default=f}end,newEnv("Orca.views.Clock.Clock"))()end)newModule("Dashboard","ModuleScript","Orca.views.Dashboard","Orca.views",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Dashboard").default;return g end,newEnv("Orca.views.Dashboard"))()end)newModule("Dashboard","ModuleScript","Orca.views.Dashboard.Dashboard","Orca.views.Dashboard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local l=h.useMemo;local bk=a.import(script,script.Parent.Parent.Parent,"components","Canvas").default;local cx=a.import(script,script.Parent.Parent.Parent,"context","scale-context").ScaleContext;local p=a.import(script,script.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local dQ=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-viewport-size").useViewportSize;local ak=a.import(script,script.Parent.Parent.Parent,"utils","color3").hex;local q=a.import(script,script.Parent.Parent.Parent,"utils","number-util").map;local r=a.import(script,script.Parent.Parent.Parent,"utils","udim2").scale;local kD=a.import(script,script.Parent.Parent,"Hint").default;local kz=a.import(script,script.Parent.Parent,"Clock").default;local kE=a.import(script,script.Parent.Parent,"Navbar").default;local kF=a.import(script,script.Parent.Parent,"Pages").default;local kG=980;local kH=1080;local kI=14;local kJ=48;local function kK(a4)if a4<kH and a4>=kG then return q(a4,kG,kH,kI,kJ)elseif a4<kG then return kI else return kJ end end;local function kL(a4)if a4<kG then return q(a4,kG,130,1,0)else return 1 end end;local function c()local ec=dQ()local c4=p(function(F)return F.dashboard.isOpen end)local U=l(function()return{ec:map(function(bd)return kL(bd.Y)end),ec:map(function(bd)return kK(bd.Y)end)}end,{ec})local ck=U[1]local bX=U[2]return b.createElement(cx.Provider,{value=ck},{b.createElement("Frame",{Size=r(1,1),BackgroundColor3=ak("#000000"),BackgroundTransparency=aL(c4 and 0 or 1,{}),BorderSizePixel=0},{b.createElement("UIGradient",{Transparency=NumberSequence.new(1,0.25),Rotation=90})}),b.createElement(bk,{padding={top=48,bottom=bX,left=48,right=48}},{b.createElement(bk,{padding={bottom=bX:map(function(kM)return 56+kM end)}},{b.createElement(kF),b.createElement(kD)}),b.createElement(kE),b.createElement(kz)})})end;local f=i(c)return{default=f}end,newEnv("Orca.views.Dashboard.Dashboard"))()end)newModule("Dashboard.story","ModuleScript","Orca.views.Dashboard.Dashboard.story","Orca.views.Dashboard",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local ah=a.import(script,a.getModule(script,"@rbxts","roact-rodux-hooked").out).Provider;local ai=a.import(script,script.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local aj=a.import(script,script.Parent.Parent.Parent,"store","store").configureStore;local c=a.import(script,script.Parent,"Dashboard").default;return function(an)local ao=b.mount(b.createElement(ah,{store=aj({dashboard={isOpen=true,page=ai.Home,hint=nil,apps={}}})},{b.createElement(c)}),an,"Dashboard")return function()return b.unmount(ao)end end end,newEnv("Orca.views.Dashboard.Dashboard.story"))()end)newModule("Hint","ModuleScript","Orca.views.Hint","Orca.views",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Hint").default;return g end,newEnv("Orca.views.Hint"))()end)newModule("Hint","ModuleScript","Orca.views.Hint.Hint","Orca.views.Hint",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local k=h.useEffect;local aH=h.useState;local p=a.import(script,script.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local b_=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-delayed-update").useDelayedUpdate;local aL=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local cd=a.import(script,script.Parent.Parent.Parent,"hooks","use-scale").useScale;local ak=a.import(script,script.Parent.Parent.Parent,"utils","color3").hex;local r=a.import(script,script.Parent.Parent.Parent,"utils","udim2").scale;local function kD()local ck=cd()local aS=p(function(F)return F.dashboard.hint end)local kN=p(function(F)return F.dashboard.isOpen end)local b2=aS;if b2==nil then b2=""end;local U=aH(b2)local kO=U[1]local kP=U[2]local kQ=b_(aS~=nil and kN,500,function(kR)return not kR end)k(function()if kQ and aS~=nil then kP(aS)end end,{aS,kQ})return b.createElement("TextLabel",{RichText=true,Text=kO,TextXAlignment="Right",TextYAlignment="Bottom",TextColor3=ak("#FFFFFF"),TextTransparency=aL(kQ and 0.4 or 1,{}),Font="GothamSemibold",TextSize=18,BackgroundTransparency=1,Position=aL(kQ and r(1,1)or UDim2.new(1,0,1,48),{})},{b.createElement("UIScale",{Scale=ck})})end;local f=i(kD)return{default=f}end,newEnv("Orca.views.Hint.Hint"))()end)newModule("Navbar","ModuleScript","Orca.views.Navbar","Orca.views",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Navbar").default;return g end,newEnv("Orca.views.Navbar"))()end)newModule("Navbar","ModuleScript","Orca.views.Navbar.Navbar","Orca.views.Navbar",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local B=a.import(script,script.Parent.Parent.Parent,"components","Acrylic").default;local b8=a.import(script,script.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent,"components","Canvas").default;local bl=a.import(script,script.Parent.Parent.Parent,"components","Fill").default;local bm=a.import(script,script.Parent.Parent.Parent,"components","Glow")local bn=bm.default;local bo=bm.GlowRadius;local p=a.import(script,script.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local dU=a.import(script,script.Parent.Parent.Parent,"hooks","use-current-page").useCurrentPage;local ei=a.import(script,script.Parent.Parent.Parent,"hooks","use-theme").useTheme;local kS=a.import(script,script.Parent.Parent.Parent,"store","models","dashboard.model")local ai=kS.DashboardPage;local ix=kS.PAGE_TO_INDEX;local kT=a.import(script,script.Parent.Parent.Parent,"utils","color3")local jO=kT.getColorInSequence;local ak=kT.hex;local al=a.import(script,script.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local kU=a.import(script,script.Parent,"NavbarTab").default;local kV=am(400,56)local kW;local function kE()local aT=ei("navbar")local c3=dU()local c4=p(function(F)return F.dashboard.isOpen end)local bN=aL(ix[c3]/4,{frequency=3.9,dampingRatio=0.76})local bc={Size=kV,Position=aL(c4 and UDim2.new(0.5,0,1,0)or UDim2.new(0.5,0,1,48+56+20),{}),AnchorPoint=Vector2.new(0.5,1),BackgroundTransparency=1}local be={b.createElement(bn,{radius=bo.Size146,size=UDim2.new(1,80,0,146),position=am(-40,-20),color=aT.dropshadow,gradient=aT.dropshadowGradient,transparency=aT.transparency}),b.createElement(kW,{transparency=aT.glowTransparency,position=bN:map(function(hx)return hx+0.125 end),sequenceColor=bN:map(function(hx)return jO(aT.accentGradient.color,hx+0.125)end)}),b.createElement(bl,{color=aT.background,gradient=aT.backgroundGradient,radius=8,transparency=aT.transparency}),b.createElement(bk,{size=am(100,56),position=bN:map(function(hx)return r(math.round(hx*800)/800,0)end),clipsDescendants=true},{b.createElement("Frame",{Size=kV,Position=bN:map(function(hx)return r(-4*math.round(hx*800)/800,0)end),BackgroundColor3=ak("#FFFFFF"),BorderSizePixel=0},{b.createElement("UIGradient",{Color=aT.accentGradient.color,Transparency=aT.accentGradient.transparency,Rotation=aT.accentGradient.rotation}),b.createElement("UICorner",{CornerRadius=UDim.new(0,8)})})})}local bf=#be;local bv=aT.outlined and b.createFragment({border=b.createElement(b8,{color=aT.foreground,radius=8,transparency=0.8})})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement(kU,{page=ai.Home})be[bf+2]=b.createElement(kU,{page=ai.Apps})be[bf+3]=b.createElement(kU,{page=ai.Scripts})be[bf+4]=b.createElement(kU,{page=ai.Options})local c9=aT.acrylic and b.createElement(B)or nil;if c9 then if c9.elements~=nil or c9.props~=nil and c9.component~=nil then be[bf+5]=c9 else for av,aw in ipairs(c9)do be[bf+4+av]=aw end end end;return b.createElement("Frame",bc,be)end;local f=i(kE)function kW(kX)return b.createElement("ImageLabel",{Image="rbxassetid://8992238178",ImageColor3=kX.sequenceColor,ImageTransparency=kX.transparency,Size=am(148,104),Position=kX.position:map(function(hx)return UDim2.new(hx,0,0,-18)end),AnchorPoint=Vector2.new(0.5,0),BackgroundTransparency=1})end;return{default=f}end,newEnv("Orca.views.Navbar.Navbar"))()end)newModule("Navbar.story","ModuleScript","Orca.views.Navbar.Navbar.story","Orca.views.Navbar",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local ah=a.import(script,a.getModule(script,"@rbxts","roact-rodux-hooked").out).Provider;local ai=a.import(script,script.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local aj=a.import(script,script.Parent.Parent.Parent,"store","store").configureStore;local kE=a.import(script,script.Parent,"Navbar").default;return function(an)local ao=b.mount(b.createElement(ah,{store=aj({dashboard={isOpen=true,page=ai.Home,hint=nil,apps={}}})},{b.createElement(kE)}),an,"Navbar")return function()return b.unmount(ao)end end end,newEnv("Orca.views.Navbar.Navbar.story"))()end)newModule("NavbarTab","ModuleScript","Orca.views.Navbar.NavbarTab","Orca.views.Navbar",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local aH=h.useState;local aK=a.import(script,script.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppDispatch;local aL=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local ei=a.import(script,script.Parent.Parent.Parent,"hooks","use-theme").useTheme;local io=a.import(script,script.Parent.Parent.Parent,"store","actions","dashboard.action").setDashboardPage;local kS=a.import(script,script.Parent.Parent.Parent,"store","models","dashboard.model")local iy=kS.PAGE_TO_ICON;local ix=kS.PAGE_TO_INDEX;local al=a.import(script,script.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local kY=am(100,56)local function kU(C)local c3=C.page;local aT=ei("navbar")local c5=c0(c3)local aW=aK()local U=aH(false)local kZ=U[1]local aZ=U[2]return b.createElement("TextButton",{Text="",AutoButtonColor=false,Active=not c5,Size=kY,Position=r(ix[c3]/4,0),BackgroundTransparency=1,[b.Event.Activated]=function()return aW(io(c3))end,[b.Event.MouseEnter]=function()return aZ(true)end,[b.Event.MouseLeave]=function()return aZ(false)end},{b.createElement("ImageLabel",{Image=iy[c3],ImageColor3=aT.foreground,ImageTransparency=aL(c5 and 0 or(kZ and 0.5 or 0.75),{}),Size=am(36,36),Position=r(0.5,0.5),AnchorPoint=Vector2.new(0.5,0.5),BackgroundTransparency=1})})end;local f=i(kU)return{default=f}end,newEnv("Orca.views.Navbar.NavbarTab"))()end)newModule("Pages","ModuleScript","Orca.views.Pages","Orca.views",function()return setfenv(function()local a=require(script.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Pages").default;return g end,newEnv("Orca.views.Pages"))()end)newModule("Apps","ModuleScript","Orca.views.Pages.Apps","Orca.views.Pages",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Apps").default;return g end,newEnv("Orca.views.Pages.Apps"))()end)newModule("Apps","ModuleScript","Orca.views.Pages.Apps.Apps","Orca.views.Pages.Apps",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local k_=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).pure;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local cd=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-scale").useScale;local r=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2").scale;local dV=a.import(script,script.Parent,"Players").default;local function l0()local ck=cd()return b.createElement(bk,{position=r(0,1),anchor=Vector2.new(0,1)},{b.createElement("UIScale",{Scale=ck}),b.createElement(dV)})end;local f=k_(l0)return{default=f}end,newEnv("Orca.views.Pages.Apps.Apps"))()end)newModule("Players","ModuleScript","Orca.views.Pages.Apps.Players","Orca.views.Pages.Apps",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Players").default;return g end,newEnv("Orca.views.Pages.Apps.Players"))()end)newModule("Actions","ModuleScript","Orca.views.Pages.Apps.Players.Actions","Orca.views.Pages.Apps.Players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local aQ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","ActionButton").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local function l1()local aT=ei("apps").players;return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(278,49),position=UDim2.new(0.5,0,0,304)},{b.createElement(aQ,{action="teleport",hint="<font face='GothamBlack'>Teleport to</font> this player, tap again to cancel",theme=aT,image="rbxassetid://8992042585",position=am(0,0),canDeactivate=true}),b.createElement(aQ,{action="hide",hint="<font face='GothamBlack'>Hide</font> this player's character; persists between players",theme=aT,image="rbxassetid://8992042653",position=am(72,0),canDeactivate=true}),b.createElement(aQ,{action="kill",hint="<font face='GothamBlack'>Kill</font> this player with a tool handle",theme=aT,image="rbxassetid://8992042471",position=am(145,0)}),b.createElement(aQ,{action="spectate",hint="<font face='GothamBlack'>Spectate</font> this player",theme=aT,image="rbxassetid://8992042721",position=am(217,0),canDeactivate=true})})end;local f=i(l1)return{default=f}end,newEnv("Orca.views.Pages.Apps.Players.Actions"))()end)newModule("Avatar","ModuleScript","Orca.views.Pages.Apps.Players.Avatar","Orca.views.Pages.Apps.Players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local dV=a.import(script,a.getModule(script,"@rbxts","services")).Players;local b8=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local p=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local function l2()local aT=ei("apps").players;local ho=p(function(F)local b0;if F.dashboard.apps.playerSelected~=nil then b0=dV:FindFirstChild(F.dashboard.apps.playerSelected)else b0=nil end;return b0 end)return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(186,186),position=UDim2.new(0.5,0,0,24)},{b.createElement("ImageLabel",{Image="https://www.roblox.com/headshot-thumbnail/image?userId="..tostring(ho and ho.UserId or dV.LocalPlayer.UserId).."&width=150&height=150&format=png",Size=am(150,150),Position=am(18,18),BackgroundColor3=aT.avatar.background,BackgroundTransparency=aT.avatar.transparency},{b.createElement("UICorner",{CornerRadius=UDim.new(1,0)})}),b.createElement(b8,{size=4,radius="circular"},{b.createElement("UIGradient",{Color=aT.avatar.gradient.color,Transparency=aT.avatar.gradient.transparency,Rotation=aT.avatar.gradient.rotation})})})end;local f=i(l2)return{default=f}end,newEnv("Orca.views.Pages.Apps.Players.Avatar"))()end)newModule("Players","ModuleScript","Orca.views.Pages.Apps.Players.Players","Orca.views.Pages.Apps.Players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local c1=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Card").default;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local l1=a.import(script,script.Parent,"Actions").default;local l2=a.import(script,script.Parent,"Avatar").default;local l3=a.import(script,script.Parent,"Selection").default;local l4=a.import(script,script.Parent,"Username").default;local function dV()local aT=ei("apps").players;return b.createElement(c1,{index=1,page=ai.Apps,theme=aT,size=am(326,648),position=UDim2.new(0,0,1,0)},{b.createElement(l2),b.createElement(l4),b.createElement(l1),b.createElement(l3)})end;local f=i(dV)return{default=f}end,newEnv("Orca.views.Pages.Apps.Players.Players"))()end)newModule("Selection","ModuleScript","Orca.views.Pages.Apps.Players.Selection","Orca.views.Pages.Apps.Players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local k=h.useEffect;local l=h.useMemo;local aH=h.useState;local ey=a.import(script,a.getModule(script,"@rbxts","services"))local dV=ey.Players;local kv=ey.TextService;local b8=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local bl=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Fill").default;local bm=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Glow")local bn=bm.default;local bo=bm.GlowRadius;local cv=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"constants").IS_DEV;local cK=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","flipper-hooks").useLinear;local aJ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local b_=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-delayed-update").useDelayedUpdate;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local aM=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","dashboard.action")local ip=aM.playerDeselected;local ho=aM.playerSelected;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local jH=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","array-util").arrayToMap;local ko=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","number-util").lerp;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local l5=20;local l6=60;local l7=326-24*2;local l8=60;local l9=NumberSequence.new({NumberSequenceKeypoint.new(0,1),NumberSequenceKeypoint.new(0.05,0),NumberSequenceKeypoint.new(0.9,0),NumberSequenceKeypoint.new(0.95,1),NumberSequenceKeypoint.new(1,1)})local function la()local U=aH(dV:GetPlayers())local lb=U[1]local lc=U[2]k(function()local ld=dV.PlayerAdded:Connect(function()lc(dV:GetPlayers())end)local le=dV.PlayerRemoving:Connect(function()lc(dV:GetPlayers())end)return function()ld:Disconnect()le:Disconnect()end end,{})return lb end;local lf;local function l3()local aW=aK()local lb=la()local ho=p(function(F)return F.dashboard.apps.playerSelected end)local lg=l(function()local y=function(kM)return kM.Name==ho end;local b0=nil;for e5,aw in ipairs(lb)do if y(aw,e5-1,lb)==true then b0=aw;break end end;local lh=b0;local c7=function(kM)return kM.Name~=ho and(kM~=dV.LocalPlayer or cv)end;local e1={}local bf=0;for av,aw in ipairs(lb)do if c7(aw,av-1,lb)==true then bf=bf+1;e1[bf]=aw end end;local li=function(hx,dG)return string.lower(hx.Name)<string.lower(dG.Name)end;table.sort(e1,li)local lj=e1;local b1;if lh then local dk={lh}local bi=#dk;table.move(lj,1,#lj,bi+1,dk)b1=dk else b1=lj end;return b1 end,{lb,ho})k(function()local b2=ho~=nil;if b2 then local y=function(eB)return eB.Name==ho end;local b0=nil;for e5,aw in ipairs(lg)do if y(aw,e5-1,lg)==true then b0=aw;break end end;b2=not b0 end;if b2 then aW(ip())end end,{lb,ho})local bc={size=am(326,280),position=am(0,368),padding={left=24,right=24,top=8},clipsDescendants=true}local be={}local bf=#be;local bg={Size=r(1,1),CanvasSize=am(0,#lg*(l6+l5)+l5),BackgroundTransparency=1,BorderSizePixel=0,ScrollBarImageTransparency=1,ScrollBarThickness=0,ClipsDescendants=false}local bh={}local bi=#bh;for av,aw in pairs(jH(lg,function(eB,c2)return{eB.Name,b.createElement(lf,{name=eB.Name,displayName=eB.DisplayName,userId=eB.UserId,index=c2})}end))do bh[av]=aw end;be[bf+1]=b.createElement("ScrollingFrame",bg,bh)return b.createElement(bk,bc,be)end;local f=i(l3)local function lk(C)local hp=C.name;local ll=C.userId;local lm=C.displayName;local c2=C.index;local aW=aK()local aT=ei("apps").players.playerButton;local c4=c0(ai.Apps)local ln=b_(c4,c4 and 170+c2*40 or 150)local lo=p(function(F)return F.dashboard.apps.playerSelected==hp end)local U=aH(false)local aY=U[1]local aZ=U[2]local lp="  "..lm.." (@"..hp..")"local lq=l(function()return kv:GetTextSize(lp,14,Enum.Font.GothamBold,Vector2.new(1000,l6))end,{lp})local lr=cK(aY and l7-l8-20-lq.X or 0,{velocity=aY and 40 or 150}):map(function(bU)return UDim.new(0,math.min(bU,0))end)local b0;if lo then b0=aT.accent else local b1;if aY then local b2=aT.backgroundHovered;if b2==nil then b2=aT.background:Lerp(aT.accent,0.1)end;b1=b2 else b1=aT.background end;b0=b1 end;local b3=aL(b0,{})local b1;if lo then b1=aT.accent else local fn;if aY then local b2=aT.backgroundHovered;if b2==nil then b2=aT.dropshadow:Lerp(aT.accent,0.5)end;fn=b2 else fn=aT.dropshadow end;b1=fn end;local ls=aL(b1,{})local b4=aL(lo and aT.foregroundAccent and aT.foregroundAccent or aT.foreground,{})local bc={size=am(l7,l6),position=aL(ln and am(0,(l5+l6)*c2)or am(-l7-24,(l5+l6)*c2),{}),zIndex=c2}local be={b.createElement(bn,{radius=bo.Size70,color=ls,size=UDim2.new(1,36,1,36),position=am(-18,5-18),transparency=aL(lo and aT.glowTransparency or(aY and ko(aT.dropshadowTransparency,aT.glowTransparency,0.5)or aT.dropshadowTransparency),{})}),b.createElement(bl,{color=b3,transparency=aL(aT.backgroundTransparency,{}),radius=8}),b.createElement("TextLabel",{Text=lp,Font="GothamBold",TextSize=14,TextColor3=b4,TextXAlignment=Enum.TextXAlignment.Left,TextYAlignment=Enum.TextYAlignment.Center,TextTransparency=aL(lo and 0 or(aY and aT.foregroundTransparency/2 or aT.foregroundTransparency),{}),BackgroundTransparency=1,Position=am(l8,1),Size=UDim2.new(1,-l8,1,-1),ClipsDescendants=true},{b.createElement("UIPadding",{PaddingLeft=lr}),b.createElement("UIGradient",{Transparency=l9})}),b.createElement("ImageLabel",{Image="https://www.roblox.com/headshot-thumbnail/image?userId="..tostring(ll).."&width=60&height=60&format=png",Size=UDim2.new(0,l6,0,l6),BackgroundTransparency=1},{b.createElement("UICorner",{CornerRadius=UDim.new(0,8)})})}local bf=#be;local bv=aT.outlined and b.createElement(b8,{color=b4,transparency=0.8,radius=8})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("TextButton",{[b.Event.Activated]=function()local eB=dV:FindFirstChild(hp)local b2=not lo;if b2 then local fn=eB;if fn~=nil then fn=fn:IsA("Player")end;b2=fn end;if b2 then aW(ho(eB))else aW(ip())end end,[b.Event.MouseEnter]=function()return aZ(true)end,[b.Event.MouseLeave]=function()return aZ(false)end,Text="",Transparency=1,Size=r(1,1)})return b.createElement(bk,bc,be)end;lf=i(lk)return{default=f}end,newEnv("Orca.views.Pages.Apps.Players.Selection"))()end)newModule("Username","ModuleScript","Orca.views.Pages.Apps.Players.Username","Orca.views.Pages.Apps.Players",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local dV=a.import(script,a.getModule(script,"@rbxts","services")).Players;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local p=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks").useAppSelector;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local function l4()local aT=ei("apps").players;local ho=p(function(F)local b0;if F.dashboard.apps.playerSelected~=nil then b0=dV:FindFirstChild(F.dashboard.apps.playerSelected)else b0=nil end;return b0 end)return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(278,49),position=UDim2.new(0.5,0,0,231)},{b.createElement("TextLabel",{Font="GothamBlack",Text=ho and ho.DisplayName or"N/A",TextSize=20,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Top",Size=r(1,1),BackgroundTransparency=1}),b.createElement("TextLabel",{Font="GothamBold",Text=ho and ho.Name or"Select a player",TextSize=16,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Bottom",TextTransparency=0.7,Size=r(1,1),BackgroundTransparency=1})})end;local f=i(l4)return{default=f}end,newEnv("Orca.views.Pages.Apps.Players.Username"))()end)newModule("Home","ModuleScript","Orca.views.Pages.Home","Orca.views.Pages",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Home").default;return g end,newEnv("Orca.views.Pages.Home"))()end)newModule("FriendActivity","ModuleScript","Orca.views.Pages.Home.FriendActivity","Orca.views.Pages.Home",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"FriendActivity").default;return g end,newEnv("Orca.views.Pages.Home.FriendActivity"))()end)newModule("FriendActivity","ModuleScript","Orca.views.Pages.Home.FriendActivity.FriendActivity","Orca.views.Pages.Home.FriendActivity",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local k=h.useEffect;local dn=h.useReducer;local aH=h.useState;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local c1=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Card").default;local dh=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-interval").useInterval;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local e3=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-friends").useFriendActivity;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local jH=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","array-util").arrayToMap;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local lt=a.import(script,script.Parent,"GameItem")local lu=lt.default;local lv=lt.GAME_PADDING;local function lw()local aT=ei("home").friendActivity;local U=dn(function(F)return F+1 end,0)local d2=U[1]local lx=U[2]local dv=e3({d2})local ly=dv[1]local dZ=dv[3]local lz=aH(ly)local e4=lz[1]local lA=lz[2]k(function()if#ly>0 then local y=function(hx,dG)return#hx.friends>#dG.friends end;table.sort(ly,y)lA(ly)end end,{ly})dh(function()return lx()end,#ly==0 and dZ~="pending"and 5000 or 30000)local bc={index=3,page=ai.Home,theme=aT,size=am(326,416),position=UDim2.new(0,374,1,0)}local be={b.createElement("TextLabel",{Text="Friend Activity",Font="GothamBlack",TextSize=20,TextColor3=aT.foreground,TextXAlignment="Left",TextYAlignment="Top",Position=am(24,24),BackgroundTransparency=1})}local bf=#be;local bg={anchor=Vector2.new(0,1),size=aL(#e4>0 and UDim2.new(1,0,0,344)or UDim2.new(1,0,0,0),{}),position=r(0,1)}local bh={}local bi=#bh;local lB={Size=r(1,1),ScrollBarThickness=0,ScrollBarImageTransparency=1,ScrollingDirection="Y",CanvasSize=am(0,#e4*(lv+156)+lv),BackgroundTransparency=1,BorderSizePixel=0}local lC={}local lD=#lC;for av,aw in pairs(jH(e4,function(e6,c2)return{tostring(e6.placeId),b.createElement(lu,{gameActivity=e6,index=c2})}end))do lC[av]=aw end;bh[bi+1]=b.createElement("ScrollingFrame",lB,lC)be[bf+1]=b.createElement(bk,bg,bh)return b.createElement(c1,bc,be)end;local f=i(lw)return{default=f}end,newEnv("Orca.views.Pages.Home.FriendActivity.FriendActivity"))()end)newModule("FriendItem","ModuleScript","Orca.views.Pages.Home.FriendActivity.FriendItem","Orca.views.Pages.Home.FriendActivity",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local aH=h.useState;local ey=a.import(script,a.getModule(script,"@rbxts","services"))local dV=ey.Players;local i5=ey.TeleportService;local b8=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local bl=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Fill").default;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local lE={frequency=6}local function lF(C)local e0=C.friend;local c2=C.index;local aT=ei("home").friendActivity.friendButton;local U=aH(false)local kZ=U[1]local aZ=U[2]local lG="https://www.roblox.com/headshot-thumbnail/image?userId="..tostring(e0.VisitorId).."&width=48&height=48&format=png"local bc={size=aL(kZ and am(96,48)or am(48,48),lE)}local be={b.createElement("ImageLabel",{Image="rbxassetid://8992244272",ImageColor3=aL(kZ and aT.accent or aT.dropshadow,lE),ImageTransparency=aL(kZ and aT.glowTransparency or aT.dropshadowTransparency,lE),Size=aL(kZ and am(88+36,74)or am(76,74),lE),Position=am(-14,-10),ScaleType="Slice",SliceCenter=Rect.new(Vector2.new(42,42),Vector2.new(42,42)),BackgroundTransparency=1}),b.createElement(bl,{radius=24,color=aL(kZ and aT.accent or aT.background,lE),transparency=aT.backgroundTransparency})}local bf=#be;local bv=aT.outlined and b.createFragment({border=b.createElement(b8,{radius=23,color=kZ and aT.foregroundAccent and aT.foregroundAccent or aT.foreground,transparency=0.7})})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("ImageLabel",{Image=lG,ScaleType="Crop",Size=am(48,48),LayoutOrder=c2,BackgroundTransparency=1},{b.createElement("UICorner",{CornerRadius=UDim.new(1,0)})})be[bf+2]=b.createElement(bk,{clipsDescendants=true},{b.createElement("ImageLabel",{Image="rbxassetid://8992244380",ImageColor3=kZ and aT.foregroundAccent and aT.foregroundAccent or aT.foreground,ImageTransparency=aT.foregroundTransparency,Size=am(36,36),Position=am(48,6),BackgroundTransparency=1})})be[bf+3]=b.createElement("TextButton",{Text="",AutoButtonColor=false,Size=r(1,1),BackgroundTransparency=1,[b.Event.Activated]=function()pcall(function()i5:TeleportToPlaceInstance(e0.PlaceId,e0.GameId,dV.LocalPlayer)end)end,[b.Event.MouseEnter]=function()return aZ(true)end,[b.Event.MouseLeave]=function()return aZ(false)end})return b.createElement(bk,bc,be)end;local f=i(lF)return{default=f}end,newEnv("Orca.views.Pages.Home.FriendActivity.FriendItem"))()end)newModule("GameItem","ModuleScript","Orca.views.Pages.Home.FriendActivity.GameItem","Orca.views.Pages.Home.FriendActivity",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local k_=h.pure;local l=h.useMemo;local b8=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Border").default;local b_=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-delayed-update").useDelayedUpdate;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local lF=a.import(script,script.Parent,"FriendItem").default;local lv=48;local function lu(C)local e6=C.gameActivity;local c2=C.index;local aT=ei("home").friendActivity;local c4=c0(ai.Home)local ln=b_(c4,c4 and 330+c2*100 or 300)local lH=l(function()return#e6.friends*(48+10)+96 end,{#e6.friends})local bc={Image=e6.thumbnail,ScaleType="Crop",Size=am(278,156),Position=aL(ln and am(24,c2*(lv+156))or am(-278,c2*(lv+156)),{}),BackgroundTransparency=1}local be={b.createElement(b8,{color=aT.foreground,radius=8,transparency=0.8}),b.createElement("UICorner",{CornerRadius=UDim.new(0,8)})}local bf=#be;local e8=e6.friends;local y=function(e0,c2)return{tostring(e0.VisitorId),b.createElement(lF,{friend=e0,index=c2})}end;local e1=table.create(#e8)for av,aw in ipairs(e8)do e1[av]=y(aw,av-1,e8)end;local jK={}for ev,aw in ipairs(e1)do jK[aw[1]]=aw[2]end;local bg={Size=UDim2.new(1,0,0,64),Position=UDim2.new(0,0,1,-24),CanvasSize=am(lH,0),ScrollingDirection="X",ScrollBarThickness=0,ScrollBarImageTransparency=1,BackgroundTransparency=1,BorderSizePixel=0,ClipsDescendants=false}local bh={b.createElement("UIListLayout",{SortOrder="LayoutOrder",FillDirection="Horizontal",HorizontalAlignment="Left",VerticalAlignment="Top",Padding=UDim.new(0,10)}),b.createElement("UIPadding",{PaddingLeft=UDim.new(0,10)})}local bi=#bh;for av,aw in pairs(jK)do bh[av]=aw end;be[bf+1]=b.createElement("ScrollingFrame",bg,bh)return b.createElement("ImageLabel",bc,be)end;local f=k_(lu)return{GAME_PADDING=lv,default=f}end,newEnv("Orca.views.Pages.Home.FriendActivity.GameItem"))()end)newModule("Home","ModuleScript","Orca.views.Pages.Home.Home","Orca.views.Pages.Home",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local k_=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).pure;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local cd=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-scale").useScale;local r=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2").scale;local lw=a.import(script,script.Parent,"FriendActivity").default;local lI=a.import(script,script.Parent,"Profile").default;local lJ=a.import(script,script.Parent,"Server").default;local lK=a.import(script,script.Parent,"Title").default;local function lL()local ck=cd()return b.createElement(bk,{position=r(0,1),anchor=Vector2.new(0,1)},{b.createElement("UIScale",{Scale=ck}),b.createElement(lK),b.createElement(lJ),b.createElement(lw),b.createElement(lI)})end;local f=k_(lL)return{default=f}end,newEnv("Orca.views.Pages.Home.Home"))()end)newModule("Profile","ModuleScript","Orca.views.Pages.Home.Profile","Orca.views.Pages.Home",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Profile").default;return g end,newEnv("Orca.views.Pages.Home.Profile"))()end)newModule("Actions","ModuleScript","Orca.views.Pages.Home.Profile.Actions","Orca.views.Pages.Home.Profile",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local aQ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","ActionButton").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local function l1()local aT=ei("home").profile;return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(278,49),position=UDim2.new(0.5,0,0,575)},{b.createElement(aQ,{action="refresh",hint="<font face='GothamBlack'>Refresh</font> your character at this location",theme=aT,image="rbxassetid://8992253511",position=am(0,0)}),b.createElement(aQ,{action="ghost",hint="<font face='GothamBlack'>Spawn a ghost</font> and go to it when disabled",theme=aT,image="rbxassetid://8992253792",position=am(72,0),canDeactivate=true}),b.createElement(aQ,{action="godmode",hint="<font face='GothamBlack'>Set godmode</font>, may break respawn",theme=aT,image="rbxassetid://8992253678",position=am(145,0)}),b.createElement(aQ,{action="freecam",hint="<font face='GothamBlack'>Set freecam</font>, use Q & E to move vertically",theme=aT,image="rbxassetid://8992253933",position=am(217,0),canDeactivate=true})})end;local f=i(l1)return{default=f}end,newEnv("Orca.views.Pages.Home.Profile.Actions"))()end)newModule("Avatar","ModuleScript","Orca.views.Pages.Home.Profile.Avatar","Orca.views.Pages.Home.Profile",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local dV=a.import(script,a.getModule(script,"@rbxts","services")).Players;local b8=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local lM="https://www.roblox.com/headshot-thumbnail/image?userId="..tostring(dV.LocalPlayer.UserId).."&width=150&height=150&format=png"local function l2()local aT=ei("home").profile;return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(186,186),position=UDim2.new(0.5,0,0,24)},{b.createElement("ImageLabel",{Image=lM,Size=am(150,150),Position=am(18,18),BackgroundColor3=aT.avatar.background,BackgroundTransparency=aT.avatar.transparency},{b.createElement("UICorner",{CornerRadius=UDim.new(1,0)})}),b.createElement(b8,{size=4,radius="circular"},{b.createElement("UIGradient",{Color=aT.avatar.gradient.color,Transparency=aT.avatar.gradient.transparency,Rotation=aT.avatar.gradient.rotation})})})end;local f=i(l2)return{default=f}end,newEnv("Orca.views.Pages.Home.Profile.Avatar"))()end)newModule("Info","ModuleScript","Orca.views.Pages.Home.Profile.Info","Orca.views.Pages.Home.Profile",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local dV=a.import(script,a.getModule(script,"@rbxts","services")).Players;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local b_=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-delayed-update").useDelayedUpdate;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local dW=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-friends").useFriends;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local function lN()local aT=ei("home").profile;local c4=c0(ai.Home)local U=dW()local dY=U[1]if dY==nil then dY={}end;local dZ=U[3]local lO=#dY;local y=function(e0)return e0.PlaceId~=nil and e0.PlaceId==game.PlaceId end;local e1={}local bf=0;for av,aw in ipairs(dY)do if y(aw,av-1,dY)==true then bf=bf+1;e1[bf]=aw end end;local lP=#e1;local lQ=b_(c4,400,function(lR)return not lR end)local lS=b_(c4 and dZ~="pending",500,function(lR)return not lR end)local lT=b_(c4 and dZ~="pending",600,function(lR)return not lR end)return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(278,48),position=UDim2.new(0.5,0,0,300)},{b.createElement("Frame",{Size=am(0,26),Position=am(90,11),BackgroundTransparency=1},{b.createElement("UIStroke",{Thickness=0.5,Color=aT.foreground,Transparency=0.7})}),b.createElement("Frame",{Size=am(0,26),Position=am(187,11),BackgroundTransparency=1},{b.createElement("UIStroke",{Thickness=0.5,Color=aT.foreground,Transparency=0.7})}),b.createElement("TextLabel",{Font="GothamBold",Text="Joined\n"..tostring(os.date("%m/%d/%Y",os.time()-dV.LocalPlayer.AccountAge*24*60*60)),TextSize=13,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Center",TextTransparency=aL(lQ and 0.2 or 1,{}),Size=am(85,48),Position=aL(lQ and am(0,0)or am(-20,0),{}),BackgroundTransparency=1}),b.createElement("TextLabel",{Font="GothamBold",Text=lP==1 and"1 friend\njoined"or tostring(lP).." friends\njoined",TextSize=13,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Center",TextTransparency=aL(lS and 0.2 or 1,{}),Size=am(85,48),Position=aL(lS and am(97,0)or am(97-20,0),{}),BackgroundTransparency=1}),b.createElement("TextLabel",{Font="GothamBold",Text=lO==1 and"1 friend\nonline"or tostring(lO).." friends\nonline",TextSize=13,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Center",TextTransparency=aL(lT and 0.2 or 1,{}),Size=am(85,48),Position=aL(lT and am(193,0)or am(193-20,0),{}),BackgroundTransparency=1})})end;local f=i(lN)return{default=f}end,newEnv("Orca.views.Pages.Home.Profile.Info"))()end)newModule("Profile","ModuleScript","Orca.views.Pages.Home.Profile.Profile","Orca.views.Pages.Home.Profile",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local c1=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Card").default;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local l1=a.import(script,script.Parent,"Actions").default;local l2=a.import(script,script.Parent,"Avatar").default;local lN=a.import(script,script.Parent,"Info").default;local lU=a.import(script,script.Parent,"Sliders").default;local l4=a.import(script,script.Parent,"Username").default;local function lI()local aT=ei("home").profile;return b.createElement(c1,{index=1,page=ai.Home,theme=aT,size=am(326,648),position=UDim2.new(0,0,1,0)},{b.createElement(bk,{padding={left=24,right=24}},{b.createElement(l2),b.createElement(l4),b.createElement(lN),b.createElement(lU),b.createElement(l1)})})end;local f=i(lI)return{default=f}end,newEnv("Orca.views.Pages.Home.Profile.Profile"))()end)newModule("Sliders","ModuleScript","Orca.views.Pages.Home.Profile.Sliders","Orca.views.Pages.Home.Profile",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local cc=h.useBinding;local aH=h.useState;local aI=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","BrightButton").default;local bD=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","BrightSlider").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local aJ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local aM=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","dashboard.action")local aN=aM.clearHint;local aO=aM.setHint;local lV=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","jobs.action")local aP=lV.setJobActive;local iq=lV.setJobValue;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local bB={frequency=5}local lW;local function lU()return b.createElement(bk,{size=am(278,187),position=am(0,368)},{b.createElement(lW,{display="Flight",hint="<font face='GothamBlack'>Configure flight</font> in studs per second",jobName="flight",units="studs/s",min=10,max=100,position=0}),b.createElement(lW,{display="Speed",hint="<font face='GothamBlack'>Configure speed</font> in studs per second",jobName="walkSpeed",units="studs/s",min=0,max=100,position=69}),b.createElement(lW,{display="Jump",hint="<font face='GothamBlack'>Configure height</font> in studs",jobName="jumpHeight",units="studs",min=0,max=500,position=138})})end;local f=lU;local function lX(kX)local aT=ei("home").profile;local aW=aK()local eM=p(function(F)return F.jobs[kX.jobName]end)local U=cc(eM.value)local d3=U[1]local lY=U[2]local dv=aH(false)local aY=dv[1]local aZ=dv[2]local a_=aT.highlight[kX.jobName]local b0;if eM.active then b0=a_ else local b1;if aY then local b2=aT.button.backgroundHovered;if b2==nil then b2=aT.button.background:Lerp(a_,0.1)end;b1=b2 else b1=aT.button.background end;b0=b1 end;local lZ=aL(b0,{})local l_=aL(eM.active and aT.button.foregroundAccent and aT.button.foregroundAccent or aT.foreground,{})return b.createElement(bk,{size=am(278,49),position=am(0,kX.position)},{b.createElement(bD,{onValueChanged=lY,onRelease=function()return aW(iq(kX.jobName,math.round(d3:getValue())))end,min=kX.min,max=kX.max,initialValue=eM.value,size=am(181,49),position=am(0,0),radius=8,color=aT.slider.background,accentColor=a_,borderEnabled=aT.slider.outlined,borderColor=aT.slider.foreground,transparency=aT.slider.backgroundTransparency,indicatorTransparency=aT.slider.indicatorTransparency},{b.createElement("TextLabel",{Font="GothamBold",Text=d3:map(function(d3)return tostring(math.round(d3)).." "..kX.units end),TextSize=15,TextColor3=aT.slider.foreground,TextXAlignment="Center",TextYAlignment="Center",TextTransparency=aT.slider.foregroundTransparency,Size=r(1,1),BackgroundTransparency=1})}),b.createElement(aI,{onActivate=function()return aW(aP(kX.jobName,not eM.active))end,onHover=function(aY)if aY then aZ(true)aW(aO(kX.hint))else aZ(false)aW(aN())end end,size=am(85,49),position=am(193,0),radius=8,color=lZ,borderEnabled=aT.button.outlined,borderColor=l_,transparency=aT.button.backgroundTransparency},{b.createElement("TextLabel",{Font="GothamBold",Text=kX.display,TextSize=15,TextColor3=l_,TextXAlignment="Center",TextYAlignment="Center",TextTransparency=aL(eM.active and 0 or(aY and aT.button.foregroundTransparency-0.25 or aT.button.foregroundTransparency),{}),Size=r(1,1),BackgroundTransparency=1})})})end;lW=i(lX)return{default=f}end,newEnv("Orca.views.Pages.Home.Profile.Sliders"))()end)newModule("Username","ModuleScript","Orca.views.Pages.Home.Profile.Username","Orca.views.Pages.Home.Profile",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local dV=a.import(script,a.getModule(script,"@rbxts","services")).Players;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local function l4()local aT=ei("home").profile;return b.createElement(bk,{anchor=Vector2.new(0.5,0),size=am(278,49),position=UDim2.new(0.5,0,0,231)},{b.createElement("TextLabel",{Font="GothamBlack",Text=dV.LocalPlayer.DisplayName,TextSize=20,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Top",Size=r(1,1),BackgroundTransparency=1}),b.createElement("TextLabel",{Font="GothamBold",Text=dV.LocalPlayer.Name,TextSize=16,TextColor3=aT.foreground,TextXAlignment="Center",TextYAlignment="Bottom",TextTransparency=0.7,Size=r(1,1),BackgroundTransparency=1})})end;local f=i(l4)return{default=f}end,newEnv("Orca.views.Pages.Home.Profile.Username"))()end)newModule("Server","ModuleScript","Orca.views.Pages.Home.Server","Orca.views.Pages.Home",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Server").default;return g end,newEnv("Orca.views.Pages.Home.Server"))()end)newModule("Server","ModuleScript","Orca.views.Pages.Home.Server.Server","Orca.views.Pages.Home.Server",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local dV=a.import(script,a.getModule(script,"@rbxts","services")).Players;local c1=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Card").default;local cv=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"constants").IS_DEV;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local m0=a.import(script,script.Parent,"ServerAction").default;local m1=a.import(script,script.Parent,"StatusLabel").default;local function lJ()local aT=ei("home").server;return b.createElement(c1,{index=2,page=ai.Home,theme=aT,size=am(326,184),position=UDim2.new(0,374,1,-416-48)},{b.createElement("TextLabel",{Text="Server",Font="GothamBlack",TextSize=20,TextColor3=aT.foreground,TextXAlignment="Left",TextYAlignment="Top",Position=am(24,24),BackgroundTransparency=1}),b.createElement(m1,{index=0,offset=69,units="players",getValue=function()return tostring(#dV:GetPlayers()).." / "..tostring(dV.MaxPlayers)end}),b.createElement(m1,{index=1,offset=108,units="elapsed",getValue=function()local m2=cv and os.clock()or time()local m3=math.floor(m2/86400)local m4=math.floor((m2-m3*86400)/3600)local m5=math.floor((m2-m3*86400-m4*3600)/60)local m6=math.floor(m2-m3*86400-m4*3600-m5*60)return m3>0 and tostring(m3).." days"or(m4>0 and tostring(m4).." hours"or(m5>0 and tostring(m5).." minutes"or tostring(m6).." seconds"))end}),b.createElement(m1,{index=2,offset=147,units="ping",getValue=function()return tostring(math.round(dV.LocalPlayer:GetNetworkPing()*1000)).." ms"end}),b.createElement(m0,{action="switchServer",hint="<font face='GothamBlack'>Switch</font> to a different server",icon="rbxassetid://8992259774",size=am(66,50),position=UDim2.new(1,-66-24,1,-100-16-12)}),b.createElement(m0,{action="rejoinServer",hint="<font face='GothamBlack'>Rejoin</font> this server",icon="rbxassetid://8992259894",size=am(66,50),position=UDim2.new(1,-66-24,1,-50-16)})})end;local f=i(lJ)return{default=f}end,newEnv("Orca.views.Pages.Home.Server.Server"))()end)newModule("ServerAction","ModuleScript","Orca.views.Pages.Home.Server.ServerAction","Orca.views.Pages.Home.Server",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local aH=h.useState;local aI=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","BrightButton").default;local aJ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local aM=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","dashboard.action")local aN=aM.clearHint;local aO=aM.setHint;local aP=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","jobs.action").setJobActive;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local function m0(C)local aR=C.action;local aS=C.hint;local m7=C.icon;local L=C.size;local M=C.position;local aW=aK()local aT=ei("home").server[aR=="switchServer"and"switchButton"or"rejoinButton"]local aX=p(function(F)return F.jobs[aR].active end)local U=aH(false)local aY=U[1]local aZ=U[2]local b0;if aX then b0=aT.accent else local b1;if aY then local b2=aT.backgroundHovered;if b2==nil then b2=aT.background:Lerp(aT.accent,0.1)end;b1=b2 else b1=aT.background end;b0=b1 end;local b3=aL(b0,{})local b4=aL(aX and aT.foregroundAccent and aT.foregroundAccent or aT.foreground,{})return b.createElement(aI,{onActivate=function()return aW(aP(aR,not aX))end,onHover=function(aY)if aY then aZ(true)aW(aO(aS))else aZ(false)aW(aN())end end,size=L,position=M,radius=8,color=b3,borderEnabled=aT.outlined,borderColor=b4,transparency=aT.backgroundTransparency},{b.createElement("ImageLabel",{Image=m7,ImageColor3=b4,ImageTransparency=aL(aX and 0 or(aY and aT.foregroundTransparency-0.25 or aT.foregroundTransparency),{}),AnchorPoint=Vector2.new(0.5,0.5),Size=am(36,36),Position=r(0.5,0.5),BackgroundTransparency=1})})end;local f=i(m0)return{default=f}end,newEnv("Orca.views.Pages.Home.Server.ServerAction"))()end)newModule("StatusLabel","ModuleScript","Orca.views.Pages.Home.Server.StatusLabel","Orca.views.Pages.Home.Server",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local l=h.useMemo;local aH=h.useState;local kv=a.import(script,a.getModule(script,"@rbxts","services")).TextService;local b_=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-delayed-update").useDelayedUpdate;local dh=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-interval").useInterval;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local am=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2").px;local function m1(C)local ct=C.offset;local c2=C.index;local m8=C.units;local m9=C.getValue;local aT=ei("home").server;local U=aH(m9)local d3=U[1]local lY=U[2]local c4=c0(ai.Home)local ln=b_(c4,c4 and 330+c2*100 or 300)local ma=l(function()return kv:GetTextSize(d3 .." ",16,"GothamBold",Vector2.new()).X end,{d3})dh(function()lY(m9())end,1000)return b.createFragment({b.createElement("TextLabel",{Text=d3,RichText=true,Font="GothamBold",TextSize=16,TextColor3=aT.foreground,TextTransparency=aL(ln and 0 or 1,{frequency=2}),TextXAlignment="Left",TextYAlignment="Top",Position=aL(ln and am(24,ct)or am(0,ct),{}),BackgroundTransparency=1}),b.createElement("TextLabel",{Text=m8,RichText=true,Font="GothamBold",TextSize=16,TextColor3=aT.foreground,TextTransparency=aL(ln and 0.4 or 1,{}),TextXAlignment="Left",TextYAlignment="Top",Position=aL(ln and am(24+ma,ct)or am(0+ma,ct),{}),BackgroundTransparency=1})})end;local f=i(m1)return{default=f}end,newEnv("Orca.views.Pages.Home.Server.StatusLabel"))()end)newModule("Title","ModuleScript","Orca.views.Pages.Home.Title","Orca.views.Pages.Home",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local c1=a.import(script,script.Parent.Parent.Parent.Parent,"components","Card").default;local cr=a.import(script,script.Parent.Parent.Parent.Parent,"components","ParallaxImage").default;local cw=a.import(script,script.Parent.Parent.Parent.Parent,"constants").VERSION_TAG;local b_=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-delayed-update").useDelayedUpdate;local aL=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local e9=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-parallax-offset").useParallaxOffset;local ei=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local al=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local mb;local function lK()local aT=ei("home").title;local ct=e9()return b.createElement(c1,{index=0,page=ai.Home,theme=aT,size=am(326,184),position=UDim2.new(0,0,1,-648-48)},{b.createElement(cr,{image="rbxassetid://9049308243",imageSize=Vector2.new(652,368),padding=Vector2.new(30,30),offset=ct},{b.createElement("UICorner",{CornerRadius=UDim.new(0,12)})}),b.createElement("ImageLabel",{Image="rbxassetid://9048947177",Size=r(1,1),ImageTransparency=0.3,BackgroundTransparency=1},{b.createElement("UICorner",{CornerRadius=UDim.new(0,12)})}),b.createElement(bk,{padding={top=24,left=24}},{b.createElement(mb,{index=0,text="Orca",font=Enum.Font.GothamBlack,size=20,position=am(0,0)}),b.createElement(mb,{index=1,text=cw,position=am(0,40)}),b.createElement(mb,{index=2,text="By 0866",position=am(0,63),transparency=0.15}),b.createElement(mb,{index=3,text="Pls star repo",position=am(0,86),transparency=0.3}),b.createElement(mb,{index=4,text="richie0866/orca",position=UDim2.new(0,0,1,-40),transparency=0.45})})})end;local f=i(lK)local function mc(kX)local U=kX;local c2=U.index;local lp=U.text;local md=U.font;if md==nil then md=Enum.Font.GothamBold end;local L=U.size;if L==nil then L=16 end;local M=U.position;local ba=U.transparency;if ba==nil then ba=0 end;local aT=ei("home").title;local c4=c0(ai.Home)local c5=b_(c4,c2*100+300,function(hy)return not hy end)local bc={Text=lp,Font=md,TextColor3=aT.foreground,TextSize=L,TextTransparency=aL(c5 and ba or 1,{frequency=2}),TextXAlignment="Left",TextYAlignment="Top",Size=am(200,24)}local b0;if c5 then b0=M else local y=am(24,0)b0=M-y end;bc.Position=aL(b0,{})bc.BackgroundTransparency=1;return b.createElement("TextLabel",bc)end;mb=i(mc)return{default=f}end,newEnv("Orca.views.Pages.Home.Title"))()end)newModule("Options","ModuleScript","Orca.views.Pages.Options","Orca.views.Pages",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Options").default;return g end,newEnv("Orca.views.Pages.Options"))()end)newModule("Config","ModuleScript","Orca.views.Pages.Options.Config","Orca.views.Pages.Options",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Config").default;return g end,newEnv("Orca.views.Pages.Options.Config"))()end)newModule("Config","ModuleScript","Orca.views.Pages.Options.Config.Config","Orca.views.Pages.Options.Config",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local c1=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Card").default;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local me=a.import(script,script.Parent,"ConfigItem")local mf=me.default;local l6=me.ENTRY_HEIGHT;local l5=me.PADDING;local mg=1;local function mh()local aT=ei("options").config;return b.createElement(c1,{index=0,page=ai.Options,theme=aT,size=am(326,184),position=UDim2.new(0,0,1,-416-48)},{b.createElement("TextLabel",{Text="Options",Font="GothamBlack",TextSize=20,TextColor3=aT.foreground,TextXAlignment="Left",TextYAlignment="Top",Position=am(24,24),BackgroundTransparency=1}),b.createElement(bk,{size=am(326,348),position=am(0,68),padding={left=24,right=24,top=8},clipsDescendants=true},{b.createElement("ScrollingFrame",{Size=r(1,1),CanvasSize=am(0,mg*(l6+l5)+l5),BackgroundTransparency=1,BorderSizePixel=0,ScrollBarImageTransparency=1,ScrollBarThickness=0,ClipsDescendants=false},{b.createElement(mf,{action="acrylicBlur",description="Acrylic background blurring",hint="<font face='GothamBlack'>Toggle BG blur</font> in some themes. May be detectable when enabled.",index=0})})})})end;local f=i(mh)return{default=f}end,newEnv("Orca.views.Pages.Options.Config.Config"))()end)newModule("ConfigItem","ModuleScript","Orca.views.Pages.Options.Config.ConfigItem","Orca.views.Pages.Options.Config",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local k_=h.pure;local aH=h.useState;local b8=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local bl=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Fill").default;local bm=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Glow")local bn=bm.default;local bo=bm.GlowRadius;local aJ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local aM=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","dashboard.action")local aN=aM.clearHint;local aO=aM.setHint;local ir=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","options.action").setConfig;local ko=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","number-util").lerp;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local l5=20;local l6=60;local l7=326-24*2;local l8=16;local function mf(C)local aR=C.action;local mi=C.description;local aS=C.hint;local c2=C.index;local aW=aK()local mj=ei("options").config.configButton;local aX=p(function(F)return F.options.config[aR]end)local U=aH(false)local aY=U[1]local aZ=U[2]local b0;if aX then b0=mj.accent else local b1;if aY then local b2=mj.backgroundHovered;if b2==nil then b2=mj.background:Lerp(mj.accent,0.1)end;b1=b2 else b1=mj.background end;b0=b1 end;local b3=aL(b0,{})local b1;if aX then b1=mj.accent else local fn;if aY then local b2=mj.backgroundHovered;if b2==nil then b2=mj.dropshadow:Lerp(mj.accent,0.5)end;fn=b2 else fn=mj.dropshadow end;b1=fn end;local ls=aL(b1,{})local b4=aL(aX and mj.foregroundAccent and mj.foregroundAccent or mj.foreground,{})local bc={size=am(l7,l6),position=am(0,(l5+l6)*c2),zIndex=c2}local be={b.createElement(bn,{radius=bo.Size70,color=ls,size=UDim2.new(1,36,1,36),position=am(-18,5-18),transparency=aL(aX and mj.glowTransparency or(aY and ko(mj.dropshadowTransparency,mj.glowTransparency,0.5)or mj.dropshadowTransparency),{})}),b.createElement(bl,{color=b3,transparency=mj.backgroundTransparency,radius=8}),b.createElement("TextLabel",{Text=mi,Font="GothamBold",TextSize=16,TextColor3=b4,TextXAlignment="Left",TextYAlignment="Center",TextTransparency=aL(aX and 0 or(aY and mj.foregroundTransparency/2 or mj.foregroundTransparency),{}),Position=am(l8,1),Size=UDim2.new(1,-l8,1,-1),BackgroundTransparency=1,ClipsDescendants=true})}local bf=#be;local bv=mj.outlined and b.createElement(b8,{color=b4,transparency=0.8,radius=8})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("TextButton",{[b.Event.Activated]=function()return aW(ir(aR,not aX))end,[b.Event.MouseEnter]=function()aZ(true)aW(aO(aS))end,[b.Event.MouseLeave]=function()aZ(false)aW(aN())end,Text="",Size=r(1,1),Transparency=1})return b.createElement(bk,bc,be)end;local f=k_(mf)return{PADDING=l5,ENTRY_HEIGHT=l6,ENTRY_WIDTH=l7,ENTRY_TEXT_PADDING=l8,default=f}end,newEnv("Orca.views.Pages.Options.Config.ConfigItem"))()end)newModule("Options","ModuleScript","Orca.views.Pages.Options.Options","Orca.views.Pages.Options",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local k_=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).pure;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local cd=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-scale").useScale;local r=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2").scale;local mh=a.import(script,script.Parent,"Config").default;local mk=a.import(script,script.Parent,"Shortcuts").default;local ml=a.import(script,script.Parent,"Themes").default;local function mm()local ck=cd()return b.createElement(bk,{position=r(0,1),anchor=Vector2.new(0,1)},{b.createElement("UIScale",{Scale=ck}),b.createElement(mh),b.createElement(ml),b.createElement(mk)})end;local f=k_(mm)return{default=f}end,newEnv("Orca.views.Pages.Options.Options"))()end)newModule("Shortcuts","ModuleScript","Orca.views.Pages.Options.Shortcuts","Orca.views.Pages.Options",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Shortcuts").default;return g end,newEnv("Orca.views.Pages.Options.Shortcuts"))()end)newModule("ShortcutItem","ModuleScript","Orca.views.Pages.Options.Shortcuts.ShortcutItem","Orca.views.Pages.Options.Shortcuts",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local k_=h.pure;local k=h.useEffect;local aH=h.useState;local bx=a.import(script,a.getModule(script,"@rbxts","services")).UserInputService;local b8=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local bl=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Fill").default;local bm=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Glow")local bn=bm.default;local bo=bm.GlowRadius;local aJ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local b_=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-delayed-update").useDelayedUpdate;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local mn=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","options.action")local iv=mn.removeShortcut;local is=mn.setShortcut;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local ko=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","number-util").lerp;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local l5=20;local l6=60;local l7=326-24*2;local l8=16;local function mo(C)local br=C.onActivate;local mp=C.onSelect;local mq=C.selectedItem;local aR=C.action;local mi=C.description;local c2=C.index;local aW=aK()local mj=ei("options").shortcuts.shortcutButton;local c4=c0(ai.Options)local ln=b_(c4,c4 and 250+c2*40 or 230)local it=p(function(F)return F.options.shortcuts[aR]end)local ax=Enum.KeyCode:GetEnumItems()local y=function(mr)return mr.Value==it end;local b0=nil;for e5,aw in ipairs(ax)do if y(aw,e5-1,ax)==true then b0=aw;break end end;local ms=b0;local lh=mq==aR;local U=aH(false)local aY=U[1]local aZ=U[2]k(function()if mq~=nil then return nil end;local ao=bx.InputBegan:Connect(function(bV,eN)if not eN and bV.KeyCode.Value==it then br()end end)return function()ao:Disconnect()end end,{mq,it})k(function()if not lh then return nil end;local ao=bx.InputBegan:Connect(function(bV,eN)if eN then return nil end;if bV.UserInputType==Enum.UserInputType.MouseButton1 then mp(nil)return nil end;local az=bV.KeyCode;repeat if az==Enum.KeyCode.Unknown then break end;if az==Enum.KeyCode.Escape then aW(iv(aR))mp(nil)break end;if az==Enum.KeyCode.Backspace then aW(iv(aR))mp(nil)break end;if az==Enum.KeyCode.Return then mp(nil)break end;aW(is(aR,bV.KeyCode.Value))mp(nil)break until true end)return function()ao:Disconnect()end end,{lh})local b1;if lh then b1=mj.accent else local fn;if aY then local b2=mj.backgroundHovered;if b2==nil then b2=mj.background:Lerp(mj.accent,0.1)end;fn=b2 else fn=mj.background end;b1=fn end;local b3=aL(b1,{})local fn;if lh then fn=mj.accent else local mt;if aY then local b2=mj.backgroundHovered;if b2==nil then b2=mj.dropshadow:Lerp(mj.accent,0.5)end;mt=b2 else mt=mj.dropshadow end;fn=mt end;local ls=aL(fn,{})local b4=aL(lh and mj.foregroundAccent and mj.foregroundAccent or mj.foreground,{})local bc={size=am(l7,l6),position=aL(ln and am(0,(l5+l6)*c2)or am(-l7-24,(l5+l6)*c2),{}),zIndex=c2}local be={b.createElement(bn,{radius=bo.Size70,color=ls,size=UDim2.new(1,36,1,36),position=am(-18,5-18),transparency=aL(lh and mj.glowTransparency or(aY and ko(mj.dropshadowTransparency,mj.glowTransparency,0.5)or mj.dropshadowTransparency),{})}),b.createElement(bl,{color=b3,transparency=mj.backgroundTransparency,radius=8}),b.createElement("TextLabel",{Text=mi,Font="GothamBold",TextSize=16,TextColor3=b4,TextXAlignment="Left",TextYAlignment="Center",TextTransparency=aL(lh and 0 or(aY and mj.foregroundTransparency/2 or mj.foregroundTransparency),{}),Position=am(l8,1),Size=UDim2.new(1,-l8,1,-1),BackgroundTransparency=1,ClipsDescendants=true}),b.createElement("TextLabel",{Text=ms and ms.Name or"Not bound",Font="GothamBold",TextSize=16,TextColor3=b4,TextXAlignment="Center",TextYAlignment="Center",TextTransparency=aL(lh and 0 or(aY and mj.foregroundTransparency/2 or mj.foregroundTransparency),{}),TextTruncate="AtEnd",AnchorPoint=Vector2.new(1,0),Position=UDim2.new(1,0,0,1),Size=UDim2.new(0,124,1,-1),BackgroundTransparency=1,ClipsDescendants=true}),b.createElement("Frame",{Size=mj.outlined and UDim2.new(0,1,1,-2)or UDim2.new(0,1,1,-36),Position=mj.outlined and UDim2.new(1,-124,0,1)or UDim2.new(1,-124,0,18),BackgroundColor3=b4,BackgroundTransparency=0.8,BorderSizePixel=0})}local bf=#be;local bv=mj.outlined and b.createElement(b8,{color=b4,transparency=0.8,radius=8})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("TextButton",{[b.Event.Activated]=function()return mp(aR)end,[b.Event.MouseEnter]=function()return aZ(true)end,[b.Event.MouseLeave]=function()return aZ(false)end,Text="",Size=r(1,1),Transparency=1})return b.createElement(bk,bc,be)end;local f=k_(mo)return{PADDING=l5,ENTRY_HEIGHT=l6,ENTRY_WIDTH=l7,ENTRY_TEXT_PADDING=l8,default=f}end,newEnv("Orca.views.Pages.Options.Shortcuts.ShortcutItem"))()end)newModule("Shortcuts","ModuleScript","Orca.views.Pages.Options.Shortcuts.Shortcuts","Orca.views.Pages.Options.Shortcuts",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local aH=h.useState;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local c1=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Card").default;local aJ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local cU=aJ.useAppStore;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ig=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","dashboard.action").toggleDashboard;local aP=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","jobs.action").setJobActive;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local mu=a.import(script,script.Parent,"ShortcutItem")local mo=mu.default;local l6=mu.ENTRY_HEIGHT;local l5=mu.PADDING;local mg=5;local function mk()local eu=cU()local aW=aK()local aT=ei("options").shortcuts;local U=aH(nil)local mq=U[1]local mv=U[2]return b.createElement(c1,{index=1,page=ai.Options,theme=aT,size=am(326,416),position=UDim2.new(0,0,1,0)},{b.createElement("TextLabel",{Text="Shortcuts",Font="GothamBlack",TextSize=20,TextColor3=aT.foreground,TextXAlignment="Left",TextYAlignment="Top",Position=am(24,24),BackgroundTransparency=1}),b.createElement(bk,{size=am(326,348),position=am(0,68),padding={left=24,right=24,top=8},clipsDescendants=true},{b.createElement("ScrollingFrame",{Size=r(1,1),CanvasSize=am(0,mg*(l6+l5)+l5),BackgroundTransparency=1,BorderSizePixel=0,ScrollBarImageTransparency=1,ScrollBarThickness=0,ClipsDescendants=false},{b.createElement(mo,{onActivate=function()aW(ig())end,onSelect=mv,selectedItem=mq,action="toggleDashboard",description="Open Orca",index=0}),b.createElement(mo,{onActivate=function()aW(aP("flight",not eu:getState().jobs.flight.active))end,onSelect=mv,selectedItem=mq,action="toggleFlight",description="Toggle flight",index=1}),b.createElement(mo,{onActivate=function()aW(aP("ghost",not eu:getState().jobs.ghost.active))end,onSelect=mv,selectedItem=mq,action="setGhost",description="Set ghost mode",index=2}),b.createElement(mo,{onActivate=function()aW(aP("walkSpeed",not eu:getState().jobs.walkSpeed.active))end,onSelect=mv,selectedItem=mq,action="setSpeed",description="Set walk speed",index=3}),b.createElement(mo,{onActivate=function()aW(aP("jumpHeight",not eu:getState().jobs.jumpHeight.active))end,onSelect=mv,selectedItem=mq,action="setJumpHeight",description="Set jump height",index=4})})})})end;local f=i(mk)return{default=f}end,newEnv("Orca.views.Pages.Options.Shortcuts.Shortcuts"))()end)newModule("Themes","ModuleScript","Orca.views.Pages.Options.Themes","Orca.views.Pages.Options",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Themes").default;return g end,newEnv("Orca.views.Pages.Options.Themes"))()end)newModule("ThemeItem","ModuleScript","Orca.views.Pages.Options.Themes.ThemeItem","Orca.views.Pages.Options.Themes",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local aH=h.useState;local b8=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local bl=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Fill").default;local bm=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Glow")local bn=bm.default;local bo=bm.GlowRadius;local aJ=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","rodux-hooks")local aK=aJ.useAppDispatch;local p=aJ.useAppSelector;local b_=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-delayed-update").useDelayedUpdate;local aL=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local iw=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","actions","options.action").setTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local kT=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","color3")local jN=kT.getLuminance;local ak=kT.hex;local ko=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","number-util").lerp;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local l5=20;local l6=60;local l7=326-24*2;local l8=16;local mw;local function mx(C)local aT=C.theme;local c2=C.index;local aW=aK()local mj=ei("options").themes.themeButton;local c4=c0(ai.Options)local ln=b_(c4,c4 and 300+c2*40 or 280)local lo=p(function(F)return F.options.currentTheme==aT.name end)local U=aH(false)local aY=U[1]local aZ=U[2]local b0;if lo then b0=mj.accent else local b1;if aY then local b2=mj.backgroundHovered;if b2==nil then b2=mj.background:Lerp(mj.accent,0.1)end;b1=b2 else b1=mj.background end;b0=b1 end;local b3=aL(b0,{})local b1;if lo then b1=mj.accent else local fn;if aY then local b2=mj.backgroundHovered;if b2==nil then b2=mj.dropshadow:Lerp(mj.accent,0.5)end;fn=b2 else fn=mj.dropshadow end;b1=fn end;local ls=aL(b1,{})local b4=aL(lo and mj.foregroundAccent and mj.foregroundAccent or mj.foreground,{})local bc={size=am(l7,l6),position=aL(ln and am(0,(l5+l6)*c2)or am(-l7-24,(l5+l6)*c2),{}),zIndex=c2}local be={b.createElement(bn,{radius=bo.Size70,color=ls,size=UDim2.new(1,36,1,36),position=am(-18,5-18),transparency=aL(lo and mj.glowTransparency or(aY and ko(mj.dropshadowTransparency,mj.glowTransparency,0.5)or mj.dropshadowTransparency),{})}),b.createElement(bl,{color=b3,transparency=mj.backgroundTransparency,radius=8}),b.createElement("TextLabel",{Text=aT.name,Font="GothamBold",TextSize=16,TextColor3=b4,TextXAlignment=Enum.TextXAlignment.Left,TextYAlignment=Enum.TextYAlignment.Center,TextTransparency=aL(lo and 0 or(aY and mj.foregroundTransparency/2 or mj.foregroundTransparency),{}),BackgroundTransparency=1,Position=am(l8,1),Size=UDim2.new(1,-l8,1,-1),ClipsDescendants=true}),b.createElement(mw,{color=b3,previewTheme=aT.preview})}local bf=#be;local bv=mj.outlined and b.createElement(b8,{color=b4,transparency=0.8,radius=8})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("TextButton",{[b.Event.Activated]=function()return not lo and aW(iw(aT.name))end,[b.Event.MouseEnter]=function()return aZ(true)end,[b.Event.MouseLeave]=function()return aZ(false)end,Text="",Transparency=1,Size=r(1,1)})return b.createElement(bk,bc,be)end;local f=i(mx)function mw(C)local b9=C.color;local my=C.previewTheme;return b.createElement("Frame",{AnchorPoint=Vector2.new(1,0),Size=UDim2.new(0,114,1,-4),Position=UDim2.new(1,-2,0,2),BackgroundColor3=b9,Transparency=1,BorderSizePixel=0},{b.createElement("UICorner",{CornerRadius=UDim.new(0,6)}),b.createElement("Frame",{AnchorPoint=Vector2.new(0,0.5),Size=am(25,25),Position=UDim2.new(0,12,0.5,0),BackgroundColor3=ak("#ffffff"),BorderSizePixel=0},{b.createElement("UICorner",{CornerRadius=UDim.new(1,0)}),b.createElement("UIGradient",{Color=my.foreground.color,Transparency=my.foreground.transparency,Rotation=my.foreground.rotation}),b.createElement("UIStroke",{Color=jN(my.foreground.color)>0.5 and ak("#000000")or ak("#ffffff"),Transparency=0.5,Thickness=2})}),b.createElement("Frame",{AnchorPoint=Vector2.new(0.5,0.5),Size=am(25,25),Position=UDim2.new(0.5,0,0.5,0),BackgroundColor3=ak("#ffffff"),BorderSizePixel=0},{b.createElement("UICorner",{CornerRadius=UDim.new(1,0)}),b.createElement("UIGradient",{Color=my.background.color,Transparency=my.background.transparency,Rotation=my.background.rotation}),b.createElement("UIStroke",{Color=jN(my.background.color)>0.5 and ak("#000000")or ak("#ffffff"),Transparency=0.5,Thickness=2})}),b.createElement("Frame",{AnchorPoint=Vector2.new(1,0.5),Size=am(25,25),Position=UDim2.new(1,-12,0.5,0),BackgroundColor3=ak("#ffffff"),BorderSizePixel=0},{b.createElement("UICorner",{CornerRadius=UDim.new(1,0)}),b.createElement("UIGradient",{Color=my.accent.color,Transparency=my.accent.transparency,Rotation=my.accent.rotation}),b.createElement("UIStroke",{Color=jN(my.accent.color)>0.5 and ak("#000000")or ak("#ffffff"),Transparency=0.5,Thickness=2})})})end;return{PADDING=l5,ENTRY_HEIGHT=l6,ENTRY_WIDTH=l7,ENTRY_TEXT_PADDING=l8,default=f}end,newEnv("Orca.views.Pages.Options.Themes.ThemeItem"))()end)newModule("Themes","ModuleScript","Orca.views.Pages.Options.Themes.Themes","Orca.views.Pages.Options.Themes",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local l=h.useMemo;local bk=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Canvas").default;local c1=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"components","Card").default;local ei=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"hooks","use-theme").useTheme;local ai=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local eg=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"themes").getThemes;local jH=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","array-util").arrayToMap;local al=a.import(script,script.Parent.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local mz=a.import(script,script.Parent,"ThemeItem")local mx=mz.default;local l6=mz.ENTRY_HEIGHT;local l5=mz.PADDING;local function ml()local aT=ei("options").themes;local iU=l(eg,{})local bc={index=2,page=ai.Options,theme=aT,size=am(326,416),position=UDim2.new(0,374,1,0)}local be={b.createElement("TextLabel",{Text="Themes",Font="GothamBlack",TextSize=20,TextColor3=aT.foreground,TextXAlignment="Left",TextYAlignment="Top",Position=am(24,24),BackgroundTransparency=1})}local bf=#be;local bg={size=am(326,348),position=am(0,68),padding={left=24,right=24,top=8},clipsDescendants=true}local bh={}local bi=#bh;local lB={Size=r(1,1),CanvasSize=am(0,#iU*(l6+l5)+l5),BackgroundTransparency=1,BorderSizePixel=0,ScrollBarImageTransparency=1,ScrollBarThickness=0,ClipsDescendants=false}local lC={}local lD=#lC;for av,aw in pairs(jH(iU,function(aT,c2)return{aT.name,b.createElement(mx,{theme=aT,index=c2})}end))do lC[av]=aw end;bh[bi+1]=b.createElement("ScrollingFrame",lB,lC)be[bf+1]=b.createElement(bk,bg,bh)return b.createElement(c1,bc,be)end;local f=i(ml)return{default=f}end,newEnv("Orca.views.Pages.Options.Themes.Themes"))()end)newModule("Pages","ModuleScript","Orca.views.Pages.Pages","Orca.views.Pages",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local b_=a.import(script,script.Parent.Parent.Parent,"hooks","common","use-delayed-update").useDelayedUpdate;local dU=a.import(script,script.Parent.Parent.Parent,"hooks","use-current-page").useCurrentPage;local ai=a.import(script,script.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local l0=a.import(script,script.Parent,"Apps").default;local lL=a.import(script,script.Parent,"Home").default;local mm=a.import(script,script.Parent,"Options").default;local mA=a.import(script,script.Parent,"Scripts").default;local function kF()local mB=dU()local mC=b_(mB==ai.Scripts,2000,function(ln)return ln end)local be={home=b.createFragment({home=b.createElement(lL)}),apps=b.createFragment({apps=b.createElement(l0)})}local bf=#be;local bv=mC and b.createFragment({scripts=b.createElement(mA)})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be.options=b.createFragment({options=b.createElement(mm)})return b.createFragment(be)end;local f=i(kF)return{default=f}end,newEnv("Orca.views.Pages.Pages"))()end)newModule("Scripts","ModuleScript","Orca.views.Pages.Scripts","Orca.views.Pages",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.include.RuntimeLib)local g={}g.default=a.import(script,script,"Scripts").default;return g end,newEnv("Orca.views.Pages.Scripts"))()end)newModule("Content","ModuleScript","Orca.views.Pages.Scripts.Content","Orca.views.Pages.Scripts",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local i=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).hooked;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local cd=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-scale").useScale;local ak=a.import(script,script.Parent.Parent.Parent.Parent,"utils","color3").hex;local al=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2")local am=al.px;local r=al.scale;local mD,mE;local function mF(C)local mG=C.header;local mH=C.body;local mI=C.footer;local ck=cd()local bc={padding={top=ck:map(function(bd)return bd*48 end),left=ck:map(function(bd)return bd*48 end),bottom=ck:map(function(bd)return bd*48 end),right=ck:map(function(bd)return bd*48 end)}}local be={mH~=nil and b.createElement(mD,{header=mG,scaleFactor=ck})or b.createElement(mE,{header=mG,scaleFactor=ck})}local bf=#be;local bv=mH~=nil and b.createElement("TextLabel",{Text=mH,TextColor3=ak("#FFFFFF"),Font="GothamBlack",TextSize=36,TextXAlignment="Left",TextYAlignment="Top",Size=r(1,70/416),Position=ck:map(function(bd)return am(0,110*bd)end),BackgroundTransparency=1},{b.createElement("UIScale",{Scale=ck})})if bv then if bv.elements~=nil or bv.props~=nil and bv.component~=nil then be[bf+1]=bv else for av,aw in ipairs(bv)do be[bf+av]=aw end end end;bf=#be;be[bf+1]=b.createElement("TextLabel",{Text=mI,TextColor3=ak("#FFFFFF"),Font="GothamBlack",TextSize=18,TextXAlignment="Center",TextYAlignment="Bottom",AnchorPoint=Vector2.new(0.5,1),Size=r(1,20/416),Position=r(0.5,1),BackgroundTransparency=1},{b.createElement("UIScale",{Scale=ck})})return b.createElement(bk,bc,be)end;function mD(kX)return b.createElement("TextLabel",{Text=kX.header,TextColor3=ak("#FFFFFF"),Font="GothamBlack",TextSize=64,TextXAlignment="Left",TextYAlignment="Top",Size=r(1,70/416),BackgroundTransparency=1},{b.createElement("UIScale",{Scale=kX.scaleFactor})})end;function mE(kX)return b.createElement("TextLabel",{Text=kX.header,TextColor3=ak("#FFFFFF"),Font="GothamBlack",TextSize=48,TextXAlignment="Center",TextYAlignment="Center",AnchorPoint=Vector2.new(0.5,0.5),Size=r(1,1),Position=r(0.5,0.5),BackgroundTransparency=1},{b.createElement("UIScale",{Scale=kX.scaleFactor})})end;local f=i(mF)return{default=f}end,newEnv("Orca.views.Pages.Scripts.Content"))()end)newModule("ScriptCard","ModuleScript","Orca.views.Pages.Scripts.ScriptCard","Orca.views.Pages.Scripts",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local k=h.useEffect;local b8=a.import(script,script.Parent.Parent.Parent.Parent,"components","Border").default;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local bl=a.import(script,script.Parent.Parent.Parent.Parent,"components","Fill").default;local cr=a.import(script,script.Parent.Parent.Parent.Parent,"components","ParallaxImage").default;local b_=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-delayed-update").useDelayedUpdate;local dc=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-did-mount").useIsMount;local dd=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-forced-update").useForcedUpdate;local dA=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-set-state").default;local aL=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","common","use-spring").useSpring;local c0=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-current-page").useIsPageOpen;local e9=a.import(script,script.Parent.Parent.Parent.Parent,"hooks","use-parallax-offset").useParallaxOffset;local ai=a.import(script,script.Parent.Parent.Parent.Parent,"store","models","dashboard.model").DashboardPage;local ak=a.import(script,script.Parent.Parent.Parent.Parent,"utils","color3").hex;local r=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2").scale;local mJ={dampingRatio=3,frequency=2}local function mK(C)local c2=C.index;local mL=C.backgroundImage;local mM=C.backgroundImageSize;local ls=C.dropshadow;local mN=C.dropshadowSize;local mO=C.dropshadowPosition;local mP=C.anchorPoint;local L=C.size;local M=C.position;local br=C.onActivate;local bb=C[b.Children]local mQ=dd()local mR=c0(ai.Scripts)local b0;if dc()then b0=false else b0=mR end;local c4=b0;local mS=b_(c4,c2*30)k(function()return mQ()end,{})local ct=e9()local U=dA({isHovered=false,isPressed=false})local dv=U[1]local kZ=dv.isHovered;local mT=dv.isPressed;local mU=U[2]local bc={anchor=mP,size=L}local b1;if mS then b1=M else local c6=UDim2.new(0,0,1,48*3+56)b1=M+c6 end;bc.position=aL(b1,{frequency=2.2,dampingRatio=0.75})local be={}local bf=#be;local bg={anchor=Vector2.new(0.5,0.5),size=aL(kZ and not mT and UDim2.new(1,48,1,48)or r(1,1),{frequency=2}),position=r(0.5,0.5)}local bh={b.createElement("ImageLabel",{Image=ls,AnchorPoint=Vector2.new(0.5,0.5),Size=r(mN.X,mN.Y),Position=r(mO.X,mO.Y),BackgroundTransparency=1}),b.createElement(cr,{image=mL,imageSize=mM,padding=Vector2.new(50,50),offset=ct},{b.createElement("UICorner",{CornerRadius=UDim.new(0,16)})})}local bi=#bh;local lB={clipsDescendants=true}local lC={}local lD=#lC;if bb then for av,aw in pairs(bb)do if type(av)=="number"then lC[lD+av]=aw else lC[av]=aw end end end;bh[bi+1]=b.createElement(bk,lB,lC)bh[bi+2]=b.createElement(bl,{radius=16,color=ak("#ffffff"),transparency=aL(kZ and 0 or 1,mJ)},{b.createElement("UIGradient",{Transparency=NumberSequence.new(0.75,1),Offset=aL(kZ and Vector2.new(0,0)or Vector2.new(-1,-1),mJ),Rotation=45})})bh[bi+3]=b.createElement(b8,{radius=18,size=3,color=ak("#ffffff"),transparency=aL(kZ and 0 or 1,mJ)},{b.createElement("UIGradient",{Transparency=NumberSequence.new(0.7,0.9),Offset=aL(kZ and Vector2.new(0,0)or Vector2.new(-1,-1),mJ),Rotation=45})})bh[bi+4]=b.createElement(b8,{color=ak("#ffffff"),radius=16,transparency=aL(kZ and 1 or 0.8,{})})be[bf+1]=b.createElement(bk,bg,bh)be[bf+2]=b.createElement("TextButton",{[b.Event.Activated]=function()return br()end,[b.Event.MouseEnter]=function()return mU({isHovered=true})end,[b.Event.MouseLeave]=function()return mU({isHovered=false,isPressed=false})end,[b.Event.MouseButton1Down]=function()return mU({isPressed=true})end,[b.Event.MouseButton1Up]=function()return mU({isPressed=false})end,Size=r(1,1),Text="",Transparency=1})return b.createElement(bk,bc,be)end;local f=i(mK)return{default=f}end,newEnv("Orca.views.Pages.Scripts.ScriptCard"))()end)newModule("Scripts","ModuleScript","Orca.views.Pages.Scripts.Scripts","Orca.views.Pages.Scripts",function()return setfenv(function()local a=require(script.Parent.Parent.Parent.Parent.include.RuntimeLib)local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local k_=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).pure;local bk=a.import(script,script.Parent.Parent.Parent.Parent,"components","Canvas").default;local i6=a.import(script,script.Parent.Parent.Parent.Parent,"utils","http")local r=a.import(script,script.Parent.Parent.Parent.Parent,"utils","udim2").scale;local mV=a.import(script,script.Parent,"constants")local mW=mV.BASE_PADDING;local mX=mV.BASE_WINDOW_HEIGHT;local mF=a.import(script,script.Parent,"Content").default;local mK=a.import(script,script.Parent,"ScriptCard").default;local mY=a.async(function(kf,mZ)local iH,iI=a.try(function()local iC=a.await(i6.get(kf))local kd,dw=loadstring(iC,"@"..mZ)local dz="Failed to call loadstring on Lua script from '"..kf.."': "..tostring(dw)assert(kd,dz)task.defer(kd)end,function(m_)warn("Failed to run Lua script from '"..kf.."': "..tostring(m_))return a.TRY_RETURN,{""}end)if iH then return unpack(iI)end end)local function mA()return b.createElement(bk,{position=r(0,1),anchor=Vector2.new(0,1)},{b.createElement(mK,{onActivate=function()return mY("https://solarishub.dev/script.lua","Solaris")end,index=4,backgroundImage="rbxassetid://8992292705",backgroundImageSize=Vector2.new(1023,682),dropshadow="rbxassetid://8992292536",dropshadowSize=Vector2.new(1.15,1.25),dropshadowPosition=Vector2.new(0.5,0.55),anchorPoint=Vector2.new(0,0),size=UDim2.new(1/3,-mW*2/3,(416+mW/2)/mX,-mW/2),position=r(0,0)},{b.createElement(mF,{header="Solaris",body="A collection\nof your favorite\nscripts.",footer="solarishub.dev"})}),b.createElement(mK,{onActivate=function()return mY("https://raw.githubusercontent.com/1201for/V.G-Hub/main/V.Ghub","V.G Hub")end,index=1,backgroundImage="rbxassetid://8992292381",backgroundImageSize=Vector2.new(1021,1023),dropshadow="rbxassetid://8992291993",dropshadowSize=Vector2.new(1.15,1.25),dropshadowPosition=Vector2.new(0.5,0.55),anchorPoint=Vector2.new(0,1),size=UDim2.new(1/3,-mW*2/3,(416+mW/2)/mX,-mW/2),position=r(0,1)},{b.createElement(mF,{header="V.G Hub",body="Featuring over\n100 games.",footer="github.com/1201for"})}),b.createElement(mK,{onActivate=function()return mY("https://raw.githubusercontent.com/CMD-X/CMD-X/master/Source","CMD-X")end,index=5,backgroundImage="rbxassetid://8992291779",backgroundImageSize=Vector2.new(818,1023),dropshadow="rbxassetid://8992291581",dropshadowSize=Vector2.new(1.15,1.4),dropshadowPosition=Vector2.new(0.5,0.6),anchorPoint=Vector2.new(0.5,0),size=UDim2.new(1/3,-mW*2/3,(242+mW/2)/mX,-mW/2),position=r(0.5,0)},{b.createElement(mF,{header="CMD-X",footer="github.com/CMD-X"})}),b.createElement(mK,{onActivate=function()return mY("https://raw.githubusercontent.com/EdgeIY/infiniteyield/master/source","Infinite Yield")end,index=3,backgroundImage="rbxassetid://8992291444",backgroundImageSize=Vector2.new(1023,682),dropshadow="rbxassetid://8992291268",dropshadowSize=Vector2.new(1.15,1.4),dropshadowPosition=Vector2.new(0.5,0.6),anchorPoint=Vector2.new(0.5,0),size=UDim2.new(1/3,-mW*2/3,(242+mW)/mX,-mW),position=UDim2.new(0.5,0,1-(590+mW/2)/mX,mW/2)},{b.createElement(mF,{header="Infinite Yield",footer="github.com/EdgeIY"})}),b.createElement(mK,{onActivate=function()return mY("https://pastebin.com/raw/mMbsHWiQ","Dex Explorer")end,index=1,backgroundImage="rbxassetid://8992290931",backgroundImageSize=Vector2.new(818,1023),dropshadow="rbxassetid://8992291101",dropshadowSize=Vector2.new(1.15,1.35),dropshadowPosition=Vector2.new(0.5,0.55),anchorPoint=Vector2.new(0.5,1),size=UDim2.new(1/3,-mW*2/3,(300+mW/2)/mX,-mW/2),position=r(0.5,1)},{b.createElement(mF,{header="Dex Explorer",footer="github.com/LorekeeperZinnia"})}),b.createElement(mK,{onActivate=function()return mY("https://raw.githubusercontent.com/ic3w0lf22/Unnamed-ESP/master/UnnamedESP.lua","Unnamed ESP")end,index=6,backgroundImage="rbxassetid://8992290714",backgroundImageSize=Vector2.new(1023,682),dropshadow="rbxassetid://8992290570",dropshadowSize=Vector2.new(1.15,1.35),dropshadowPosition=Vector2.new(0.5,0.55),anchorPoint=Vector2.new(1,0),size=UDim2.new(1/3,-mW*2/3,(300+mW/2)/mX,-mW/2),position=r(1,0)},{b.createElement(mF,{header="Unnamed ESP",footer="github.com/ic3w0lf22"})}),b.createElement(mK,{onActivate=function()return mY("https://projectevo.xyz/script/loader.lua","EvoV2")end,index=2,backgroundImage="rbxassetid://8992290314",backgroundImageSize=Vector2.new(682,1023),dropshadow="rbxassetid://8992290105",dropshadowSize=Vector2.new(1.15,1.22),dropshadowPosition=Vector2.new(0.5,0.53),anchorPoint=Vector2.new(1,1),size=UDim2.new(1/3,-mW*2/3,(532+mW/2)/mX,-mW/2),position=r(1,1)},{b.createElement(mF,{header="EvoV2",body="Reliable cheats for\nRoblox's top shooter\ngames, reimagined.",footer="projectevo.xyz"})})})end;local f=k_(mA)return{default=f}end,newEnv("Orca.views.Pages.Scripts.Scripts"))()end)newModule("constants","ModuleScript","Orca.views.Pages.Scripts.constants","Orca.views.Pages.Scripts",function()return setfenv(function()local mX=880;local n0=1824;local mW=48;return{BASE_WINDOW_HEIGHT=mX,BASE_WINDOW_WIDTH=n0,BASE_PADDING=mW}end,newEnv("Orca.views.Pages.Scripts.constants"))()end)newInstance("include","Folder","Orca.include","Orca")newModule("Promise","ModuleScript","Orca.include.Promise","Orca.include",function()return setfenv(function()local n1="Non-promise value passed into %s at index %s"local n2="Please pass a list of promises to %s"local n3="Please pass a handler function to %s!"local n4={__mode="k"}local function n5(n6,n7)local n8={}for ev,n9 in ipairs(n7)do n8[n9]=n9 end;return setmetatable(n8,{__index=function(ev,gR)error(string.format("%s is not in %s!",gR,n6),2)end,__newindex=function()error(string.format("Creating new members in %s is not allowed!",n6),2)end})end;local na;do na={Kind=n5("Promise.Error.Kind",{"ExecutionError","AlreadyCancelled","NotResolvedInTime","TimedOut"})}na.__index=na;function na.new(cL,nb)cL=cL or{}return setmetatable({error=tostring(cL.error)or"[This error has no error text.]",trace=cL.trace,context=cL.context,kind=cL.kind,parent=nb,createdTick=os.clock(),createdTrace=debug.traceback()},na)end;function na.is(nc)if type(nc)=="table"then local nd=getmetatable(nc)if type(nd)=="table"then return rawget(nc,"error")~=nil and type(rawget(nd,"extend"))=="function"end end;return false end;function na.isKind(nc,ne)assert(ne~=nil,"Argument #2 to Promise.Error.isKind must not be nil")return na.is(nc)and nc.kind==ne end;function na:extend(cL)cL=cL or{}cL.kind=cL.kind or self.kind;return na.new(cL,self)end;function na:getErrorChain()local nf={self}while nf[#nf].parent do table.insert(nf,nf[#nf].parent)end;return nf end;function na:__tostring()local ng={string.format("-- Promise.Error(%s) --",self.kind or"?")}for ev,nh in ipairs(self:getErrorChain())do table.insert(ng,table.concat({nh.trace or nh.error,nh.context},"\n"))end;return table.concat(ng,"\n")end end;local function ni(...)return select("#",...),{...}end;local function nj(nk,...)return nk,select("#",...),{...}end;local function nl(nm)assert(nm~=nil)return function(dw)if type(dw)=="table"then return dw end;return na.new({error=dw,kind=na.Kind.ExecutionError,trace=debug.traceback(tostring(dw),2),context="Promise created at:\n\n"..nm})end end;local function nn(nm,da,...)return nj(xpcall(da,nl(nm),...))end;local function no(nm,da,hs,np)return function(...)local nq,nr,dx=nn(nm,da,...)if nq then hs(unpack(dx,1,nr))else np(dx[1])end end end;local function ns(ek)return next(ek)==nil end;local nt={Error=na,Status=n5("Promise.Status",{"Started","Resolved","Rejected","Cancelled"}),_getTime=os.clock,_timeEvent=game:GetService("RunService").Heartbeat}nt.prototype={}nt.__index=nt.prototype;function nt._new(nm,da,nb)if nb~=nil and not nt.is(nb)then error("Argument #2 to Promise.new must be a promise or nil",2)end;local self={_source=nm,_status=nt.Status.Started,_values=nil,_valuesLength=-1,_unhandledRejection=true,_queuedResolve={},_queuedReject={},_queuedFinally={},_cancellationHook=nil,_parent=nb,_consumers=setmetatable({},n4)}if nb and nb._status==nt.Status.Started then nb._consumers[self]=true end;setmetatable(self,nt)local function hs(...)self:_resolve(...)end;local function np(...)self:_reject(...)end;local function ht(nu)if nu then if self._status==nt.Status.Cancelled then nu()else self._cancellationHook=nu end end;return self._status==nt.Status.Cancelled end;coroutine.wrap(function()local nq,ev,dx=nn(self._source,da,hs,np,ht)if not nq then np(dx[1])end end)()return self end;function nt.new(nv)return nt._new(debug.traceback(nil,2),nv)end;function nt:__tostring()return string.format("Promise(%s)",self:getStatus())end;function nt.defer(da)local nm=debug.traceback(nil,2)local dq;dq=nt._new(nm,function(hs,np,ht)local nw;nw=nt._timeEvent:Connect(function()nw:Disconnect()local nq,ev,dx=nn(nm,da,hs,np,ht)if not nq then np(dx[1])end end)end)return dq end;nt.async=nt.defer;function nt.resolve(...)local nx,ny=ni(...)return nt._new(debug.traceback(nil,2),function(hs)hs(unpack(ny,1,nx))end)end;function nt.reject(...)local nx,ny=ni(...)return nt._new(debug.traceback(nil,2),function(ev,np)np(unpack(ny,1,nx))end)end;function nt._try(nm,da,...)local nz,ny=ni(...)return nt._new(nm,function(hs)hs(da(unpack(ny,1,nz)))end)end;function nt.try(...)return nt._try(debug.traceback(nil,2),...)end;function nt._all(nm,nA,nB)if type(nA)~="table"then error(string.format(n2,"Promise.all"),3)end;for jX,dq in pairs(nA)do if not nt.is(dq)then error(string.format(n1,"Promise.all",tostring(jX)),3)end end;if#nA==0 or nB==0 then return nt.resolve({})end;return nt._new(nm,function(hs,np,ht)local nC={}local nD={}local nE=0;local nF=0;local nG=false;local function nH()for ev,dq in ipairs(nD)do dq:cancel()end end;local function nI(jX,...)if nG then return end;nE=nE+1;if nB==nil then nC[jX]=...else nC[nE]=...end;if nE>=(nB or#nA)then nG=true;hs(nC)nH()end end;ht(nH)for jX,dq in ipairs(nA)do nD[jX]=dq:andThen(function(...)nI(jX,...)end,function(...)nF=nF+1;if nB==nil or#nA-nF<nB then nH()nG=true;np(...)end end)end;if nG then nH()end end)end;function nt.all(nA)return nt._all(debug.traceback(nil,2),nA)end;function nt.fold(nJ,da,bG)assert(type(nJ)=="table","Bad argument #1 to Promise.fold: must be a table")assert(type(da)=="function","Bad argument #2 to Promise.fold: must be a function")local nK=nt.resolve(bG)return nt.each(nJ,function(nL,jX)nK=nK:andThen(function(nM)return da(nM,nL,jX)end)end):andThenReturn(nK)end;function nt.some(nA,nB)assert(type(nB)=="number","Bad argument #2 to Promise.some: must be a number")return nt._all(debug.traceback(nil,2),nA,nB)end;function nt.any(nA)return nt._all(debug.traceback(nil,2),nA,1):andThen(function(ny)return ny[1]end)end;function nt.allSettled(nA)if type(nA)~="table"then error(string.format(n2,"Promise.allSettled"),2)end;for jX,dq in pairs(nA)do if not nt.is(dq)then error(string.format(n1,"Promise.allSettled",tostring(jX)),2)end end;if#nA==0 then return nt.resolve({})end;return nt._new(debug.traceback(nil,2),function(hs,ev,ht)local nN={}local nD={}local nO=0;local function nI(jX,...)nO=nO+1;nN[jX]=...if nO>=#nA then hs(nN)end end;ht(function()for ev,dq in ipairs(nD)do dq:cancel()end end)for jX,dq in ipairs(nA)do nD[jX]=dq:finally(function(...)nI(jX,...)end)end end)end;function nt.race(nA)assert(type(nA)=="table",string.format(n2,"Promise.race"))for jX,dq in pairs(nA)do assert(nt.is(dq),string.format(n1,"Promise.race",tostring(jX)))end;return nt._new(debug.traceback(nil,2),function(hs,np,ht)local nD={}local nP=false;local function nH()for ev,dq in ipairs(nD)do dq:cancel()end end;local function nQ(da)return function(...)nH()nP=true;return da(...)end end;if ht(nQ(np))then return end;for jX,dq in ipairs(nA)do nD[jX]=dq:andThen(nQ(hs),nQ(np))end;if nP then nH()end end)end;function nt.each(nJ,nR)assert(type(nJ)=="table",string.format(n2,"Promise.each"))assert(type(nR)=="function",string.format(n3,"Promise.each"))return nt._new(debug.traceback(nil,2),function(hs,np,ht)local nS={}local nT={}local nU=false;local function nH()for ev,nV in ipairs(nT)do nV:cancel()end end;ht(function()nU=true;nH()end)local nW={}for c2,d3 in ipairs(nJ)do if nt.is(d3)then if d3:getStatus()==nt.Status.Cancelled then nH()return np(na.new({error="Promise is cancelled",kind=na.Kind.AlreadyCancelled,context=string.format("The Promise that was part of the array at index %d passed into Promise.each was already cancelled when Promise.each began.\n\nThat Promise was created at:\n\n%s",c2,d3._source)}))elseif d3:getStatus()==nt.Status.Rejected then nH()return np(select(2,d3:await()))end;local nX=d3:andThen(function(...)return...end)table.insert(nT,nX)nW[c2]=nX else nW[c2]=d3 end end;for c2,d3 in ipairs(nW)do if nt.is(d3)then local nk;nk,d3=d3:await()if not nk then nH()return np(d3)end end;if nU then return end;local nY=nt.resolve(nR(d3,c2))table.insert(nT,nY)local nk,dx=nY:await()if not nk then nH()return np(dx)end;nS[c2]=dx end;hs(nS)end)end;function nt.is(nZ)if type(nZ)~="table"then return false end;local n_=getmetatable(nZ)if n_==nt then return true elseif n_==nil then return type(nZ.andThen)=="function"elseif type(n_)=="table"and type(rawget(n_,"__index"))=="table"and type(rawget(rawget(n_,"__index"),"andThen"))=="function"then return true end;return false end;function nt.promisify(da)return function(...)return nt._try(debug.traceback(nil,2),da,...)end end;do local o0;local nw;function nt.delay(m6)assert(type(m6)=="number","Bad argument #1 to Promise.delay, must be a number.")if not(m6>=1/60)or m6==math.huge then m6=1/60 end;return nt._new(debug.traceback(nil,2),function(hs,ev,ht)local o1=nt._getTime()local o2=o1+m6;local o3={resolve=hs,startTime=o1,endTime=o2}if nw==nil then o0=o3;nw=nt._timeEvent:Connect(function()local o4=nt._getTime()while o0~=nil and o0.endTime<o4 do local hy=o0;o0=hy.next;if o0==nil then nw:Disconnect()nw=nil else o0.previous=nil end;hy.resolve(nt._getTime()-hy.startTime)end end)else if o0.endTime<o2 then local hy=o0;local next=hy.next;while next~=nil and next.endTime<o2 do hy=next;next=hy.next end;hy.next=o3;o3.previous=hy;if next~=nil then o3.next=next;next.previous=o3 end else o3.next=o0;o0.previous=o3;o0=o3 end end;ht(function()local next=o3.next;if o0==o3 then if next==nil then nw:Disconnect()nw=nil else next.previous=nil end;o0=next else local o5=o3.previous;o5.next=next;if next~=nil then next.previous=o5 end end end)end)end end;function nt.prototype:timeout(m6,o6)local nm=debug.traceback(nil,2)return nt.race({nt.delay(m6):andThen(function()return nt.reject(o6==nil and na.new({kind=na.Kind.TimedOut,error="Timed out",context=string.format("Timeout of %d seconds exceeded.\n:timeout() called at:\n\n%s",m6,nm)})or o6)end),self})end;function nt.prototype:getStatus()return self._status end;function nt.prototype:_andThen(nm,o7,o8)self._unhandledRejection=false;return nt._new(nm,function(hs,np)local o9=hs;if o7 then o9=no(nm,o7,hs,np)end;local oa=np;if o8 then oa=no(nm,o8,hs,np)end;if self._status==nt.Status.Started then table.insert(self._queuedResolve,o9)table.insert(self._queuedReject,oa)elseif self._status==nt.Status.Resolved then o9(unpack(self._values,1,self._valuesLength))elseif self._status==nt.Status.Rejected then oa(unpack(self._values,1,self._valuesLength))elseif self._status==nt.Status.Cancelled then np(na.new({error="Promise is cancelled",kind=na.Kind.AlreadyCancelled,context="Promise created at\n\n"..nm}))end end,self)end;function nt.prototype:andThen(o7,o8)assert(o7==nil or type(o7)=="function",string.format(n3,"Promise:andThen"))assert(o8==nil or type(o8)=="function",string.format(n3,"Promise:andThen"))return self:_andThen(debug.traceback(nil,2),o7,o8)end;function nt.prototype:catch(oa)assert(oa==nil or type(oa)=="function",string.format(n3,"Promise:catch"))return self:_andThen(debug.traceback(nil,2),nil,oa)end;function nt.prototype:tap(ob)assert(type(ob)=="function",string.format(n3,"Promise:tap"))return self:_andThen(debug.traceback(nil,2),function(...)local oc=ob(...)if nt.is(oc)then local nx,ny=ni(...)return oc:andThen(function()return unpack(ny,1,nx)end)end;return...end)end;function nt.prototype:andThenCall(da,...)assert(type(da)=="function",string.format(n3,"Promise:andThenCall"))local nx,ny=ni(...)return self:_andThen(debug.traceback(nil,2),function()return da(unpack(ny,1,nx))end)end;function nt.prototype:andThenReturn(...)local nx,ny=ni(...)return self:_andThen(debug.traceback(nil,2),function()return unpack(ny,1,nx)end)end;function nt.prototype:cancel()if self._status~=nt.Status.Started then return end;self._status=nt.Status.Cancelled;if self._cancellationHook then self._cancellationHook()end;if self._parent then self._parent:_consumerCancelled(self)end;for fi in pairs(self._consumers)do fi:cancel()end;self:_finalize()end;function nt.prototype:_consumerCancelled(od)if self._status~=nt.Status.Started then return end;self._consumers[od]=nil;if next(self._consumers)==nil then self:cancel()end end;function nt.prototype:_finally(nm,oe,of)if not of then self._unhandledRejection=false end;return nt._new(nm,function(hs,np)local og=hs;if oe then og=no(nm,oe,hs,np)end;if of then local da=og;og=function(...)if self._status==nt.Status.Rejected then return hs(self)end;return da(...)end end;if self._status==nt.Status.Started then table.insert(self._queuedFinally,og)else og(self._status)end end,self)end;function nt.prototype:finally(oe)assert(oe==nil or type(oe)=="function",string.format(n3,"Promise:finally"))return self:_finally(debug.traceback(nil,2),oe)end;function nt.prototype:finallyCall(da,...)assert(type(da)=="function",string.format(n3,"Promise:finallyCall"))local nx,ny=ni(...)return self:_finally(debug.traceback(nil,2),function()return da(unpack(ny,1,nx))end)end;function nt.prototype:finallyReturn(...)local nx,ny=ni(...)return self:_finally(debug.traceback(nil,2),function()return unpack(ny,1,nx)end)end;function nt.prototype:done(oe)assert(oe==nil or type(oe)=="function",string.format(n3,"Promise:done"))return self:_finally(debug.traceback(nil,2),oe,true)end;function nt.prototype:doneCall(da,...)assert(type(da)=="function",string.format(n3,"Promise:doneCall"))local nx,ny=ni(...)return self:_finally(debug.traceback(nil,2),function()return da(unpack(ny,1,nx))end,true)end;function nt.prototype:doneReturn(...)local nx,ny=ni(...)return self:_finally(debug.traceback(nil,2),function()return unpack(ny,1,nx)end,true)end;function nt.prototype:awaitStatus()self._unhandledRejection=false;if self._status==nt.Status.Started then local oh=Instance.new("BindableEvent")self:finally(function()oh:Fire()end)oh.Event:Wait()oh:Destroy()end;if self._status==nt.Status.Resolved then return self._status,unpack(self._values,1,self._valuesLength)elseif self._status==nt.Status.Rejected then return self._status,unpack(self._values,1,self._valuesLength)end;return self._status end;local function oi(dZ,...)return dZ==nt.Status.Resolved,...end;function nt.prototype:await()return oi(self:awaitStatus())end;local function oj(dZ,...)if dZ~=nt.Status.Resolved then error(...==nil and"Expected Promise rejected with no value."or...,3)end;return...end;function nt.prototype:expect()return oj(self:awaitStatus())end;nt.prototype.awaitValue=nt.prototype.expect;function nt.prototype:_unwrap()if self._status==nt.Status.Started then error("Promise has not resolved or rejected.",2)end;local nk=self._status==nt.Status.Resolved;return nk,unpack(self._values,1,self._valuesLength)end;function nt.prototype:_resolve(...)if self._status~=nt.Status.Started then if nt.is(...)then(...):_consumerCancelled(self)end;return end;if nt.is(...)then if select("#",...)>1 then local ok=string.format("When returning a Promise from andThen, extra arguments are ".."discarded! See:\n\n%s",self._source)warn(ok)end;local ol=...local dq=ol:andThen(function(...)self:_resolve(...)end,function(...)local om=ol._values[1]if ol._error then om=na.new({error=ol._error,kind=na.Kind.ExecutionError,context="[No stack trace available as this Promise originated from an older version of the Promise library (< v2)]"})end;if na.isKind(om,na.Kind.ExecutionError)then return self:_reject(om:extend({error="This Promise was chained to a Promise that errored.",trace="",context=string.format("The Promise at:\n\n%s\n...Rejected because it was chained to the following Promise, which encountered an error:\n",self._source)}))end;self:_reject(...)end)if dq._status==nt.Status.Cancelled then self:cancel()elseif dq._status==nt.Status.Started then self._parent=dq;dq._consumers[self]=true end;return end;self._status=nt.Status.Resolved;self._valuesLength,self._values=ni(...)for ev,da in ipairs(self._queuedResolve)do coroutine.wrap(da)(...)end;self:_finalize()end;function nt.prototype:_reject(...)if self._status~=nt.Status.Started then return end;self._status=nt.Status.Rejected;self._valuesLength,self._values=ni(...)if not ns(self._queuedReject)then for ev,da in ipairs(self._queuedReject)do coroutine.wrap(da)(...)end else local dw=tostring(...)coroutine.wrap(function()nt._timeEvent:Wait()if not self._unhandledRejection then return end;local ok=string.format("Unhandled Promise rejection:\n\n%s\n\n%s",dw,self._source)if nt.TEST then return end;warn(ok)end)()end;self:_finalize()end;function nt.prototype:_finalize()for ev,da in ipairs(self._queuedFinally)do coroutine.wrap(da)(self._status)end;self._queuedFinally=nil;self._queuedReject=nil;self._queuedResolve=nil;if not nt.TEST then self._parent=nil;self._consumers=nil end end;function nt.prototype:now(o6)local nm=debug.traceback(nil,2)if self:getStatus()==nt.Status.Resolved then return self:_andThen(nm,function(...)return...end)else return nt.reject(o6==nil and na.new({kind=na.Kind.NotResolvedInTime,error="This Promise was not resolved in time for :now()",context=":now() was called at:\n\n"..nm})or o6)end end;function nt.retry(da,on,...)assert(type(da)=="function","Parameter #1 to Promise.retry must be a function")assert(type(on)=="number","Parameter #2 to Promise.retry must be a number")local kr,nx={...},select("#",...)return nt.resolve(da(...)):catch(function(...)if on>0 then return nt.retry(da,on-1,unpack(kr,1,nx))else return nt.reject(...)end end)end;function nt.fromEvent(oo,nR)nR=nR or function()return true end;return nt._new(debug.traceback(nil,2),function(hs,np,ht)local nw;local op=false;local function oq()nw:Disconnect()nw=nil end;nw=oo:Connect(function(...)local ot=nR(...)if ot==true then hs(...)if nw then oq()else op=true end elseif type(ot)~="boolean"then error("Promise.fromEvent predicate should always return a boolean")end end)if op and nw then return oq()end;ht(function()oq()end)end)end;return nt end,newEnv("Orca.include.Promise"))()end)newModule("RuntimeLib","ModuleScript","Orca.include.RuntimeLib","Orca.include",function()return setfenv(function()local nt=require(script.Parent.Promise)local ez=game:GetService("RunService")local ou=game:GetService("ReplicatedFirst")local a={}a.Promise=nt;local function ov(nZ)return ez:IsStudio()and nZ:FindFirstAncestorWhichIsA("Plugin")~=nil end;function a.getModule(nZ,ow,ox)if ox==nil then ox=ow;ow="@rbxts"end;if ez:IsRunning()and nZ:IsDescendantOf(ou)then warn("roblox-ts packages should not be used from ReplicatedFirst!")end;if ez:IsRunning()and ez:IsClient()and not ov(nZ)and not game:IsLoaded()then game.Loaded:Wait()end;local oy=script.Parent:FindFirstChild("node_modules")if not oy then error("Could not find any modules!",2)end;repeat local oz=nZ:FindFirstChild("node_modules")if oz and oz~=oy then oz=oz:FindFirstChild("@rbxts")end;if oz then local oA=oz:FindFirstChild(ox)if oA then return oA end end;nZ=nZ.Parent until nZ==nil or nZ==oy;local oB=oy:FindFirstChild(ow or"@rbxts")return(oB or oy):FindFirstChild(ox)or error("Could not find module: "..ox,2)end;local oC={}local oD={}function a.import(oE,oA,...)for jX=1,select("#",...)do oA=oA:WaitForChild(select(jX,...))end;if oA.ClassName~="ModuleScript"then error("Failed to import! Expected ModuleScript, got "..oA.ClassName,2)end;oC[oE]=oA;local oF=oA;local oG=0;while oF do oG=oG+1;oF=oC[oF]if oF==oA then local oH=oF.Name;for ev=1,oG do oF=oC[oF]oH=oH.."  ⇒ "..oF.Name end;error("Failed to import! Detected a circular dependency chain: "..oH,2)end end;if not oD[oA]then if _G[oA]then error("Invalid module access! Do you have two TS runtimes trying to import this? "..oA:GetFullName(),2)end;_G[oA]=a;oD[oA]=true end;local hA=require(oA)if oC[oE]==oA then oC[oE]=nil end;return hA end;function a.instanceof(hP,oI)if type(oI)=="table"and type(oI.instanceof)=="function"then return oI.instanceof(hP)end;if type(hP)=="table"then hP=getmetatable(hP)while hP~=nil do if hP==oI then return true end;local oJ=getmetatable(hP)if oJ then hP=oJ.__index else hP=nil end end end;return false end;function a.async(da)return function(...)local kj=select("#",...)local kr={...}return nt.new(function(hs,np)coroutine.wrap(function()local nq,dx=pcall(da,unpack(kr,1,kj))if nq then hs(dx)else np(dx)end end)()end)end end;function a.await(dq)if not nt.is(dq)then return dq end;local dZ,d3=dq:awaitStatus()if dZ==nt.Status.Resolved then return d3 elseif dZ==nt.Status.Rejected then error(d3,2)else error("The awaited Promise was cancelled",2)end end;function a.bit_lrsh(hx,dG)local oK=math.abs(hx)local dx=bit32.rshift(oK,dG)if hx==oK then return dx else return-dx-1 end end;a.TRY_RETURN=1;a.TRY_BREAK=2;a.TRY_CONTINUE=3;function a.try(oL,oM,oN)local dw,nm;local nk,oO,oP=xpcall(oL,function(oQ)dw=oQ;nm=debug.traceback()end)if not nk and oM then local oR,oS=oM(dw,nm)if oR then oO,oP=oR,oS end end;if oN then local oR,oS=oN()if oR then oO,oP=oR,oS end end;return oO,oP end;function a.generator(da)local oT=coroutine.create(da)return{next=function(...)if coroutine.status(oT)=="dead"then return{done=true}else local nk,d3=coroutine.resume(oT,...)if nk==false then error(d3,2)end;return{value=d3,done=coroutine.status(oT)=="dead"}end end}end;return a end,newEnv("Orca.include.RuntimeLib"))()end)newInstance("node_modules","Folder","Orca.include.node_modules","Orca.include")newInstance("compiler-types","Folder","Orca.include.node_modules.compiler-types","Orca.include.node_modules")newInstance("types","Folder","Orca.include.node_modules.compiler-types.types","Orca.include.node_modules.compiler-types")newInstance("exploit-types","Folder","Orca.include.node_modules.exploit-types","Orca.include.node_modules")newInstance("types","Folder","Orca.include.node_modules.exploit-types.types","Orca.include.node_modules.exploit-types")newInstance("flipper","Folder","Orca.include.node_modules.flipper","Orca.include.node_modules")newModule("src","ModuleScript","Orca.include.node_modules.flipper.src","Orca.include.node_modules.flipper",function()return setfenv(function()local oU={SingleMotor=require(script.SingleMotor),GroupMotor=require(script.GroupMotor),Instant=require(script.Instant),Linear=require(script.Linear),Spring=require(script.Spring),isMotor=require(script.isMotor)}return oU end,newEnv("Orca.include.node_modules.flipper.src"))()end)newModule("BaseMotor","ModuleScript","Orca.include.node_modules.flipper.src.BaseMotor","Orca.include.node_modules.flipper.src",function()return setfenv(function()local ez=game:GetService("RunService")local oV=require(script.Parent.Signal)local oW=function()end;local oX={}oX.__index=oX;function oX.new()return setmetatable({_onStep=oV.new(),_onStart=oV.new(),_onComplete=oV.new()},oX)end;function oX:onStep(oY)return self._onStep:connect(oY)end;function oX:onStart(oY)return self._onStart:connect(oY)end;function oX:onComplete(oY)return self._onComplete:connect(oY)end;function oX:start()if not self._connection then self._connection=ez.RenderStepped:Connect(function(eO)self:step(eO)end)end end;function oX:stop()if self._connection then self._connection:Disconnect()self._connection=nil end end;oX.destroy=oX.stop;oX.step=oW;oX.getValue=oW;oX.setGoal=oW;function oX:__tostring()return"Motor"end;return oX end,newEnv("Orca.include.node_modules.flipper.src.BaseMotor"))()end)newModule("GroupMotor","ModuleScript","Orca.include.node_modules.flipper.src.GroupMotor","Orca.include.node_modules.flipper.src",function()return setfenv(function()local oX=require(script.Parent.BaseMotor)local cO=require(script.Parent.SingleMotor)local cy=require(script.Parent.isMotor)local cN=setmetatable({},oX)cN.__index=cN;local function oZ(d3)if cy(d3)then return d3 end;local o_=typeof(d3)if o_=="number"then return cO.new(d3,false)elseif o_=="table"then return cN.new(d3,false)end;error(("Unable to convert %q to motor; type %s is unsupported"):format(d3,o_),2)end;function cN.new(p0,p1)assert(p0,"Missing argument #1: initialValues")assert(typeof(p0)=="table","initialValues must be a table!")assert(not p0.step,"initialValues contains disallowed property \"step\". Did you mean to put a table of values here?")local self=setmetatable(oX.new(),cN)if p1~=nil then self._useImplicitConnections=p1 else self._useImplicitConnections=true end;self._complete=true;self._motors={}for ej,d3 in pairs(p0)do self._motors[ej]=oZ(d3)end;return self end;function cN:step(eO)if self._complete then return true end;local p2=true;for ev,cB in pairs(self._motors)do local p3=cB:step(eO)if not p3 then p2=false end end;self._onStep:fire(self:getValue())if p2 then if self._useImplicitConnections then self:stop()end;self._complete=true;self._onComplete:fire()end;return p2 end;function cN:setGoal(p4)assert(not p4.step,"goals contains disallowed property \"step\". Did you mean to put a table of goals here?")self._complete=false;self._onStart:fire()for ej,cF in pairs(p4)do local cB=assert(self._motors[ej],("Unknown motor for key %s"):format(ej))cB:setGoal(cF)end;if self._useImplicitConnections then self:start()end end;function cN:getValue()local ny={}for ej,cB in pairs(self._motors)do ny[ej]=cB:getValue()end;return ny end;function cN:__tostring()return"Motor(Group)"end;return cN end,newEnv("Orca.include.node_modules.flipper.src.GroupMotor"))()end)newModule("Instant","ModuleScript","Orca.include.node_modules.flipper.src.Instant","Orca.include.node_modules.flipper.src",function()return setfenv(function()local cG={}cG.__index=cG;function cG.new(cI)return setmetatable({_targetValue=cI},cG)end;function cG:step()return{complete=true,value=self._targetValue}end;return cG end,newEnv("Orca.include.node_modules.flipper.src.Instant"))()end)newModule("Linear","ModuleScript","Orca.include.node_modules.flipper.src.Linear","Orca.include.node_modules.flipper.src",function()return setfenv(function()local cJ={}cJ.__index=cJ;function cJ.new(cI,cL)assert(cI,"Missing argument #1: targetValue")cL=cL or{}return setmetatable({_targetValue=cI,_velocity=cL.velocity or 1},cJ)end;function cJ:step(F,ga)local M=F.value;local p5=self._velocity;local cF=self._targetValue;local p6=ga*p5;local p3=p6>=math.abs(cF-M)M=M+p6*(cF>M and 1 or-1)if p3 then M=self._targetValue;p5=0 end;return{complete=p3,value=M,velocity=p5}end;return cJ end,newEnv("Orca.include.node_modules.flipper.src.Linear"))()end)newModule("Signal","ModuleScript","Orca.include.node_modules.flipper.src.Signal","Orca.include.node_modules.flipper.src",function()return setfenv(function()local p7={}p7.__index=p7;function p7.new(p8,oY)return setmetatable({signal=p8,connected=true,_handler=oY},p7)end;function p7:disconnect()if self.connected then self.connected=false;for c2,nw in pairs(self.signal._connections)do if nw==self then table.remove(self.signal._connections,c2)return end end end end;local oV={}oV.__index=oV;function oV.new()return setmetatable({_connections={},_threads={}},oV)end;function oV:fire(...)for ev,nw in pairs(self._connections)do nw._handler(...)end;for ev,p9 in pairs(self._threads)do coroutine.resume(p9,...)end;self._threads={}end;function oV:connect(oY)local nw=p7.new(self,oY)table.insert(self._connections,nw)return nw end;function oV:wait()table.insert(self._threads,coroutine.running())return coroutine.yield()end;return oV end,newEnv("Orca.include.node_modules.flipper.src.Signal"))()end)newModule("SingleMotor","ModuleScript","Orca.include.node_modules.flipper.src.SingleMotor","Orca.include.node_modules.flipper.src",function()return setfenv(function()local oX=require(script.Parent.BaseMotor)local cO=setmetatable({},oX)cO.__index=cO;function cO.new(bG,p1)assert(bG,"Missing argument #1: initialValue")assert(typeof(bG)=="number","initialValue must be a number!")local self=setmetatable(oX.new(),cO)if p1~=nil then self._useImplicitConnections=p1 else self._useImplicitConnections=true end;self._goal=nil;self._state={complete=true,value=bG}return self end;function cO:step(eO)if self._state.complete then return true end;local ex=self._goal:step(self._state,eO)self._state=ex;self._onStep:fire(ex.value)if ex.complete then if self._useImplicitConnections then self:stop()end;self._onComplete:fire()end;return ex.complete end;function cO:getValue()return self._state.value end;function cO:setGoal(cF)self._state.complete=false;self._goal=cF;self._onStart:fire()if self._useImplicitConnections then self:start()end end;function cO:__tostring()return"Motor(Single)"end;return cO end,newEnv("Orca.include.node_modules.flipper.src.SingleMotor"))()end)newModule("Spring","ModuleScript","Orca.include.node_modules.flipper.src.Spring","Orca.include.node_modules.flipper.src",function()return setfenv(function()local pa=0.001;local pb=0.001;local pc=0.0001;local bw={}bw.__index=bw;function bw.new(cI,cL)assert(cI,"Missing argument #1: targetValue")cL=cL or{}return setmetatable({_targetValue=cI,_frequency=cL.frequency or 4,_dampingRatio=cL.dampingRatio or 1},bw)end;function bw:step(F,ga)local pd=self._dampingRatio;local gb=self._frequency*2*math.pi;local dF=self._targetValue;local gc=F.value;local gd=F.velocity or 0;local ct=gc-dF;local ge=math.exp(-pd*gb*ga)local gf,gg;if pd==1 then gf=(ct*(1+gb*ga)+gd*ga)*ge+dF;gg=(gd*(1-gb*ga)-ct*gb*gb*ga)*ge elseif pd<1 then local pe=math.sqrt(1-pd*pd)local jX=math.cos(gb*pe*ga)local pf=math.sin(gb*pe*ga)local eP;if pe>pc then eP=pf/pe else local hx=ga*gb;eP=hx+(hx*hx*pe*pe*pe*pe/20-pe*pe)*hx*hx*hx/6 end;local ed;if gb*pe>pc then ed=pf/(gb*pe)else local dG=gb*pe;ed=ga+(ga*ga*dG*dG*dG*dG/20-dG*dG)*ga*ga*ga/6 end;gf=(ct*(jX+pd*eP)+gd*ed)*ge+dF;gg=(gd*(jX-eP*pd)-ct*eP*gb)*ge else local pe=math.sqrt(pd*pd-1)local pg=-gb*(pd-pe)local ph=-gb*(pd+pe)local pi=(gd-ct*pg)/(2*gb*pe)local pj=ct-pi;local pk=pj*math.exp(pg*ga)local pl=pi*math.exp(ph*ga)gf=pk+pl+dF;gg=pk*pg+pl*ph end;local p3=math.abs(gg)<pa and math.abs(gf-dF)<pb;return{complete=p3,value=p3 and dF or gf,velocity=gg}end;return bw end,newEnv("Orca.include.node_modules.flipper.src.Spring"))()end)newModule("isMotor","ModuleScript","Orca.include.node_modules.flipper.src.isMotor","Orca.include.node_modules.flipper.src",function()return setfenv(function()local function cy(d3)local pm=tostring(d3):match("^Motor%((.+)%)$")if pm then return true,pm else return false end end;return cy end,newEnv("Orca.include.node_modules.flipper.src.isMotor"))()end)newInstance("typings","Folder","Orca.include.node_modules.flipper.typings","Orca.include.node_modules.flipper")newModule("make","ModuleScript","Orca.include.node_modules.make","Orca.include.node_modules",function()return setfenv(function()local function ap(pn,po)local U=po;local bb=U.Children;local nb=U.Parent;local pp=Instance.new(pn)for pq,d3 in pairs(po)do if pq~="Children"and pq~="Parent"then local dv=pp;local pr=dv[pq]if typeof(pr)=="RBXScriptSignal"then pr:Connect(d3)else pp[pq]=d3 end end end;if bb then for ev,fi in ipairs(bb)do fi.Parent=pp end end;pp.Parent=nb;return pp end;return ap end,newEnv("Orca.include.node_modules.make"))()end)newInstance("node_modules","Folder","Orca.include.node_modules.make.node_modules","Orca.include.node_modules.make")newInstance("@rbxts","Folder","Orca.include.node_modules.make.node_modules.@rbxts","Orca.include.node_modules.make.node_modules")newInstance("compiler-types","Folder","Orca.include.node_modules.make.node_modules.@rbxts.compiler-types","Orca.include.node_modules.make.node_modules.@rbxts")newInstance("types","Folder","Orca.include.node_modules.make.node_modules.@rbxts.compiler-types.types","Orca.include.node_modules.make.node_modules.@rbxts.compiler-types")newModule("object-utils","ModuleScript","Orca.include.node_modules.object-utils","Orca.include.node_modules",function()return setfenv(function()local i4=game:GetService("HttpService")local ps={}function ps.keys(nZ)local dx=table.create(#nZ)for ej in pairs(nZ)do dx[#dx+1]=ej end;return dx end;function ps.values(nZ)local dx=table.create(#nZ)for ev,d3 in pairs(nZ)do dx[#dx+1]=d3 end;return dx end;function ps.entries(nZ)local dx=table.create(#nZ)for ej,d3 in pairs(nZ)do dx[#dx+1]={ej,d3}end;return dx end;function ps.assign(pt,...)for jX=1,select("#",...)do local pu=select(jX,...)if type(pu)=="table"then for ej,d3 in pairs(pu)do pt[ej]=d3 end end end;return pt end;function ps.copy(nZ)local dx=table.create(#nZ)for gR,bM in pairs(nZ)do dx[gR]=bM end;return dx end;local function pv(nZ,pw)local dx=table.create(#nZ)pw[nZ]=dx;for gR,bM in pairs(nZ)do if type(gR)=="table"then gR=pw[gR]or pv(gR,pw)end;if type(bM)=="table"then bM=pw[bM]or pv(bM,pw)end;dx[gR]=bM end;return dx end;function ps.deepCopy(nZ)return pv(nZ,{})end;function ps.deepEquals(hx,dG)for gR in pairs(hx)do local px=hx[gR]local py=dG[gR]if type(px)=="table"and type(py)=="table"then local dx=ps.deepEquals(px,py)if not dx then return false end elseif px~=py then return false end end;for gR in pairs(dG)do if hx[gR]==nil then return false end end;return true end;function ps.toString(hA)return i4:JSONEncode(hA)end;function ps.isEmpty(nZ)return next(nZ)==nil end;function ps.fromEntries(pz)local pA=#pz;local dx=table.create(pA)if pz then for jX=1,pA do local pB=pz[jX]dx[pB[1]]=pB[2]end end;return dx end;return ps end,newEnv("Orca.include.node_modules.object-utils"))()end)newInstance("roact","Folder","Orca.include.node_modules.roact","Orca.include.node_modules")newModule("src","ModuleScript","Orca.include.node_modules.roact.src","Orca.include.node_modules.roact",function()return setfenv(function()local pC=require(script.GlobalConfig)local pD=require(script.createReconciler)local pE=require(script.createReconcilerCompat)local pF=require(script.RobloxRenderer)local pG=require(script.strict)local pH=require(script.Binding)local pI=pD(pF)local pJ=pE(pI)local b=pG{Component=require(script.Component),createElement=require(script.createElement),createFragment=require(script.createFragment),oneChild=require(script.oneChild),PureComponent=require(script.PureComponent),None=require(script.None),Portal=require(script.Portal),createRef=require(script.createRef),forwardRef=require(script.forwardRef),createBinding=pH.create,joinBindings=pH.join,createContext=require(script.createContext),Change=require(script.PropMarkers.Change),Children=require(script.PropMarkers.Children),Event=require(script.PropMarkers.Event),Ref=require(script.PropMarkers.Ref),mount=pI.mountVirtualTree,unmount=pI.unmountVirtualTree,update=pI.updateVirtualTree,reify=pJ.reify,teardown=pJ.teardown,reconcile=pJ.reconcile,setGlobalConfig=pC.set,UNSTABLE={}}return b end,newEnv("Orca.include.node_modules.roact.src"))()end)newModule("Binding","ModuleScript","Orca.include.node_modules.roact.src.Binding","Orca.include.node_modules.roact.src",function()return setfenv(function()local pK=require(script.Parent.createSignal)local pL=require(script.Parent.Symbol)local pM=require(script.Parent.Type)local pN=require(script.Parent.GlobalConfig).get()local pO=pL.named("BindingImpl")local pP={}local pQ={}function pQ:getValue()return pP.getValue(self)end;function pQ:map(nR)return pP.map(self,nR)end;local pR={__index=pQ,__tostring=function(self)return string.format("RoactBinding(%s)",tostring(self:getValue()))end}function pP.update(cC,pS)return cC[pO].update(pS)end;function pP.subscribe(cC,da)return cC[pO].subscribe(da)end;function pP.getValue(cC)return cC[pO].getValue()end;function pP.create(bG)local pT={value=bG,changeSignal=pK()}function pT.subscribe(da)return pT.changeSignal:subscribe(da)end;function pT.update(pS)pT.value=pS;pT.changeSignal:fire(pS)end;function pT.getValue()return pT.value end;return setmetatable({[pM]=pM.Binding,[pO]=pT},pR),pT.update end;function pP.map(pU,nR)if pN.typeChecks then assert(pM.of(pU)==pM.Binding,"Expected arg #1 to be a binding")assert(typeof(nR)=="function","Expected arg #1 to be a function")end;local pT={}function pT.subscribe(da)return pP.subscribe(pU,function(pS)da(nR(pS))end)end;function pT.update(pS)error("Bindings created by Binding:map(fn) cannot be updated directly",2)end;function pT.getValue()return nR(pU:getValue())end;return setmetatable({[pM]=pM.Binding,[pO]=pT},pR)end;function pP.join(pV)if pN.typeChecks then assert(typeof(pV)=="table","Expected arg #1 to be of type table")for ej,d3 in pairs(pV)do if pM.of(d3)~=pM.Binding then local ok=("Expected arg #1 to contain only bindings, but key %q had a non-binding value"):format(tostring(ej))error(ok,2)end end end;local pT={}local function m9()local d3={}for ej,pW in pairs(pV)do d3[ej]=pW:getValue()end;return d3 end;function pT.subscribe(da)local pX={}for ej,pW in pairs(pV)do pX[ej]=pP.subscribe(pW,function(pS)da(m9())end)end;return function()if pX==nil then return end;for ev,oq in pairs(pX)do oq()end;pX=nil end end;function pT.update(pS)error("Bindings created by joinBindings(...) cannot be updated directly",2)end;function pT.getValue()return m9()end;return setmetatable({[pM]=pM.Binding,[pO]=pT},pR)end;return pP end,newEnv("Orca.include.node_modules.roact.src.Binding"))()end)newModule("Component","ModuleScript","Orca.include.node_modules.roact.src.Component","Orca.include.node_modules.roact.src",function()return setfenv(function()local pY=require(script.Parent.assign)local pZ=require(script.Parent.ComponentLifecyclePhase)local pM=require(script.Parent.Type)local pL=require(script.Parent.Symbol)local p_=require(script.Parent.invalidSetStateMessages)local q0=require(script.Parent.internalAssert)local pN=require(script.Parent.GlobalConfig).get()local q1=100;local q2=pL.named("InternalData")local q3=[[
The component %q is missing the `render` method.
`render` must be defined when creating a Roact component!]]local q4=[[
The component %q has reached the setState update recursion limit.
When using `setState` in `didUpdate`, make sure that it won't repeat infinitely!]]local q5={}function q5:__tostring()return self.__componentName end;local q6={}setmetatable(q6,q5)q6[pM]=pM.StatefulComponentClass;q6.__index=q6;q6.__componentName="Component"function q6:extend(hp)if pN.typeChecks then assert(pM.of(self)==pM.StatefulComponentClass,"Invalid `self` argument to `extend`.")assert(typeof(hp)=="string","Component class name must be a string")end;local oI={}for ej,d3 in pairs(self)do if ej~="extend"then oI[ej]=d3 end end;oI[pM]=pM.StatefulComponentClass;oI.__index=oI;oI.__componentName=hp;setmetatable(oI,q5)return oI end;function q6:__getDerivedState(q7,q8)if pN.internalTypeChecks then q0(pM.of(self)==pM.StatefulComponentInstance,"Invalid use of `__getDerivedState`")end;local q9=self[q2]local qa=q9.componentClass;if qa.getDerivedStateFromProps~=nil then local qb=qa.getDerivedStateFromProps(q7,q8)if qb~=nil then if pN.typeChecks then assert(typeof(qb)=="table","getDerivedStateFromProps must return a table!")end;return qb end end;return nil end;function q6:setState(qc)if pN.typeChecks then assert(pM.of(self)==pM.StatefulComponentInstance,"Invalid `self` argument to `extend`.")end;local q9=self[q2]local qd=q9.lifecyclePhase;if qd==pZ.ShouldUpdate or qd==pZ.WillUpdate or qd==pZ.Render or qd==pZ.WillUnmount then local qe=p_[q9.lifecyclePhase]local ok=qe:format(tostring(q9.componentClass))error(ok,2)end;local qf=q9.pendingState;local qg;if typeof(qc)=="function"then qg=qc(qf or self.state,self.props)if qg==nil then return end elseif typeof(qc)=="table"then qg=qc else error("Invalid argument to setState, expected function or table",2)end;local ex;if qf~=nil then ex=pY(qf,qg)else ex=pY({},self.state,qg)end;if qd==pZ.Init then local qb=self:__getDerivedState(self.props,ex)self.state=pY(ex,qb)elseif qd==pZ.DidMount or qd==pZ.DidUpdate or qd==pZ.ReconcileChildren then local qb=self:__getDerivedState(self.props,ex)q9.pendingState=pY(ex,qb)elseif qd==pZ.Idle then local qh=q9.virtualNode;local qi=q9.reconciler;if pN.tempFixUpdateChildrenReEntrancy then qi.suspendParentEvents(qh)end;self:__update(nil,ex)if pN.tempFixUpdateChildrenReEntrancy then qi.resumeParentEvents(qh)end else local qe=p_.default;local ok=qe:format(tostring(q9.componentClass))error(ok,2)end end;function q6:getElementTraceback()return self[q2].virtualNode.currentElement.source end;function q6:render()local q9=self[q2]local ok=q3:format(tostring(q9.componentClass))error(ok,0)end;function q6:__getContext(ej)if pN.internalTypeChecks then q0(pM.of(self)==pM.StatefulComponentInstance,"Invalid use of `__getContext`")q0(ej~=nil,"Context key cannot be nil")end;local qh=self[q2].virtualNode;local qj=qh.context;return qj[ej]end;function q6:__addContext(ej,d3)if pN.internalTypeChecks then q0(pM.of(self)==pM.StatefulComponentInstance,"Invalid use of `__addContext`")end;local qh=self[q2].virtualNode;if qh.originalContext==nil then qh.originalContext=qh.context end;local qk=qh.context;qh.context=pY({},qk,{[ej]=d3})end;function q6:__validateProps(kX)if not pN.propValidation then return end;local ql=self[q2].componentClass.validateProps;if ql==nil then return end;if typeof(ql)~="function"then error(("validateProps must be a function, but it is a %s.\nCheck the definition of the component %q."):format(typeof(ql),self.__componentName))end;local nk,qm=ql(kX)if not nk then qm=qm or"<Validator function did not supply a message>"error(("Property validation failed in %s: %s\n\n%s"):format(self.__componentName,tostring(qm),self:getElementTraceback()or"<enable element tracebacks>"),0)end end;function q6:__mount(qi,qh)if pN.internalTypeChecks then q0(pM.of(self)==pM.StatefulComponentClass,"Invalid use of `__mount`")q0(pM.of(qh)==pM.VirtualNode,"Expected arg #2 to be of type VirtualNode")end;local qn=qh.currentElement;local qo=qh.hostParent;local q9={reconciler=qi,virtualNode=qh,componentClass=self,lifecyclePhase=pZ.Init}local pp={[pM]=pM.StatefulComponentInstance,[q2]=q9}setmetatable(pp,self)qh.instance=pp;local kX=qn.props;if self.defaultProps~=nil then kX=pY({},self.defaultProps,kX)end;pp:__validateProps(kX)pp.props=kX;local qp=pY({},qh.legacyContext)pp._context=qp;pp.state=pY({},pp:__getDerivedState(pp.props,{}))if pp.init~=nil then pp:init(pp.props)pY(pp.state,pp:__getDerivedState(pp.props,pp.state))end;qh.legacyContext=pp._context;q9.lifecyclePhase=pZ.Render;local qq=pp:render()q9.lifecyclePhase=pZ.ReconcileChildren;qi.updateVirtualNodeWithRenderResult(qh,qo,qq)if pp.didMount~=nil then q9.lifecyclePhase=pZ.DidMount;pp:didMount()end;if q9.pendingState~=nil then pp:__update(nil,nil)end;q9.lifecyclePhase=pZ.Idle end;function q6:__unmount()if pN.internalTypeChecks then q0(pM.of(self)==pM.StatefulComponentInstance,"Invalid use of `__unmount`")end;local q9=self[q2]local qh=q9.virtualNode;local qi=q9.reconciler;if self.willUnmount~=nil then q9.lifecyclePhase=pZ.WillUnmount;self:willUnmount()end;for ev,qr in pairs(qh.children)do qi.unmountVirtualNode(qr)end end;function q6:__update(qs,qt)if pN.internalTypeChecks then q0(pM.of(self)==pM.StatefulComponentInstance,"Invalid use of `__update`")q0(pM.of(qs)==pM.Element or qs==nil,"Expected arg #1 to be of type Element or nil")q0(typeof(qt)=="table"or qt==nil,"Expected arg #2 to be of type table or nil")end;local q9=self[q2]local qa=q9.componentClass;local qu=self.props;if qs~=nil then qu=qs.props;if qa.defaultProps~=nil then qu=pY({},qa.defaultProps,qu)end;self:__validateProps(qu)end;local qv=0;repeat local qw;local qf=nil;if q9.pendingState~=nil then qf=q9.pendingState;q9.pendingState=nil end;if qt~=nil or qu~=self.props then if qf==nil then qw=qt or self.state else qw=pY(qf,qt)end;local qb=self:__getDerivedState(qu,qw)if qb~=nil then qw=pY({},qw,qb)end;qt=nil else qw=qf end;if not self:__resolveUpdate(qu,qw)then return false end;qv=qv+1;if qv>q1 then error(q4:format(tostring(q9.componentClass)),3)end until q9.pendingState==nil;return true end;function q6:__resolveUpdate(q7,q8)if pN.internalTypeChecks then q0(pM.of(self)==pM.StatefulComponentInstance,"Invalid use of `__resolveUpdate`")end;local q9=self[q2]local qh=q9.virtualNode;local qi=q9.reconciler;local qx=self.props;local qy=self.state;if q7==nil then q7=qx end;if q8==nil then q8=qy end;if self.shouldUpdate~=nil then q9.lifecyclePhase=pZ.ShouldUpdate;local qz=self:shouldUpdate(q7,q8)if not qz then q9.lifecyclePhase=pZ.Idle;return false end end;if self.willUpdate~=nil then q9.lifecyclePhase=pZ.WillUpdate;self:willUpdate(q7,q8)end;q9.lifecyclePhase=pZ.Render;self.props=q7;self.state=q8;local qq=qh.instance:render()q9.lifecyclePhase=pZ.ReconcileChildren;qi.updateVirtualNodeWithRenderResult(qh,qh.hostParent,qq)if self.didUpdate~=nil then q9.lifecyclePhase=pZ.DidUpdate;self:didUpdate(qx,qy)end;q9.lifecyclePhase=pZ.Idle;return true end;return q6 end,newEnv("Orca.include.node_modules.roact.src.Component"))()end)newModule("ComponentLifecyclePhase","ModuleScript","Orca.include.node_modules.roact.src.ComponentLifecyclePhase","Orca.include.node_modules.roact.src",function()return setfenv(function()local pL=require(script.Parent.Symbol)local pG=require(script.Parent.strict)local pZ=pG({Init=pL.named("init"),Render=pL.named("render"),ShouldUpdate=pL.named("shouldUpdate"),WillUpdate=pL.named("willUpdate"),DidMount=pL.named("didMount"),DidUpdate=pL.named("didUpdate"),WillUnmount=pL.named("willUnmount"),ReconcileChildren=pL.named("reconcileChildren"),Idle=pL.named("idle")},"ComponentLifecyclePhase")return pZ end,newEnv("Orca.include.node_modules.roact.src.ComponentLifecyclePhase"))()end)newModule("Config","ModuleScript","Orca.include.node_modules.roact.src.Config","Orca.include.node_modules.roact.src",function()return setfenv(function()local qA={["internalTypeChecks"]=false,["typeChecks"]=false,["elementTracing"]=false,["propValidation"]=false,["tempFixUpdateChildrenReEntrancy"]=false}local qB={}for ej in pairs(qA)do table.insert(qB,ej)end;local mh={}function mh.new()local self={}self._currentConfig=setmetatable({},{__index=function(ev,ej)local ok=("Invalid global configuration key %q. Valid configuration keys are: %s"):format(tostring(ej),table.concat(qB,", "))error(ok,3)end})self.set=function(...)return mh.set(self,...)end;self.get=function(...)return mh.get(self,...)end;self.scoped=function(...)return mh.scoped(self,...)end;self.set(qA)return self end;function mh:set(qC)for ej,d3 in pairs(qC)do if qA[ej]==nil then local ok=("Invalid global configuration key %q (type %s). Valid configuration keys are: %s"):format(tostring(ej),typeof(ej),table.concat(qB,", "))error(ok,3)end;if typeof(d3)~="boolean"then local ok=("Invalid value %q (type %s) for global configuration key %q. Valid values are: true, false"):format(tostring(d3),typeof(d3),tostring(ej))error(ok,3)end;self._currentConfig[ej]=d3 end end;function mh:get()return self._currentConfig end;function mh:scoped(qC,da)local qD={}for ej,d3 in pairs(self._currentConfig)do qD[ej]=d3 end;self.set(qC)local nk,dx=pcall(da)self.set(qD)assert(nk,dx)end;return mh end,newEnv("Orca.include.node_modules.roact.src.Config"))()end)newModule("ElementKind","ModuleScript","Orca.include.node_modules.roact.src.ElementKind","Orca.include.node_modules.roact.src",function()return setfenv(function()local pL=require(script.Parent.Symbol)local pG=require(script.Parent.strict)local qE=require(script.Parent.Portal)local qF=newproxy(true)local qG={Portal=pL.named("Portal"),Host=pL.named("Host"),Function=pL.named("Function"),Stateful=pL.named("Stateful"),Fragment=pL.named("Fragment")}function qG.of(d3)if typeof(d3)~="table"then return nil end;return d3[qF]end;local qH={["string"]=qG.Host,["function"]=qG.Function,["table"]=qG.Stateful}function qG.fromComponent(qI)if qI==qE then return qF.Portal else return qH[typeof(qI)]end end;getmetatable(qF).__index=qG;pG(qG,"ElementKind")return qF end,newEnv("Orca.include.node_modules.roact.src.ElementKind"))()end)newModule("ElementUtils","ModuleScript","Orca.include.node_modules.roact.src.ElementUtils","Orca.include.node_modules.roact.src",function()return setfenv(function()local pM=require(script.Parent.Type)local pL=require(script.Parent.Symbol)local function oW()return nil end;local qJ={}qJ.UseParentKey=pL.named("UseParentKey")function qJ.iterateElements(qK)local qL=pM.of(qK)if qL==pM.Element then local qM=false;return function()if qM then return nil else qM=true;return qJ.UseParentKey,qK end end end;local qN=typeof(qK)if qK==nil or qN=="boolean"then return oW end;if qN=="table"then return pairs(qK)end;error("Invalid elements")end;function qJ.getElementByKey(qO,qP)if qO==nil or typeof(qO)=="boolean"then return nil end;if pM.of(qO)==pM.Element then if qP==qJ.UseParentKey then return qO end;return nil end;if typeof(qO)=="table"then return qO[qP]end;error("Invalid elements")end;return qJ end,newEnv("Orca.include.node_modules.roact.src.ElementUtils"))()end)newModule("GlobalConfig","ModuleScript","Orca.include.node_modules.roact.src.GlobalConfig","Orca.include.node_modules.roact.src",function()return setfenv(function()local mh=require(script.Parent.Config)return mh.new()end,newEnv("Orca.include.node_modules.roact.src.GlobalConfig"))()end)newModule("Logging","ModuleScript","Orca.include.node_modules.roact.src.Logging","Orca.include.node_modules.roact.src",function()return setfenv(function()local qQ=true;local qR={}local qS={}local function qT(qU,qV)local qW=("\t"):rep(qV)return qW..qU:gsub("\n","\n"..qW)end;local function qX(qY,qV)local qZ={}for ev,q_ in ipairs(qY)do table.insert(qZ,qT(q_,qV))end;return table.concat(qZ,"\n")end;local r0={}function r0:__tostring()local qZ={"LogInfo {"}local r1=#self.errors;local r2=#self.warnings;local r3=#self.infos;if r1+r2+r3==0 then table.insert(qZ,"\t(no messages)")end;if r1>0 then table.insert(qZ,("\tErrors (%d) {"):format(r1))table.insert(qZ,qX(self.errors,2))table.insert(qZ,"\t}")end;if r2>0 then table.insert(qZ,("\tWarnings (%d) {"):format(r2))table.insert(qZ,qX(self.warnings,2))table.insert(qZ,"\t}")end;if r3>0 then table.insert(qZ,("\tInfos (%d) {"):format(r3))table.insert(qZ,qX(self.infos,2))table.insert(qZ,"\t}")end;table.insert(qZ,"}")return table.concat(qZ,"\n")end;local function r4()local r5={errors={},warnings={},infos={}}setmetatable(r5,r0)return r5 end;local r6={}function r6.capture(da)local r7=r4()local r8=qQ;qQ=false;qR[r7]=true;local nk,dx=pcall(da)qR[r7]=nil;qQ=r8;assert(nk,dx)return r7 end;function r6.warn(qe,...)local ok=qe:format(...)for r7 in pairs(qR)do table.insert(r7.warnings,ok)end;local r9=debug.traceback("",2):sub(2)local ra=("%s\n%s"):format(ok,qT(r9,1))if qQ then warn(ra)end end;function r6.warnOnce(qe,...)local r9=debug.traceback()if qS[r9]then return end;qS[r9]=true;r6.warn(qe,...)end;return r6 end,newEnv("Orca.include.node_modules.roact.src.Logging"))()end)newModule("None","ModuleScript","Orca.include.node_modules.roact.src.None","Orca.include.node_modules.roact.src",function()return setfenv(function()local pL=require(script.Parent.Symbol)local rb=pL.named("None")return rb end,newEnv("Orca.include.node_modules.roact.src.None"))()end)newModule("NoopRenderer","ModuleScript","Orca.include.node_modules.roact.src.NoopRenderer","Orca.include.node_modules.roact.src",function()return setfenv(function()local rc={}function rc.isHostObject(an)return an==nil end;function rc.mountHostNode(qi,o3)end;function rc.unmountHostNode(qi,o3)end;function rc.updateHostNode(qi,o3,rd)return o3 end;return rc end,newEnv("Orca.include.node_modules.roact.src.NoopRenderer"))()end)newModule("Portal","ModuleScript","Orca.include.node_modules.roact.src.Portal","Orca.include.node_modules.roact.src",function()return setfenv(function()local pL=require(script.Parent.Symbol)local qE=pL.named("Portal")return qE end,newEnv("Orca.include.node_modules.roact.src.Portal"))()end)newInstance("PropMarkers","Folder","Orca.include.node_modules.roact.src.PropMarkers","Orca.include.node_modules.roact.src")newModule("Change","ModuleScript","Orca.include.node_modules.roact.src.PropMarkers.Change","Orca.include.node_modules.roact.src.PropMarkers",function()return setfenv(function()local pM=require(script.Parent.Parent.Type)local re={}local rf={__tostring=function(self)return("RoactHostChangeEvent(%s)"):format(self.name)end}setmetatable(re,{__index=function(self,rg)local rh={[pM]=pM.HostChangeEvent,name=rg}setmetatable(rh,rf)re[rg]=rh;return rh end})return re end,newEnv("Orca.include.node_modules.roact.src.PropMarkers.Change"))()end)newModule("Children","ModuleScript","Orca.include.node_modules.roact.src.PropMarkers.Children","Orca.include.node_modules.roact.src.PropMarkers",function()return setfenv(function()local pL=require(script.Parent.Parent.Symbol)local ri=pL.named("Children")return ri end,newEnv("Orca.include.node_modules.roact.src.PropMarkers.Children"))()end)newModule("Event","ModuleScript","Orca.include.node_modules.roact.src.PropMarkers.Event","Orca.include.node_modules.roact.src.PropMarkers",function()return setfenv(function()local pM=require(script.Parent.Parent.Type)local rj={}local rk={__tostring=function(self)return("RoactHostEvent(%s)"):format(self.name)end}setmetatable(rj,{__index=function(self,rl)local oo={[pM]=pM.HostEvent,name=rl}setmetatable(oo,rk)rj[rl]=oo;return oo end})return rj end,newEnv("Orca.include.node_modules.roact.src.PropMarkers.Event"))()end)newModule("Ref","ModuleScript","Orca.include.node_modules.roact.src.PropMarkers.Ref","Orca.include.node_modules.roact.src.PropMarkers",function()return setfenv(function()local pL=require(script.Parent.Parent.Symbol)local rm=pL.named("Ref")return rm end,newEnv("Orca.include.node_modules.roact.src.PropMarkers.Ref"))()end)newModule("PureComponent","ModuleScript","Orca.include.node_modules.roact.src.PureComponent","Orca.include.node_modules.roact.src",function()return setfenv(function()local q6=require(script.Parent.Component)local rn=q6:extend("PureComponent")rn.extend=q6.extend;function rn:shouldUpdate(qu,ex)if ex~=self.state then return true end;if qu==self.props then return false end;for ej,d3 in pairs(qu)do if self.props[ej]~=d3 then return true end end;for ej,d3 in pairs(self.props)do if qu[ej]~=d3 then return true end end;return false end;return rn end,newEnv("Orca.include.node_modules.roact.src.PureComponent"))()end)newModule("RobloxRenderer","ModuleScript","Orca.include.node_modules.roact.src.RobloxRenderer","Orca.include.node_modules.roact.src",function()return setfenv(function()local pH=require(script.Parent.Binding)local ri=require(script.Parent.PropMarkers.Children)local qF=require(script.Parent.ElementKind)local ro=require(script.Parent.SingleEventManager)local rp=require(script.Parent.getDefaultInstanceProperty)local rm=require(script.Parent.PropMarkers.Ref)local pM=require(script.Parent.Type)local q0=require(script.Parent.internalAssert)local pN=require(script.Parent.GlobalConfig).get()local rq=[[
Error applying props:
	%s
In element:
%s
]]local rr=[[
Error updating props:
	%s
In element:
%s
]]local function rs(...)return...end;local function rt(db,ru)if db==nil then return end;if typeof(db)=="function"then db(ru)elseif pM.of(db)==pM.Binding then pH.update(db,ru)else error(("Invalid ref: Expected type Binding but got %s"):format(typeof(db)))end end;local function rv(rw,ej,pS)if pS==nil then local rx=rw.ClassName;local ev,iG=rp(rx,ej)pS=iG end;rw[ej]=pS;return end;local function ry(qh,ej)local oq=qh.bindings[ej]oq()qh.bindings[ej]=nil end;local function rz(qh,ej,rA)local function rB(pS)local nk,rC=xpcall(function()rv(qh.hostObject,ej,pS)end,rs)if not nk then local qU=qh.currentElement.source;if qU==nil then qU="<enable element tracebacks>"end;local ra=rr:format(rC,qU)error(ra,0)end end;if qh.bindings==nil then qh.bindings={}end;qh.bindings[ej]=pH.subscribe(rA,rB)rB(rA:getValue())end;local function rD(qh)if qh.bindings~=nil then for ev,oq in pairs(qh.bindings)do oq()end end end;local function rE(qh,ej,pS,rF)if pS==rF then return end;if ej==rm or ej==ri then return end;local rG=pM.of(ej)if rG==pM.HostEvent or rG==pM.HostChangeEvent then if qh.eventManager==nil then qh.eventManager=ro.new(qh.hostObject)end;local rl=ej.name;if rG==pM.HostChangeEvent then qh.eventManager:connectPropertyChange(rl,pS)else qh.eventManager:connectEvent(rl,pS)end;return end;local rH=pM.of(pS)==pM.Binding;local rI=pM.of(rF)==pM.Binding;if rI then ry(qh,ej)end;if rH then rz(qh,ej,pS)else rv(qh.hostObject,ej,pS)end end;local function rJ(qh,kX)for rK,d3 in pairs(kX)do rE(qh,rK,d3,nil)end end;local function rL(qh,qx,qu)for rK,pS in pairs(qu)do local rF=qx[rK]rE(qh,rK,pS,rF)end;for rK,rF in pairs(qx)do local pS=qu[rK]if pS==nil then rE(qh,rK,nil,rF)end end end;local pF={}function pF.isHostObject(an)return typeof(an)=="Instance"end;function pF.mountHostNode(qi,qh)local rM=qh.currentElement;local qo=qh.hostParent;local qP=qh.hostKey;if pN.internalTypeChecks then q0(qF.of(rM)==qF.Host,"Element at given node is not a host Element")end;if pN.typeChecks then assert(rM.props.Name==nil,"Name can not be specified as a prop to a host component in Roact.")assert(rM.props.Parent==nil,"Parent can not be specified as a prop to a host component in Roact.")end;local pp=Instance.new(rM.component)qh.hostObject=pp;local nk,rC=xpcall(function()rJ(qh,rM.props)end,rs)if not nk then local qU=rM.source;if qU==nil then qU="<enable element tracebacks>"end;local ra=rq:format(rC,qU)error(ra,0)end;pp.Name=tostring(qP)local bb=rM.props[ri]if bb~=nil then qi.updateVirtualNodeWithChildren(qh,qh.hostObject,bb)end;pp.Parent=qo;qh.hostObject=pp;rt(rM.props[rm],pp)if qh.eventManager~=nil then qh.eventManager:resume()end end;function pF.unmountHostNode(qi,qh)local rM=qh.currentElement;rt(rM.props[rm],nil)for ev,qr in pairs(qh.children)do qi.unmountVirtualNode(qr)end;rD(qh)qh.hostObject:Destroy()end;function pF.updateHostNode(qi,qh,rd)local qx=qh.currentElement.props;local qu=rd.props;if qh.eventManager~=nil then qh.eventManager:suspend()end;if qx[rm]~=qu[rm]then rt(qx[rm],nil)rt(qu[rm],qh.hostObject)end;local nk,rC=xpcall(function()rL(qh,qx,qu)end,rs)if not nk then local qU=rd.source;if qU==nil then qU="<enable element tracebacks>"end;local ra=rr:format(rC,qU)error(ra,0)end;local bb=rd.props[ri]if bb~=nil or qx[ri]~=nil then qi.updateVirtualNodeWithChildren(qh,qh.hostObject,bb)end;if qh.eventManager~=nil then qh.eventManager:resume()end;return qh end;return pF end,newEnv("Orca.include.node_modules.roact.src.RobloxRenderer"))()end)newModule("SingleEventManager","ModuleScript","Orca.include.node_modules.roact.src.SingleEventManager","Orca.include.node_modules.roact.src",function()return setfenv(function()local r6=require(script.Parent.Logging)local rN="Change."local rO={Disabled="Disabled",Suspended="Suspended",Enabled="Enabled"}local ro={}ro.__index=ro;function ro.new(pp)local self=setmetatable({_suspendedEventQueue={},_connections={},_listeners={},_status=rO.Disabled,_isResuming=false,_instance=pp},ro)return self end;function ro:connectEvent(ej,rP)self:_connect(ej,self._instance[ej],rP)end;function ro:connectPropertyChange(ej,rP)local nk,oo=pcall(function()return self._instance:GetPropertyChangedSignal(ej)end)if not nk then error(("Cannot get changed signal on property %q: %s"):format(tostring(ej),oo),0)end;self:_connect(rN..ej,oo,rP)end;function ro:_connect(rQ,oo,rP)if rP==nil then if self._connections[rQ]~=nil then self._connections[rQ]:Disconnect()self._connections[rQ]=nil end;self._listeners[rQ]=nil else if self._connections[rQ]==nil then self._connections[rQ]=oo:Connect(function(...)if self._status==rO.Enabled then self._listeners[rQ](self._instance,...)elseif self._status==rO.Suspended then local rR=select("#",...)table.insert(self._suspendedEventQueue,{rQ,rR,...})end end)end;self._listeners[rQ]=rP end end;function ro:suspend()self._status=rO.Suspended end;function ro:resume()if self._isResuming then return end;self._isResuming=true;local c2=1;while c2<=#self._suspendedEventQueue do local rS=self._suspendedEventQueue[c2]local rP=self._listeners[rS[1]]local rR=rS[2]if rP~=nil then local rT=coroutine.create(rP)local nk,dx=coroutine.resume(rT,self._instance,unpack(rS,3,2+rR))if not nk then r6.warn("%s",dx)end end;c2=c2+1 end;self._isResuming=false;self._status=rO.Enabled;self._suspendedEventQueue={}end;return ro end,newEnv("Orca.include.node_modules.roact.src.SingleEventManager"))()end)newModule("Symbol","ModuleScript","Orca.include.node_modules.roact.src.Symbol","Orca.include.node_modules.roact.src",function()return setfenv(function()local pL={}function pL.named(hp)assert(type(hp)=="string","Symbols must be created using a string name!")local self=newproxy(true)local rU=("Symbol(%s)"):format(hp)getmetatable(self).__tostring=function()return rU end;return self end;return pL end,newEnv("Orca.include.node_modules.roact.src.Symbol"))()end)newModule("Type","ModuleScript","Orca.include.node_modules.roact.src.Type","Orca.include.node_modules.roact.src",function()return setfenv(function()local pL=require(script.Parent.Symbol)local pG=require(script.Parent.strict)local pM=newproxy(true)local rV={}local function rW(hp)rV[hp]=pL.named("Roact"..hp)end;rW("Binding")rW("Element")rW("HostChangeEvent")rW("HostEvent")rW("StatefulComponentClass")rW("StatefulComponentInstance")rW("VirtualNode")rW("VirtualTree")function rV.of(d3)if typeof(d3)~="table"then return nil end;return d3[pM]end;getmetatable(pM).__index=rV;getmetatable(pM).__tostring=function()return"RoactType"end;pG(rV,"Type")return pM end,newEnv("Orca.include.node_modules.roact.src.Type"))()end)newModule("assertDeepEqual","ModuleScript","Orca.include.node_modules.roact.src.assertDeepEqual","Orca.include.node_modules.roact.src",function()return setfenv(function()local function rX(hx,dG)if typeof(hx)~=typeof(dG)then local ok=("{1} is of type %s, but {2} is of type %s"):format(typeof(hx),typeof(dG))return false,ok end;if typeof(hx)=="table"then local rY={}for ej,d3 in pairs(hx)do rY[ej]=true;local nk,rZ=rX(d3,dG[ej])if not nk then local ok=rZ:gsub("{1}",("{1}[%s]"):format(tostring(ej))):gsub("{2}",("{2}[%s]"):format(tostring(ej)))return false,ok end end;for ej,d3 in pairs(dG)do if not rY[ej]then local nk,rZ=rX(d3,hx[ej])if not nk then local ok=rZ:gsub("{1}",("{1}[%s]"):format(tostring(ej))):gsub("{2}",("{2}[%s]"):format(tostring(ej)))return false,ok end end end;return true end;if hx==dG then return true end;local ok="{1} ~= {2}"return false,ok end;local function r_(hx,dG)local nk,s0=rX(hx,dG)if not nk then local rZ=s0:gsub("{1}","first"):gsub("{2}","second")local ok=("Values were not deep-equal.\n%s"):format(rZ)error(ok,2)end end;return r_ end,newEnv("Orca.include.node_modules.roact.src.assertDeepEqual"))()end)newModule("assign","ModuleScript","Orca.include.node_modules.roact.src.assign","Orca.include.node_modules.roact.src",function()return setfenv(function()local rb=require(script.Parent.None)local function pY(an,...)for c2=1,select("#",...)do local qU=select(c2,...)if qU~=nil then for ej,d3 in pairs(qU)do if d3==rb then an[ej]=nil else an[ej]=d3 end end end end;return an end;return pY end,newEnv("Orca.include.node_modules.roact.src.assign"))()end)newModule("createContext","ModuleScript","Orca.include.node_modules.roact.src.createContext","Orca.include.node_modules.roact.src",function()return setfenv(function()local pL=require(script.Parent.Symbol)local s1=require(script.Parent.createFragment)local pK=require(script.Parent.createSignal)local ri=require(script.Parent.PropMarkers.Children)local q6=require(script.Parent.Component)local function s2(s3)return{value=s3,onUpdate=pK()}end;local function s4(qj)local ah=q6:extend("Provider")function ah:init(kX)self.contextEntry=s2(kX.value)self:__addContext(qj.key,self.contextEntry)end;function ah:willUpdate(s5)if s5.value~=self.props.value then self.contextEntry.value=s5.value end end;function ah:didUpdate(s6)if s6.value~=self.props.value then self.contextEntry.onUpdate:fire(self.props.value)end end;function ah:render()return s1(self.props[ri])end;return ah end;local function s7(qj)local s8=q6:extend("Consumer")function s8.validateProps(kX)if type(kX.render)~="function"then return false,"Consumer expects a `render` function"else return true end end;function s8:init(kX)self.contextEntry=self:__getContext(qj.key)end;function s8:render()local d3;if self.contextEntry~=nil then d3=self.contextEntry.value else d3=qj.defaultValue end;return self.props.render(d3)end;function s8:didUpdate()if self.contextEntry~=nil then self.lastValue=self.contextEntry.value end end;function s8:didMount()if self.contextEntry~=nil then self.disconnect=self.contextEntry.onUpdate:subscribe(function(pS)if pS~=self.lastValue then self:setState({})end end)end end;function s8:willUnmount()if self.disconnect~=nil then self.disconnect()end end;return s8 end;local s9={}s9.__index=s9;function s9.new(iG)return setmetatable({defaultValue=iG,key=pL.named("ContextKey")},s9)end;function s9:__tostring()return"RoactContext"end;local function sa(iG)local qj=s9.new(iG)return{Provider=s4(qj),Consumer=s7(qj)}end;return sa end,newEnv("Orca.include.node_modules.roact.src.createContext"))()end)newModule("createElement","ModuleScript","Orca.include.node_modules.roact.src.createElement","Orca.include.node_modules.roact.src",function()return setfenv(function()local ri=require(script.Parent.PropMarkers.Children)local qF=require(script.Parent.ElementKind)local r6=require(script.Parent.Logging)local pM=require(script.Parent.Type)local pN=require(script.Parent.GlobalConfig).get()local sb=[[
The prop `Roact.Children` was defined but was overriden by the third parameter to createElement!
This can happen when a component passes props through to a child element but also uses the `children` argument:

	Roact.createElement("Frame", passedProps, {
		child = ...
	})

Instead, consider using a utility function to merge tables of children together:

	local children = mergeTables(passedProps[Roact.Children], {
		child = ...
	})

	local fullProps = mergeTables(passedProps, {
		[Roact.Children] = children
	})

	Roact.createElement("Frame", fullProps)]]local function sc(qI,kX,bb)if pN.typeChecks then assert(qI~=nil,"`component` is required")assert(typeof(kX)=="table"or kX==nil,"`props` must be a table or nil")assert(typeof(bb)=="table"or bb==nil,"`children` must be a table or nil")end;if kX==nil then kX={}end;if bb~=nil then if kX[ri]~=nil then r6.warnOnce(sb)end;kX[ri]=bb end;local sd=qF.fromComponent(qI)local rM={[pM]=pM.Element,[qF]=sd,component=qI,props=kX}if pN.elementTracing then rM.source=debug.traceback("",2):sub(2)end;return rM end;return sc end,newEnv("Orca.include.node_modules.roact.src.createElement"))()end)newModule("createFragment","ModuleScript","Orca.include.node_modules.roact.src.createFragment","Orca.include.node_modules.roact.src",function()return setfenv(function()local qF=require(script.Parent.ElementKind)local pM=require(script.Parent.Type)local function s1(qO)return{[pM]=pM.Element,[qF]=qF.Fragment,elements=qO}end;return s1 end,newEnv("Orca.include.node_modules.roact.src.createFragment"))()end)newModule("createReconciler","ModuleScript","Orca.include.node_modules.roact.src.createReconciler","Orca.include.node_modules.roact.src",function()return setfenv(function()local pM=require(script.Parent.Type)local qF=require(script.Parent.ElementKind)local qJ=require(script.Parent.ElementUtils)local ri=require(script.Parent.PropMarkers.Children)local pL=require(script.Parent.Symbol)local q0=require(script.Parent.internalAssert)local pN=require(script.Parent.GlobalConfig).get()local q2=pL.named("InternalData")local function pD(se)local qi;local sf;local sg;local sh;local function si(qh,rd)local qo=qh.hostParent;local qP=qh.hostKey;local oG=qh.depth;local nb=qh.parent;local qj=qh.originalContext or qh.context;local sj=qh.parentLegacyContext;sh(qh)local sk=sf(rd,qo,qP,qj,sj)if sk~=nil then sk.depth=oG;sk.parent=nb end;return sk end;local function sl(qh,qo,sm)if pN.internalTypeChecks then q0(pM.of(qh)==pM.VirtualNode,"Expected arg #1 to be of type VirtualNode")end;local sn={}for so,qr in pairs(qh.children)do local rd=qJ.getElementByKey(sm,so)local sk=sg(qr,rd)if sk~=nil then qh.children[so]=sk else sn[so]=true end end;for so in pairs(sn)do qh.children[so]=nil end;for so,rd in qJ.iterateElements(sm)do local sp=so;if so==qJ.UseParentKey then sp=qh.hostKey end;if qh.children[so]==nil then local qr=sf(rd,qo,sp,qh.context,qh.legacyContext)if qr~=nil then qr.depth=qh.depth+1;qr.parent=qh;qh.children[so]=qr end end end end;local function sq(qh,qo,sm)sl(qh,qo,sm)end;local function sr(qh,qo,qq)if pM.of(qq)==pM.Element or qq==nil or typeof(qq)=="boolean"then sl(qh,qo,qq)else error(("%s\n%s"):format("Component returned invalid children:",qh.currentElement.source or"<enable element tracebacks>"),0)end end;function sh(qh)if pN.internalTypeChecks then q0(pM.of(qh)==pM.VirtualNode,"Expected arg #1 to be of type VirtualNode")end;local ne=qF.of(qh.currentElement)if ne==qF.Host then se.unmountHostNode(qi,qh)elseif ne==qF.Function then for ev,qr in pairs(qh.children)do sh(qr)end elseif ne==qF.Stateful then qh.instance:__unmount()elseif ne==qF.Portal then for ev,qr in pairs(qh.children)do sh(qr)end elseif ne==qF.Fragment then for ev,qr in pairs(qh.children)do sh(qr)end else error(("Unknown ElementKind %q"):format(tostring(ne)),2)end end;local function ss(qh,rd)local bb=rd.component(rd.props)sr(qh,qh.hostParent,bb)return qh end;local function st(qh,rd)local su=qh.currentElement;local sv=su.props.target;local sw=rd.props.target;assert(se.isHostObject(sw),"Expected target to be host object")if sw~=sv then return si(qh,rd)end;local bb=rd.props[ri]sq(qh,sw,bb)return qh end;local function sx(qh,rd)sq(qh,qh.hostParent,rd.elements)return qh end;function sg(qh,rd,ex)if pN.internalTypeChecks then q0(pM.of(qh)==pM.VirtualNode,"Expected arg #1 to be of type VirtualNode")end;if pN.typeChecks then assert(pM.of(rd)==pM.Element or typeof(rd)=="boolean"or rd==nil,"Expected arg #2 to be of type Element, boolean, or nil")end;if qh.currentElement==rd and ex==nil then return qh end;if typeof(rd)=="boolean"or rd==nil then sh(qh)return nil end;if qh.currentElement.component~=rd.component then return si(qh,rd)end;local ne=qF.of(rd)local sy=true;if ne==qF.Host then qh=se.updateHostNode(qi,qh,rd)elseif ne==qF.Function then qh=ss(qh,rd)elseif ne==qF.Stateful then sy=qh.instance:__update(rd,ex)elseif ne==qF.Portal then qh=st(qh,rd)elseif ne==qF.Fragment then qh=sx(qh,rd)else error(("Unknown ElementKind %q"):format(tostring(ne)),2)end;if not sy then return qh end;qh.currentElement=rd;return qh end;local function sz(rM,qo,qP,qj,sA)if pN.internalTypeChecks then q0(se.isHostObject(qo)or qo==nil,"Expected arg #2 to be a host object")q0(typeof(qj)=="table"or qj==nil,"Expected arg #4 to be of type table or nil")q0(typeof(sA)=="table"or sA==nil,"Expected arg #5 to be of type table or nil")end;if pN.typeChecks then assert(qP~=nil,"Expected arg #3 to be non-nil")assert(pM.of(rM)==pM.Element or typeof(rM)=="boolean","Expected arg #1 to be of type Element or boolean")end;return{[pM]=pM.VirtualNode,currentElement=rM,depth=1,parent=nil,children={},hostParent=qo,hostKey=qP,legacyContext=sA,parentLegacyContext=sA,context=qj or{},originalContext=nil}end;local function sB(qh)local rM=qh.currentElement;local bb=rM.component(rM.props)sr(qh,qh.hostParent,bb)end;local function sC(qh)local rM=qh.currentElement;local sw=rM.props.target;local bb=rM.props[ri]assert(se.isHostObject(sw),"Expected target to be host object")sq(qh,sw,bb)end;local function sD(qh)local rM=qh.currentElement;local bb=rM.elements;sq(qh,qh.hostParent,bb)end;function sf(rM,qo,qP,qj,sA)if pN.internalTypeChecks then q0(se.isHostObject(qo)or qo==nil,"Expected arg #2 to be a host object")q0(typeof(sA)=="table"or sA==nil,"Expected arg #5 to be of type table or nil")end;if pN.typeChecks then assert(qP~=nil,"Expected arg #3 to be non-nil")assert(pM.of(rM)==pM.Element or typeof(rM)=="boolean","Expected arg #1 to be of type Element or boolean")end;if typeof(rM)=="boolean"then return nil end;local ne=qF.of(rM)local qh=sz(rM,qo,qP,qj,sA)if ne==qF.Host then se.mountHostNode(qi,qh)elseif ne==qF.Function then sB(qh)elseif ne==qF.Stateful then rM.component:__mount(qi,qh)elseif ne==qF.Portal then sC(qh)elseif ne==qF.Fragment then sD(qh)else error(("Unknown ElementKind %q"):format(tostring(ne)),2)end;return qh end;local function sE(rM,qo,qP)if pN.typeChecks then assert(pM.of(rM)==pM.Element,"Expected arg #1 to be of type Element")assert(se.isHostObject(qo)or qo==nil,"Expected arg #2 to be a host object")end;if qP==nil then qP="RoactTree"end;local sF={[pM]=pM.VirtualTree,[q2]={rootNode=nil,mounted=true}}sF[q2].rootNode=sf(rM,qo,qP)return sF end;local function sG(sF)local q9=sF[q2]if pN.typeChecks then assert(pM.of(sF)==pM.VirtualTree,"Expected arg #1 to be a Roact handle")assert(q9.mounted,"Cannot unmounted a Roact tree that has already been unmounted")end;q9.mounted=false;if q9.rootNode~=nil then sh(q9.rootNode)end end;local function sH(sF,rd)local q9=sF[q2]if pN.typeChecks then assert(pM.of(sF)==pM.VirtualTree,"Expected arg #1 to be a Roact handle")assert(pM.of(rd)==pM.Element,"Expected arg #2 to be a Roact Element")end;q9.rootNode=sg(q9.rootNode,rd)return sF end;local function sI(qh)local sJ=qh.parent;while sJ do if sJ.eventManager~=nil then sJ.eventManager:suspend()end;sJ=sJ.parent end end;local function sK(qh)local sJ=qh.parent;while sJ do if sJ.eventManager~=nil then sJ.eventManager:resume()end;sJ=sJ.parent end end;qi={mountVirtualTree=sE,unmountVirtualTree=sG,updateVirtualTree=sH,createVirtualNode=sz,mountVirtualNode=sf,unmountVirtualNode=sh,updateVirtualNode=sg,updateVirtualNodeWithChildren=sq,updateVirtualNodeWithRenderResult=sr,suspendParentEvents=sI,resumeParentEvents=sK}return qi end;return pD end,newEnv("Orca.include.node_modules.roact.src.createReconciler"))()end)newModule("createReconcilerCompat","ModuleScript","Orca.include.node_modules.roact.src.createReconcilerCompat","Orca.include.node_modules.roact.src",function()return setfenv(function()local r6=require(script.Parent.Logging)local sL=[[
Roact.reify has been renamed to Roact.mount and will be removed in a future release.
Check the call to Roact.reify at:
]]local sM=[[
Roact.teardown has been renamed to Roact.unmount and will be removed in a future release.
Check the call to Roact.teardown at:
]]local sN=[[
Roact.reconcile has been renamed to Roact.update and will be removed in a future release.
Check the call to Roact.reconcile at:
]]local function pE(qi)local sO={}function sO.reify(...)r6.warnOnce(sL)return qi.mountVirtualTree(...)end;function sO.teardown(...)r6.warnOnce(sM)return qi.unmountVirtualTree(...)end;function sO.reconcile(...)r6.warnOnce(sN)return qi.updateVirtualTree(...)end;return sO end;return pE end,newEnv("Orca.include.node_modules.roact.src.createReconcilerCompat"))()end)newModule("createRef","ModuleScript","Orca.include.node_modules.roact.src.createRef","Orca.include.node_modules.roact.src",function()return setfenv(function()local pH=require(script.Parent.Binding)local function sP()local cC,ev=pH.create(nil)local db={}setmetatable(db,{__index=function(self,ej)if ej=="current"then return cC:getValue()else return cC[ej]end end,__newindex=function(self,ej,d3)if ej=="current"then error("Cannot assign to the 'current' property of refs",2)end;cC[ej]=d3 end,__tostring=function(self)return("RoactRef(%s)"):format(tostring(cC:getValue()))end})return db end;return sP end,newEnv("Orca.include.node_modules.roact.src.createRef"))()end)newModule("createSignal","ModuleScript","Orca.include.node_modules.roact.src.createSignal","Orca.include.node_modules.roact.src",function()return setfenv(function()local function pK()local sQ={}local sR={}local sS=false;local function sT(self,da)assert(typeof(da)=="function","Can only subscribe to signals with a function.")local nw={callback=da,disconnected=false}if sS and not sQ[da]then sR[da]=nw end;sQ[da]=nw;local function oq()assert(not nw.disconnected,"Listeners can only be disconnected once.")nw.disconnected=true;sQ[da]=nil;sR[da]=nil end;return oq end;local function sU(self,...)sS=true;for da,nw in pairs(sQ)do if not nw.disconnected and not sR[da]then da(...)end end;sS=false;for da,ev in pairs(sR)do sR[da]=nil end end;return{subscribe=sT,fire=sU}end;return pK end,newEnv("Orca.include.node_modules.roact.src.createSignal"))()end)newModule("createSpy","ModuleScript","Orca.include.node_modules.roact.src.createSpy","Orca.include.node_modules.roact.src",function()return setfenv(function()local r_=require(script.Parent.assertDeepEqual)local function sV(sW)local self={callCount=0,values={},valuesLength=0}self.value=function(...)self.callCount=self.callCount+1;self.values={...}self.valuesLength=select("#",...)if sW~=nil then return sW(...)end end;self.assertCalledWith=function(ev,...)local sX=select("#",...)if self.valuesLength~=sX then error(("Expected %d arguments, but was called with %d arguments"):format(self.valuesLength,sX),2)end;for jX=1,sX do local sY=select(jX,...)assert(self.values[jX]==sY,"value differs")end end;self.assertCalledWithDeepEqual=function(ev,...)local sX=select("#",...)if self.valuesLength~=sX then error(("Expected %d arguments, but was called with %d arguments"):format(self.valuesLength,sX),2)end;for jX=1,sX do local sY=select(jX,...)r_(self.values[jX],sY)end end;self.captureValues=function(ev,...)local sX=select("#",...)local dx={}assert(self.valuesLength==sX,"length of expected values differs from stored values")for jX=1,sX do local ej=select(jX,...)dx[ej]=self.values[jX]end;return dx end;setmetatable(self,{__index=function(ev,ej)error(("%q is not a valid member of spy"):format(ej))end})return self end;return sV end,newEnv("Orca.include.node_modules.roact.src.createSpy"))()end)newModule("forwardRef","ModuleScript","Orca.include.node_modules.roact.src.forwardRef","Orca.include.node_modules.roact.src",function()return setfenv(function()local pY=require(script.Parent.assign)local rb=require(script.Parent.None)local rm=require(script.Parent.PropMarkers.Ref)local pN=require(script.Parent.GlobalConfig).get()local sZ={[rm]=rb}local function s_(ij)if pN.typeChecks then assert(typeof(ij)=="function","Expected arg #1 to be a function")end;return function(kX)local db=kX[rm]local t0=pY({},kX,sZ)return ij(t0,db)end end;return s_ end,newEnv("Orca.include.node_modules.roact.src.forwardRef"))()end)newModule("getDefaultInstanceProperty","ModuleScript","Orca.include.node_modules.roact.src.getDefaultInstanceProperty","Orca.include.node_modules.roact.src",function()return setfenv(function()local pL=require(script.Parent.Symbol)local t1=pL.named("Nil")local t2={}local function rp(pn,rg)local t3=t2[pn]if t3 then local t4=t3[rg]if t4==t1 then return true,nil end;if t4~=nil then return true,t4 end else t3={}t2[pn]=t3 end;local t5=Instance.new(pn)local nq,iG=pcall(function()return t5[rg]end)t5:Destroy()if nq then if iG==nil then t3[rg]=t1 else t3[rg]=iG end end;return nq,iG end;return rp end,newEnv("Orca.include.node_modules.roact.src.getDefaultInstanceProperty"))()end)newModule("internalAssert","ModuleScript","Orca.include.node_modules.roact.src.internalAssert","Orca.include.node_modules.roact.src",function()return setfenv(function()local function q0(t6,ok)if not t6 then error(ok.." (This is probably a bug in Roact!)",3)end end;return q0 end,newEnv("Orca.include.node_modules.roact.src.internalAssert"))()end)newModule("invalidSetStateMessages","ModuleScript","Orca.include.node_modules.roact.src.invalidSetStateMessages","Orca.include.node_modules.roact.src",function()return setfenv(function()local pZ=require(script.Parent.ComponentLifecyclePhase)local p_={}p_[pZ.WillUpdate]=[[
setState cannot be used in the willUpdate lifecycle method.
Consider using the didUpdate method instead, or using getDerivedStateFromProps.

Check the definition of willUpdate in the component %q.]]p_[pZ.WillUnmount]=[[
setState cannot be used in the willUnmount lifecycle method.
A component that is being unmounted cannot be updated!

Check the definition of willUnmount in the component %q.]]p_[pZ.ShouldUpdate]=[[
setState cannot be used in the shouldUpdate lifecycle method.
shouldUpdate must be a pure function that only depends on props and state.

Check the definition of shouldUpdate in the component %q.]]p_[pZ.Render]=[[
setState cannot be used in the render method.
render must be a pure function that only depends on props and state.

Check the definition of render in the component %q.]]p_["default"]=[[
setState can not be used in the current situation, because Roact doesn't know
which part of the lifecycle this component is in.

This is a bug in Roact.
It was triggered by the component %q.
]]return p_ end,newEnv("Orca.include.node_modules.roact.src.invalidSetStateMessages"))()end)newModule("oneChild","ModuleScript","Orca.include.node_modules.roact.src.oneChild","Orca.include.node_modules.roact.src",function()return setfenv(function()local function t7(bb)if not bb then return nil end;local ej,fi=next(bb)if not fi then return nil end;local t8=next(bb,ej)if t8 then error("Expected at most child, had more than one child.",2)end;return fi end;return t7 end,newEnv("Orca.include.node_modules.roact.src.oneChild"))()end)newModule("strict","ModuleScript","Orca.include.node_modules.roact.src.strict","Orca.include.node_modules.roact.src",function()return setfenv(function()local function pG(ek,hp)hp=hp or tostring(ek)return setmetatable(ek,{__index=function(self,ej)local ok=("%q (%s) is not a valid member of %s"):format(tostring(ej),typeof(ej),hp)error(ok,2)end,__newindex=function(self,ej,d3)local ok=("%q (%s) is not a valid member of %s"):format(tostring(ej),typeof(ej),hp)error(ok,2)end})end;return pG end,newEnv("Orca.include.node_modules.roact.src.strict"))()end)newInstance("roact-hooked","Folder","Orca.include.node_modules.roact-hooked","Orca.include.node_modules")newModule("out","ModuleScript","Orca.include.node_modules.roact-hooked.out","Orca.include.node_modules.roact-hooked",function()return setfenv(function()local a=_G[script]local g={}local t9=a.import(script,script,"with-hooks")local ta=t9.withHooks;local tb=t9.withHooksPure;for av,aw in pairs(a.import(script,script,"hooks"))do g[av]=aw end;local function i(tc)return ta(tc)end;local function k_(tc)return tb(tc)end;g.hooked=i;g.pure=k_;return g end,newEnv("Orca.include.node_modules.roact-hooked.out"))()end)newModule("hooks","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks","Orca.include.node_modules.roact-hooked.out",function()return setfenv(function()local a=_G[script]local g={}g.useBinding=a.import(script,script,"use-binding").useBinding;g.useCallback=a.import(script,script,"use-callback").useCallback;g.useContext=a.import(script,script,"use-context").useContext;g.useEffect=a.import(script,script,"use-effect").useEffect;g.useMemo=a.import(script,script,"use-memo").useMemo;g.useReducer=a.import(script,script,"use-reducer").useReducer;g.useState=a.import(script,script,"use-state").useState;g.useMutable=a.import(script,script,"use-mutable").useMutable;g.useRef=a.import(script,script,"use-ref").useRef;return g end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks"))()end)newModule("use-binding","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-binding","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local cz=a.import(script,a.getModule(script,"@rbxts","roact").src).createBinding;local td=a.import(script,script.Parent.Parent,"utils","memoized-hook").memoizedHook;local function cc(bG)return td(function()local te={cz(bG)}return te end).state end;return{useBinding=cc}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-binding"))()end)newModule("use-callback","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-callback","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local l=a.import(script,script.Parent,"use-memo").useMemo;local function j(da,di)return l(function()return da end,di)end;return{useCallback=j}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-callback"))()end)newModule("use-context","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-context","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local tf=a.import(script,script.Parent.Parent,"utils","memoized-hook")local td=tf.memoizedHook;local tg=tf.resolveCurrentComponent;local k=a.import(script,script.Parent,"use-effect").useEffect;local aH=a.import(script,script.Parent,"use-state").useState;local function th(qI)return setmetatable({},{__index=qI})end;local function ee(qj)local ti=qj;local U=td(function()local od=th(tg())ti.Consumer.init(od)return od.contextEntry end)local tj=U.state;if tj then local dv=aH(tj.value)local d3=dv[1]local lY=dv[2]k(function()return tj.onUpdate:subscribe(lY)end,{})return d3 else return ti.defaultValue end end;return{useContext=ee}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-context"))()end)newModule("use-effect","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-effect","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local tk=a.import(script,script.Parent.Parent,"utils","are-deps-equal").areDepsEqual;local tf=a.import(script,script.Parent.Parent,"utils","memoized-hook")local td=tf.memoizedHook;local tg=tf.resolveCurrentComponent;local function tl(eq)local U=tg()local tm=U.effects;if tm.tail==nil then tm.tail=eq;tm.head=tm.tail else local ax=tm.tail;ax.next=eq;tm.tail=ax.next end;return eq end;local function k(da,di)local tn=td(nil)local to=tn.state;if to~=nil then to=to.deps end;local tp=to;if di and tk(di,tp)then return nil end;tn.state=tl({id=tn.id,callback=da,deps=di})end;return{useEffect=k}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-effect"))()end)newModule("use-memo","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-memo","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local tk=a.import(script,script.Parent.Parent,"utils","are-deps-equal").areDepsEqual;local td=a.import(script,script.Parent.Parent,"utils","memoized-hook").memoizedHook;local function l(tq,di)local tn=td(function()return{}end)local U=tn.state;local tr=U[1]local tp=U[2]if tr~=nil and(di and tk(di,tp))then return tr end;local ts=tq()tn.state={ts,di}return ts end;return{useMemo=l}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-memo"))()end)newModule("use-mutable","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-mutable","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local td=a.import(script,script.Parent.Parent,"utils","memoized-hook").memoizedHook;local function m(bG)return td(function()return{current=bG}end).state end;return{useMutable=m}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-mutable"))()end)newModule("use-reducer","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-reducer","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local tf=a.import(script,script.Parent.Parent,"utils","memoized-hook")local td=tf.memoizedHook;local tg=tf.resolveCurrentComponent;local function dn(dt,tt,tu)local tv=tg()local tn=td(function()local b0;if tu then b0=tu(tt)else b0=tt end;return b0 end)local function aW(aR)local tw=dt(tn.state,aR)if tn.state~=tw then tv:setHookState(tn.id,function()tn.state=tw;return tn.state end)end end;return{tn.state,aW}end;return{useReducer=dn}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-reducer"))()end)newModule("use-ref","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-ref","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local sP=a.import(script,a.getModule(script,"@rbxts","roact").src).createRef;local td=a.import(script,script.Parent.Parent,"utils","memoized-hook").memoizedHook;local function tx()return td(function()return sP()end).state end;return{useRef=tx}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-ref"))()end)newModule("use-state","ModuleScript","Orca.include.node_modules.roact-hooked.out.hooks.use-state","Orca.include.node_modules.roact-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local dn=a.import(script,script.Parent,"use-reducer").useReducer;local function aH(dB)local U=dn(function(F,aR)local b0;if type(aR)=="function"then b0=aR(F)else b0=aR end;return b0 end,nil,function()local b0;if type(dB)=="function"then b0=dB()else b0=dB end;return b0 end)local F=U[1]local aW=U[2]return{F,aW}end;return{useState=aH}end,newEnv("Orca.include.node_modules.roact-hooked.out.hooks.use-state"))()end)newModule("types","ModuleScript","Orca.include.node_modules.roact-hooked.out.types","Orca.include.node_modules.roact-hooked.out",function()return setfenv(function()return nil end,newEnv("Orca.include.node_modules.roact-hooked.out.types"))()end)newInstance("utils","Folder","Orca.include.node_modules.roact-hooked.out.utils","Orca.include.node_modules.roact-hooked.out")newModule("are-deps-equal","ModuleScript","Orca.include.node_modules.roact-hooked.out.utils.are-deps-equal","Orca.include.node_modules.roact-hooked.out.utils",function()return setfenv(function()local function tk(ty,tp)if tp==nil then return false end;if#ty~=#tp then return false end;do local jX=0;local hS=false;while true do if hS then jX=jX+1 else hS=true end;if not(jX<#ty)then break end;if ty[jX+1]==tp[jX+1]then continue;end;return false end end;return true end;return{areDepsEqual=tk}end,newEnv("Orca.include.node_modules.roact-hooked.out.utils.are-deps-equal"))()end)newModule("memoized-hook","ModuleScript","Orca.include.node_modules.roact-hooked.out.utils.memoized-hook","Orca.include.node_modules.roact-hooked.out.utils",function()return setfenv(function()local tz=table.concat({"Invalid hook call. Hooks can only be called inside of the body of a function component.","This is usually the result of conflicting versions of roact-hooked.","See https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem."},"\n")local tA="Failed to render hook! (Another hooked component is rendering)"local tB="Failed to render hook! (Another hooked component rendered during this one)"local tC;local tD;local function tE(qI)local y=tD==nil;assert(y,tA)tD=qI end;local function tF(qI)local y=tD==qI;assert(y,tB)tD=nil;tC=nil end;local function tg()return tD or error(tz,3)end;local function td(bG)local tD=tg()local b0;if tC then b0=tC.next else b0=tD.firstHook end;local tG=b0;if tG then tC=tG else local b1;if type(bG)=="function"then b1=bG()else b1=bG end;local F=b1;local tH={id=tC and tC.id+1 or 0,state=F,baseState=F}if not tC then tC=tH;tD.firstHook=tC else tC.next=tH;tC=tC.next end end;return tC end;return{renderReady=tE,renderDone=tF,resolveCurrentComponent=tg,memoizedHook=td}end,newEnv("Orca.include.node_modules.roact-hooked.out.utils.memoized-hook"))()end)newModule("with-hooks","ModuleScript","Orca.include.node_modules.roact-hooked.out.with-hooks","Orca.include.node_modules.roact-hooked.out",function()return setfenv(function()local a=_G[script]local g={}local t9=a.import(script,script,"with-hooks")g.withHooks=t9.withHooks;g.withHooksPure=t9.withHooksPure;return g end,newEnv("Orca.include.node_modules.roact-hooked.out.with-hooks"))()end)newModule("component-with-hooks","ModuleScript","Orca.include.node_modules.roact-hooked.out.with-hooks.component-with-hooks","Orca.include.node_modules.roact-hooked.out.with-hooks",function()return setfenv(function()local a=_G[script]local tf=a.import(script,script.Parent.Parent,"utils","memoized-hook")local tF=tf.renderDone;local tE=tf.renderReady;local tI;do tI={}function tI:constructor()end;function tI:init()self.effects={}self.effectHandles={}end;function tI:setHookState(d1,dt)self:setState(function(F)return{[d1]=dt(F[d1])}end)end;function tI:render()tE(self)local tJ=self.functionComponent;local tK=self.props;local tL,tM=pcall(tJ,tK)local dx=tL and{success=true,value=tM}or{success=false,error=tM}tF(self)if not dx.success then error("(ComponentWithHooks) "..dx.error)end;return dx.value end;function tI:didMount()self:flushEffects()end;function tI:didUpdate()self:flushEffects()end;function tI:willUnmount()self:unmountEffects()self.effects.head=nil end;function tI:flushEffectsHelper(eq)if not eq then return nil end;local tN=self.effectHandles;local tO=eq.id;local b0=tN[tO]if b0~=nil then b0()end;local ao=eq.callback()if ao then local tP=self.effectHandles;local tQ=eq.id;tP[tQ]=ao end;self:flushEffectsHelper(eq.next)end;function tI:flushEffects()self:flushEffectsHelper(self.effects.head)self.effects.head=nil;self.effects.tail=nil end;function tI:unmountEffects()local tN=self.effectHandles;local y=function(ao)return ao()end;for av,aw in pairs(tN)do y(aw,av,tN)end;table.clear(self.effectHandles)end end;return{ComponentWithHooks=tI}end,newEnv("Orca.include.node_modules.roact-hooked.out.with-hooks.component-with-hooks"))()end)newModule("with-hooks","ModuleScript","Orca.include.node_modules.roact-hooked.out.with-hooks.with-hooks","Orca.include.node_modules.roact-hooked.out.with-hooks",function()return setfenv(function()local a=_G[script]local tI=a.import(script,script.Parent,"component-with-hooks").ComponentWithHooks;local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local function tR(tS)for gR,bM in pairs(tI)do tS[gR]=bM end end;local function ta(tc)local tT;do tT=b.Component:extend("ComponentClass")function tT:init()end;tT.functionComponent=tc end;tR(tT)return tT end;local function tb(tc)local tT;do tT=b.PureComponent:extend("ComponentClass")function tT:init()end;tT.functionComponent=tc end;tR(tT)return tT end;return{withHooks=ta,withHooksPure=tb}end,newEnv("Orca.include.node_modules.roact-hooked.out.with-hooks.with-hooks"))()end)newInstance("roact-rodux-hooked","Folder","Orca.include.node_modules.roact-rodux-hooked","Orca.include.node_modules")newModule("out","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out","Orca.include.node_modules.roact-rodux-hooked",function()return setfenv(function()local a=_G[script]local g={}g.Provider=a.import(script,script,"components","provider").Provider;g.useDispatch=a.import(script,script,"hooks","use-dispatch").useDispatch;g.useSelector=a.import(script,script,"hooks","use-selector").useSelector;g.useStore=a.import(script,script,"hooks","use-store").useStore;g.shallowEqual=a.import(script,script,"helpers","shallow-equal").shallowEqual;g.RoactRoduxContext=a.import(script,script,"components","context").RoactRoduxContext;return g end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out"))()end)newInstance("components","Folder","Orca.include.node_modules.roact-rodux-hooked.out.components","Orca.include.node_modules.roact-rodux-hooked.out")newModule("context","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.components.context","Orca.include.node_modules.roact-rodux-hooked.out.components",function()return setfenv(function()local a=_G[script]local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local tU=b.createContext(nil)return{RoactRoduxContext=tU}end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.components.context"))()end)newModule("provider","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.components.provider","Orca.include.node_modules.roact-rodux-hooked.out.components",function()return setfenv(function()local a=_G[script]local tU=a.import(script,script.Parent,"context").RoactRoduxContext;local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local i=h.hooked;local l=h.useMemo;local b=a.import(script,a.getModule(script,"@rbxts","roact").src)local ah=i(function(C)local eu=C.store;local bb=C[b.Children]local tV=l(function()return{store=eu}end,{eu})local tW={value=tV}local tX={}local bf=#tX;if bb then for av,aw in pairs(bb)do if type(av)=="number"then tX[bf+av]=aw else tX[av]=aw end end end;return b.createElement(tU.Provider,tW,tX)end)return{Provider=ah}end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.components.provider"))()end)newInstance("helpers","Folder","Orca.include.node_modules.roact-rodux-hooked.out.helpers","Orca.include.node_modules.roact-rodux-hooked.out")newModule("shallow-equal","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.helpers.shallow-equal","Orca.include.node_modules.roact-rodux-hooked.out.helpers",function()return setfenv(function()local a=_G[script]local ps=a.import(script,a.getModule(script,"@rbxts","object-utils"))local function hu(tY,tZ)if tY==tZ then return true end;if not(type(tY)=="table")or not(type(tZ)=="table")then return false end;local t_=ps.keys(tY)local u0=ps.keys(tZ)if#t_~=#u0 then return false end;local y=function(d3,c2)return d3==tZ[c2]end;local b0=true;for av,aw in ipairs(t_)do if not y(aw,av-1,t_)then b0=false;break end end;return b0 end;return{shallowEqual=hu}end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.helpers.shallow-equal"))()end)newInstance("hooks","Folder","Orca.include.node_modules.roact-rodux-hooked.out.hooks","Orca.include.node_modules.roact-rodux-hooked.out")newModule("use-dispatch","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.hooks.use-dispatch","Orca.include.node_modules.roact-rodux-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local m=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).useMutable;local cT=a.import(script,script.Parent,"use-store").useStore;local function cR()local eu=cT()return m(function(aR)return eu:dispatch(aR)end).current end;return{useDispatch=cR}end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.hooks.use-dispatch"))()end)newModule("use-selector","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.hooks.use-selector","Orca.include.node_modules.roact-rodux-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local h=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out)local k=h.useEffect;local m=h.useMutable;local dn=h.useReducer;local cT=a.import(script,script.Parent,"use-store").useStore;local function cS(iF,u1)if u1==nil then u1=function(hx,dG)return hx==dG end end;local U=dn(function(bd)return bd+1 end,0)local u2=U[2]local eu=cT()local u3=m()local u4=m()local u5=m()local u6=m()local u7=eu:getState()local u8;a.try(function()local u9=iF~=u4.current or u7~=u5.current or u3.current;if u9~=""and u9 then local ua=iF(u7)if u6.current==nil or not u1(ua,u6.current)then u8=ua else u8=u6.current end else u8=u6.current end end,function(dw)if u3.current~=nil then dw=dw.."\nThe error may be correlated with this previous error:\n"..u3.current.."\n\n"end;error(dw)end)k(function()u4.current=iF;u5.current=u7;u6.current=u8;u3.current=nil end)k(function()local function ub(uc)local iH,iI=a.try(function()if uc==u5.current then return a.TRY_RETURN,{}end;local ua=u4.current(uc)if u1(ua,u6.current)then return a.TRY_RETURN,{}end;u6.current=ua;u5.current=uc end,function(dw)u3.current=dw end)if iH then return unpack(iI)end;task.spawn(u2)end;local ud=eu.changed:connect(ub)ub(eu:getState())return function()return ud:disconnect()end end,{eu})return u8 end;return{useSelector=cS}end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.hooks.use-selector"))()end)newModule("use-store","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.hooks.use-store","Orca.include.node_modules.roact-rodux-hooked.out.hooks",function()return setfenv(function()local a=_G[script]local tU=a.import(script,script.Parent.Parent,"components","context").RoactRoduxContext;local ee=a.import(script,a.getModule(script,"@rbxts","roact-hooked").out).useContext;local function cT()return ee(tU).store end;return{useStore=cT}end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.hooks.use-store"))()end)newModule("types","ModuleScript","Orca.include.node_modules.roact-rodux-hooked.out.types","Orca.include.node_modules.roact-rodux-hooked.out",function()return setfenv(function()return nil end,newEnv("Orca.include.node_modules.roact-rodux-hooked.out.types"))()end)newInstance("rodux","Folder","Orca.include.node_modules.rodux","Orca.include.node_modules")newModule("src","ModuleScript","Orca.include.node_modules.rodux.src","Orca.include.node_modules.rodux",function()return setfenv(function()local ue=require(script.Store)local uf=require(script.createReducer)local ug=require(script.combineReducers)local uh=require(script.makeActionCreator)local ui=require(script.loggerMiddleware)local uj=require(script.thunkMiddleware)return{Store=ue,createReducer=uf,combineReducers=ug,makeActionCreator=uh,loggerMiddleware=ui.middleware,thunkMiddleware=uj}end,newEnv("Orca.include.node_modules.rodux.src"))()end)newModule("NoYield","ModuleScript","Orca.include.node_modules.rodux.src.NoYield","Orca.include.node_modules.rodux.src",function()return setfenv(function()local function uk(oT,nq,...)if not nq then local ok=...error(debug.traceback(oT,ok),2)end;if coroutine.status(oT)~="dead"then error(debug.traceback(oT,"Attempted to yield inside changed event!"),2)end;return...end;local function ul(da,...)local oT=coroutine.create(da)return uk(oT,coroutine.resume(oT,...))end;return ul end,newEnv("Orca.include.node_modules.rodux.src.NoYield"))()end)newModule("Signal","ModuleScript","Orca.include.node_modules.rodux.src.Signal","Orca.include.node_modules.rodux.src",function()return setfenv(function()local function um(nJ,...)local un={}local sX=#nJ;for ej=1,sX do un[ej]=nJ[ej]end;for jX=1,select("#",...)do un[sX+jX]=select(jX,...)end;return un end;local function uo(nJ,up)local un={}for jX=1,#nJ do if nJ[jX]~=up then table.insert(un,nJ[jX])end end;return un end;local oV={}oV.__index=oV;function oV.new(eu)local self={_listeners={},_store=eu}setmetatable(self,oV)return self end;function oV:connect(da)if typeof(da)~="function"then error("Expected the listener to be a function.")end;if self._store and self._store._isDispatching then error('You may not call store.changed:connect() while the reducer is executing. '..'If you would like to be notified after the store has been updated, subscribe from a '..'component and invoke store:getState() in the callback to access the latest state. ')end;local rP={callback=da,disconnected=false,connectTraceback=debug.traceback(),disconnectTraceback=nil}self._listeners=um(self._listeners,rP)local function oq()if rP.disconnected then error(("Listener connected at: \n%s\n".."was already disconnected at: \n%s\n"):format(tostring(rP.connectTraceback),tostring(rP.disconnectTraceback)))end;if self._store and self._store._isDispatching then error("You may not unsubscribe from a store listener while the reducer is executing.")end;rP.disconnected=true;rP.disconnectTraceback=debug.traceback()self._listeners=uo(self._listeners,rP)end;return{disconnect=oq}end;function oV:fire(...)for ev,rP in ipairs(self._listeners)do if not rP.disconnected then rP.callback(...)end end end;return oV end,newEnv("Orca.include.node_modules.rodux.src.Signal"))()end)newModule("Store","ModuleScript","Orca.include.node_modules.rodux.src.Store","Orca.include.node_modules.rodux.src",function()return setfenv(function()local ez=game:GetService("RunService")local oV=require(script.Parent.Signal)local ul=require(script.Parent.NoYield)local uq=3;local ur={reportReducerError=function(us,aR,ut)error(string.format("Received error: %s\n\n%s",ut.message,ut.thrownValue))end,reportUpdateError=function(us,uu,uv,ut)error(string.format("Received error: %s\n\n%s",ut.message,ut.thrownValue))end}local function uw(ok)return debug.traceback(tostring(ok))end;local ue={}ue._flushEvent=ez.Heartbeat;ue.__index=ue;function ue.new(dt,dB,ux,uy)assert(typeof(dt)=="function","Bad argument #1 to Store.new, expected function.")assert(ux==nil or typeof(ux)=="table","Bad argument #3 to Store.new, expected nil or table.")if ux~=nil then for jX=1,#ux,1 do assert(typeof(ux[jX])=="function",("Expected the middleware ('%s') at index %d to be a function."):format(tostring(ux[jX]),jX))end end;local self={}self._errorReporter=uy or ur;self._isDispatching=false;self._reducer=dt;local uz={type="@@INIT"}self._actionLog={uz}local nq,dx=xpcall(function()self._state=dt(dB,uz)end,uw)if not nq then self._errorReporter.reportReducerError(dB,uz,{message="Caught error in reducer with init",thrownValue=dx})self._state=dB end;self._lastState=self._state;self._mutatedSinceFlush=false;self._connections={}self.changed=oV.new(self)setmetatable(self,ue)local nw=self._flushEvent:Connect(function()self:flush()end)table.insert(self._connections,nw)if ux then local uA=self.dispatch;local aW=function(...)return uA(self,...)end;for jX=#ux,1,-1 do local uB=ux[jX]aW=uB(aW,self)end;self.dispatch=function(uC,...)return aW(...)end end;return self end;function ue:getState()if self._isDispatching then error(("You may not call store:getState() while the reducer is executing. ".."The reducer (%s) has already received the state as an argument. ".."Pass it down from the top reducer instead of reading it from the store."):format(tostring(self._reducer)))end;return self._state end;function ue:dispatch(aR)if typeof(aR)~="table"then error(("Actions must be tables. ".."Use custom middleware for %q actions."):format(typeof(aR)),2)end;if aR.type==nil then error("Actions may not have an undefined 'type' property. ".."Have you misspelled a constant? \n"..tostring(aR),2)end;if self._isDispatching then error("Reducers may not dispatch actions.")end;local nq,dx=pcall(function()self._isDispatching=true;self._state=self._reducer(self._state,aR)self._mutatedSinceFlush=true end)self._isDispatching=false;if not nq then self._errorReporter.reportReducerError(self._state,aR,{message="Caught error in reducer",thrownValue=dx})end;if#self._actionLog==uq then table.remove(self._actionLog,1)end;table.insert(self._actionLog,aR)end;function ue:destruct()for ev,nw in ipairs(self._connections)do nw:Disconnect()end;self._connections=nil end;function ue:flush()if not self._mutatedSinceFlush then return end;self._mutatedSinceFlush=false;local F=self._state;local nq,ut=xpcall(function()ul(function()self.changed:fire(F,self._lastState)end)end,uw)if not nq then self._errorReporter.reportUpdateError(self._lastState,F,self._actionLog,{message="Caught error flushing store updates",thrownValue=ut})end;self._lastState=F end;return ue end,newEnv("Orca.include.node_modules.rodux.src.Store"))()end)newModule("combineReducers","ModuleScript","Orca.include.node_modules.rodux.src.combineReducers","Orca.include.node_modules.rodux.src",function()return setfenv(function()local function ug(q)return function(F,aR)if F==nil then F={}end;local ex={}for ej,dt in pairs(q)do ex[ej]=dt(F[ej],aR)end;return ex end end;return ug end,newEnv("Orca.include.node_modules.rodux.src.combineReducers"))()end)newModule("createReducer","ModuleScript","Orca.include.node_modules.rodux.src.createReducer","Orca.include.node_modules.rodux.src",function()return setfenv(function()return function(dB,uD)return function(F,aR)if F==nil then F=dB end;local oY=uD[aR.type]if oY then return oY(F,aR)end;return F end end end,newEnv("Orca.include.node_modules.rodux.src.createReducer"))()end)newModule("loggerMiddleware","ModuleScript","Orca.include.node_modules.rodux.src.loggerMiddleware","Orca.include.node_modules.rodux.src",function()return setfenv(function()local uE=require(script.Parent.prettyPrint)local ui={outputFunction=print}function ui.middleware(uF,eu)return function(aR)local dx=uF(aR)ui.outputFunction(("Action dispatched: %s\nState changed to: %s"):format(uE(aR),uE(eu:getState())))return dx end end;return ui end,newEnv("Orca.include.node_modules.rodux.src.loggerMiddleware"))()end)newModule("makeActionCreator","ModuleScript","Orca.include.node_modules.rodux.src.makeActionCreator","Orca.include.node_modules.rodux.src",function()return setfenv(function()local function uh(hp,kd)assert(type(hp)=="string","Bad argument #1: Expected a string name for the action creator")assert(type(kd)=="function","Bad argument #2: Expected a function that creates action objects")return setmetatable({name=hp},{__call=function(self,...)local dx=kd(...)assert(type(dx)=="table","Invalid action: An action creator must return a table")dx.type=hp;return dx end})end;return uh end,newEnv("Orca.include.node_modules.rodux.src.makeActionCreator"))()end)newModule("prettyPrint","ModuleScript","Orca.include.node_modules.rodux.src.prettyPrint","Orca.include.node_modules.rodux.src",function()return setfenv(function()local qT="    "local function uE(d3,qV)qV=qV or 0;local uG={}if typeof(d3)=="table"then table.insert(uG,"{\n")for uH,uI in pairs(d3)do table.insert(uG,qT:rep(qV+1))table.insert(uG,tostring(uH))table.insert(uG," = ")table.insert(uG,uE(uI,qV+1))table.insert(uG,"\n")end;table.insert(uG,qT:rep(qV))table.insert(uG,"}")elseif typeof(d3)=="string"then table.insert(uG,string.format("%q",d3))table.insert(uG," (string)")else table.insert(uG,tostring(d3))table.insert(uG," (")table.insert(uG,typeof(d3))table.insert(uG,")")end;return table.concat(uG,"")end;return uE end,newEnv("Orca.include.node_modules.rodux.src.prettyPrint"))()end)newModule("thunkMiddleware","ModuleScript","Orca.include.node_modules.rodux.src.thunkMiddleware","Orca.include.node_modules.rodux.src",function()return setfenv(function()local function uw(ok)return debug.traceback(ok)end;local function uj(uF,eu)return function(aR)if typeof(aR)=="function"then local nq,dx=xpcall(function()return aR(eu)end,uw)if not nq then eu._errorReporter.reportReducerError(eu:getState(),aR,{message="Caught error in thunk",thrownValue=dx})return nil end;return dx end;return uF(aR)end end;return uj end,newEnv("Orca.include.node_modules.rodux.src.thunkMiddleware"))()end)newModule("services","ModuleScript","Orca.include.node_modules.services","Orca.include.node_modules",function()return setfenv(function()return setmetatable({},{__index=function(self,uJ)local uK=game:GetService(uJ)self[uJ]=uK;return uK end})end,newEnv("Orca.include.node_modules.services"))()end)newInstance("types","Folder","Orca.include.node_modules.types","Orca.include.node_modules")newInstance("include","Folder","Orca.include.node_modules.types.include","Orca.include.node_modules.types")newInstance("generated","Folder","Orca.include.node_modules.types.include.generated","Orca.include.node_modules.types.include")

init()